package br.ufsc.fcama.ig;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JToolBar;
import javax.swing.UIManager;
import javax.swing.border.Border;

import org.jdom.JDOMException;

import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.ig.jPanel.JPanelProjeto;
import br.ufsc.fcama.ig.jPanel.JPanelTree;
import br.ufsc.fcama.ig.wizard.WizardProjeto;
import br.ufsc.fcama.logica.Controlador;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.persistencia.PersistenciaAplicacao;
import java.awt.*;
import br.ufsc.fcama.ig.jPanel.JPanelImagem;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class FramePrincipal extends JFrame {
	
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private Controlador controlador = new Controlador();
    public PersistenciaAplicacao persistencia = new PersistenciaAplicacao();
    public FramePrincipal() {
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
            this.setAreaDeTrabalho("", new JPanelImagem("semDestaque.gif"));
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }


    public Controlador getControlador(){
          return this.controlador;
    }

    public void projetoAlterado(){
        this.jMenuItemSalvar.setEnabled(true);
        this.jButtonSalvar.setEnabled(true);
    }

   public void setProjeto(Projeto projeto){
       try {
               this.controlador.criarProjeto(projeto);
               this.jSplitPane1.remove(this.jPanelTree);
               this.setTree(projeto);

       } catch (IOException e) {
               JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.criarProjeto") ,projeto.getNomeProjeto(), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
       }
   }

   private void setTree(Projeto projeto){
       this.jPanelTree = new JPanelTree(this, projeto);
       this.jSplitPane1.setLeftComponent(this.jPanelTree);
       this.jSplitPane1.setDividerLocation(200);
       this.jMenuItemFecharProjeto.setEnabled(true);
       this.jButtonClose.setEnabled(true);
       this.jMenuItemSalvar.setEnabled(false);
       this.jButtonSalvar.setEnabled(false);
       this.jPanelTree.atual = projeto;
       this.jMenuItemAbrirProjeto.setEnabled(false);
       this.jButtonOpen.setEnabled(false);
       this.jMenuItemProjeto.setEnabled(false);
       this.jMenuItemCicloDesenvolvimento.setEnabled(true);
       this.jButtonNew.setEnabled(false);

   }
   
   public void setAreaDeTrabalho(String titulo, JPanel jPanel){
       //jPanelConteudo.add(jPanelbase, java.awt.BorderLayout.CENTER);
       jLabel1.setText(titulo);
       this.jPanelConteudo.remove(this.jPanelAreaTrabalho);
       this.jPanelAreaTrabalho = jPanel;
       this.jPanelConteudo.add(this.jPanelAreaTrabalho , java.awt.BorderLayout.CENTER);
       this.jPanelConteudo.setVisible(false);
       this.jPanelConteudo.setVisible(true);


   }

   private void abrirProjeto(){
           //ao para abrir um projeto
          // abrir a janela para pesquisar o local do projeto
          JFileChooser jFileChooser = new JFileChooser();
          jFileChooser.setDialogTitle("Informe o diretrio do projeto");
          jFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
          int result = jFileChooser.showOpenDialog(this);
          if(result == JFileChooser.APPROVE_OPTION){
                  try {
                                  this.controlador.abrirProjeto(jFileChooser.getSelectedFile());
                                  this.setTree(this.controlador.getProjeto());
                                  this.jMenuItemFecharProjeto.setEnabled(true);
                                  this.jButtonClose.setEnabled(true);
                                  this.jMenuItemAbrirProjeto.setEnabled(false);
                                  this.jButtonOpen.setEnabled(false);
                                  this.jMenuItemProjeto.setEnabled(false);
                                  this.jMenuItemCicloDesenvolvimento.setEnabled(true);
                                  this.jButtonNew.setEnabled(false);
                                  this.setAreaDeTrabalho("Projeto "+ this.controlador.getProjeto().getNomeProjeto(), new JPanelProjeto(this));
                          } catch (IOException e1) {
                                  JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.abrirProjeto") ,this.rb.getString("framePrincipal.erro.msn.abrirProjeto.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
                          } catch (JDOMException e1) {
                                  JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.abrirProjeto") ,this.rb.getString("framePrincipal.erro.msn.abrirProjeto.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
                          } catch (ExceptionPraticaNaoLiberada e1) {
                                  JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.abrirProjeto"),this.rb.getString("framePrincipal.erro.msn.abrirProjeto.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
                          } catch (ExceptionInclusaoPraticaNaoPermitida e1) {
                                  JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.abrirProjeto") ,this.rb.getString("framePrincipal.erro.msn.abrirProjeto.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
                          } catch (ExceptionExclusaoPraticaNaoPermitida e1) {
                                  JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.abrirProjeto") ,this.rb.getString("framePrincipal.erro.msn.abrirProjeto.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
                          }
          }

   }

   private void salvarProjeto(){
       try {
           this.controlador.salvarProjeto();
           this.jMenuItemSalvar.setEnabled(false);
           this.jButtonSalvar.setEnabled(false);
       } catch (IOException e1) {
           JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.salvarProjeto") ,this.rb.getString("framePrincipal.erro.msn.salvarProjeto.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
       }
   }

   private void fecharProjeto(){
      if (this.jButtonSalvar.isEnabled()){
          int resposta = JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.msn.fecharProjeto") ,this.rb.getString("framePrincipal.msn.fecharProjeto.titulo"), JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE );
          if (resposta == JOptionPane.OK_OPTION){
              this.salvarProjeto();
          }else{
              this.controlador.cancelarAlteracoesProjeto();
          }
      }

      this.setTree(null);
      this.setAreaDeTrabalho("", new JPanelImagem("semDestaque.gif"));
      this.jMenuItemFecharProjeto.setEnabled(false);
      this.jButtonClose.setEnabled(false);
      this.jMenuItemAbrirProjeto.setEnabled(true);
      this.jButtonOpen.setEnabled(true);
      this.jMenuItemProjeto.setEnabled(true);
      this.jButtonNew.setEnabled(true);
      this.jMenuItemCicloDesenvolvimento.setEnabled(false);

   }

   private void addIteracao(){
	   try {
		this.controlador.novaIteracao();
		this.jSplitPane1.remove(this.jPanelTree);
		this.jPanelTree = new JPanelTree(this, this.controlador.getProjeto());
		this.jSplitPane1.setLeftComponent(this.jPanelTree);
		this.jSplitPane1.setDividerLocation(200);
		this.projetoAlterado();
	} catch (IOException e) {
		JOptionPane.showConfirmDialog(this, this.rb.getString("framePrincipal.erro.msn.novaIteracao") ,this.rb.getString("framePrincipal.erro.msn.novaIteracao.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
		e.printStackTrace();
	}
   }



    JPanel contentPane;
    BorderLayout borderLayoutFrame = new BorderLayout();
    JMenuBar jMenuBarFrame = new JMenuBar();
    JMenu jMenuArquivo = new JMenu();
    JButton jButtonNew = new JButton();
    Icon iconLogo = new ImageIcon("imagens/logo.gif");
    Icon iconSave = new ImageIcon("imagens/save.gif");
    Icon iconClose = new ImageIcon("imagens/close.gif");
    Icon iconOpen = new ImageIcon("imagens/open.gif");
    JToolBar jToolBar = new JToolBar();
    JMenu jMenuNovo = new JMenu();
    JMenuItem jMenuItemProjeto = new JMenuItem();
    JMenuItem jMenuItemAbrirProjeto = new JMenuItem();
    JMenuItem jMenuItemFecharProjeto = new JMenuItem();
    JMenuItem jMenuItemSalvar = new JMenuItem();
    //JMenuItem jMenuItemSalvarComo = new JMenuItem();
    //JMenuItem jMenuItemImportarModelo = new JMenuItem();
    //JMenuItem jMenuItemExportarModelo = new JMenuItem();
    JMenuItem jMenuItemCicloDesenvolvimento = new JMenuItem();
    JMenu jMenuProjeto = new JMenu();
    JMenuItem jMenuItemModelo = new JMenuItem();
    JPanel jPanelCentral = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JSplitPane jSplitPane1 = new JSplitPane();
    JPanel jPanelConteudo = new JPanel();
    JPanelTree jPanelTree = new JPanelTree(this, null);
    BorderLayout borderLayout2 = new BorderLayout();
    Border border1 = BorderFactory.createLineBorder(Color.white, 5);
    Border border2 = BorderFactory.createLineBorder(Color.white, 1);
    JPanel jPanelTitulo = new JPanel();
    JLabel jLabel1 = new JLabel();
    BorderLayout borderLayout3 = new BorderLayout();
    JPanel jPanelAreaTrabalho = new JPanel();
    JButton jButtonOpen = new JButton();
    JButton jButtonSalvar = new JButton();
    JButton jButtonClose = new JButton();
    FlowLayout flowLayout1 = new FlowLayout();





    JMenuItem jMenuItemFechar = new JMenuItem();
    JMenuItem jMenuItemSair = new JMenuItem();
    /**
       JMenuItem jMenuItemSair = new JMenuItem(); * C* Component initialization.
     *
     * @throws java.lang.Exception
     */
    private void jbInit() throws Exception {
        this.setSize(800,600);
        this.setIconImage(this.getToolkit().getImage("imagens/logo.gif"));
        contentPane = (JPanel) getContentPane();
        contentPane.setLayout(borderLayoutFrame);
        this.setJMenuBar(jMenuBarFrame);
        setTitle(this.rb.getString("framePrincipal.titulo"));
        this.addWindowListener(new FramePrincipal_this_windowAdapter(this));
        jMenuArquivo.setText(this.rb.getString("framePrincipal.jMenu.arquivo"));
        jButtonNew.setEnabled(true);
        jButtonNew.setToolTipText(this.rb.getString("framePrincipal.jButton.novoProjeto"));
        jButtonNew.setIcon(iconLogo);
        jButtonNew.setMargin(new Insets(0, 0, 0, 0));
        jButtonNew.setText("");
        jButtonNew.addMouseListener(new FramePrincipal_jButtonNew_mouseAdapter(this));
        jToolBar.setOrientation(JToolBar.HORIZONTAL);
        jToolBar.setBackground(UIManager.getColor("control"));
        jMenuNovo.setText(this.rb.getString("framePrincipal.jMenu.novo"));
        jMenuItemProjeto.setEnabled(true);
        jMenuItemProjeto.setRequestFocusEnabled(false);
        jMenuItemProjeto.setToolTipText("");
        jMenuItemProjeto.setIcon(iconLogo);
        jMenuItemProjeto.setText(this.rb.getString("framePrincipal.jMenu.projeto"));
        jMenuItemProjeto.addActionListener(new
                FramePrincipal_jMenuItemProjeto_actionAdapter(this));
        jMenuItemAbrirProjeto.setToolTipText("");
        jMenuItemAbrirProjeto.setIcon(iconOpen);
        jMenuItemAbrirProjeto.setText(this.rb.getString("framePrincipal.jMenu.abrirProjeto"));
        jMenuItemAbrirProjeto.addActionListener(new
                FramePrincipal_jMenuItemAbrirProjeto_actionAdapter(this));
        jMenuItemFecharProjeto.setIcon(iconClose);
        jMenuItemFecharProjeto.setText(this.rb.getString("framePrincipal.jMenu.fecharProjeto"));
        jMenuItemFecharProjeto.addActionListener(new
                FramePrincipal_jMenuItemFecharProjeto_actionAdapter(this));
        this.jMenuItemFecharProjeto.setEnabled(false);
        this.jButtonClose.setEnabled(false);
        jMenuItemSalvar.setIcon(iconSave);
        jMenuItemSalvar.setText(this.rb.getString("framePrincipal.jMenu.salvar"));
        jMenuItemSalvar.addActionListener(new
                FramePrincipal_jMenuItemSalvar_actionAdapter(this));
        this.jMenuItemSalvar.setEnabled(false);
        this.jButtonSalvar.setEnabled(false);
        jMenuItemCicloDesenvolvimento.setToolTipText("");
        jMenuItemCicloDesenvolvimento.setText(this.rb.getString("framePrincipal.jMenu.novaIteracao"));
        jMenuItemCicloDesenvolvimento.addActionListener(new
                FramePrincipal_jMenuItemCicloDesenvolvimento_actionAdapter(this));
        this.jMenuItemCicloDesenvolvimento.setEnabled(false);
        jMenuProjeto.setText(this.rb.getString("framePrincipal.jMenu.projeto"));
        jMenuItemModelo.setToolTipText("");
        jMenuItemModelo.setText(this.rb.getString("framePrincipal.jMenu.modeloDeProcesso"));
        jMenuItemModelo.addActionListener(new
                FramePrincipal_jMenuItemModelo_actionAdapter(this));
        this.jMenuItemModelo.setEnabled(true);
        jPanelCentral.setMinimumSize(new Dimension(800, 600));
        jPanelCentral.setPreferredSize(new Dimension(800, 600));
        jPanelCentral.setToolTipText("");
        jPanelCentral.setLayout(borderLayout1);
        jSplitPane1.setLastDividerLocation(200);
        jSplitPane1.setLeftComponent(jPanelTree);
        jPanelConteudo.setBorder(BorderFactory.createLineBorder(Color.white, 2));
        jPanelConteudo.setLayout(borderLayout3);
        jPanelTitulo.setBackground(Color.white);
        jPanelTitulo.setPreferredSize(new Dimension(22, 20));
        jPanelTitulo.setLayout(flowLayout1);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText("   ");
        jButtonOpen.setToolTipText(this.rb.getString("framePrincipal.jButton.abrirProjeto"));
        jButtonOpen.setIcon(iconOpen);
        jButtonOpen.setText("");
        jButtonOpen.addMouseListener(new
                                     FramePrincipal_jButtonOpen_mouseAdapter(this));
        jButtonSalvar.setToolTipText(this.rb.getString("framePrincipal.jButton.salvarProjeto"));
        jButtonSalvar.setIcon(iconSave);
        jButtonSalvar.setText("");
        jButtonSalvar.addMouseListener(new
                FramePrincipal_jButtonSalvar_mouseAdapter(this));
        jButtonClose.setToolTipText(this.rb.getString("framePrincipal.jButton.fecharProjeto"));
        jButtonClose.setIcon(iconClose);
        jButtonClose.setText("");
        jButtonClose.addMouseListener(new
                                      FramePrincipal_jButtonClose_mouseAdapter(this));
        flowLayout1.setHgap(0);
        flowLayout1.setVgap(0);
        jMenuItemSair.setToolTipText("");
        jMenuItemSair.setText(this.rb.getString("framePrincipal.jMenu.sair"));
        jMenuItemSair.addActionListener(new
                FramePrincipal_jMenuItemSair_actionAdapter(this));

        jMenuBarFrame.add(jMenuArquivo);
        jMenuBarFrame.add(jMenuProjeto);
        jToolBar.add(jButtonNew);
        jToolBar.add(jButtonOpen);
        jToolBar.add(jButtonClose);
        jToolBar.add(jButtonSalvar);
        jMenuArquivo.add(jMenuNovo);
        jMenuArquivo.addSeparator();
        jMenuArquivo.add(jMenuItemAbrirProjeto);
        jMenuArquivo.add(jMenuItemFecharProjeto);
        jMenuArquivo.addSeparator();
        jMenuArquivo.add(jMenuItemSalvar);
        jMenuArquivo.addSeparator();
        jMenuArquivo.add(jMenuItemSair);
        jMenuNovo.add(jMenuItemModelo);
        jMenuNovo.add(jMenuItemProjeto);
        jMenuProjeto.add(jMenuItemCicloDesenvolvimento);
        contentPane.add(jPanelCentral, java.awt.BorderLayout.CENTER);
        jPanelCentral.add(jSplitPane1, java.awt.BorderLayout.CENTER);
        contentPane.add(jToolBar, java.awt.BorderLayout.NORTH);
        jSplitPane1.add(jPanelConteudo, JSplitPane.RIGHT);
        jPanelTitulo.add(jLabel1, null);
        jPanelConteudo.add(jPanelAreaTrabalho, java.awt.BorderLayout.CENTER);
        jPanelConteudo.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
    }

   public Point getXY(){
        return this.getLocationOnScreen();
    }

    public void jMenuItemProjeto_actionPerformed(ActionEvent e) {
        //Ao para criar um novo projeto
        new WizardProjeto(this, WizardProjeto.WIZARD_PROJETO);



    }

    public void jButtonNew_mouseClicked(MouseEvent e) {
        //Ao para criar um novo projeto
        if (this.jButtonNew.isEnabled()){
            new WizardProjeto(this, WizardProjeto.WIZARD_PROJETO);
        }
    }




    public void jMenuItemAbrirProjeto_actionPerformed(ActionEvent e) {
       this.abrirProjeto();
   }

   public void jButtonOpen_mouseClicked(MouseEvent e) {
         if (this.jButtonOpen.isEnabled()){
             this.abrirProjeto();
         }
    }

    public void jMenuItemSalvar_actionPerformed(ActionEvent e) {
      this.salvarProjeto();;
    }

    public void jButtonSalvar_mouseClicked(MouseEvent e) {
      if (this.jButtonSalvar.isEnabled()){
          this.salvarProjeto();
      }
   }

   public void jMenuItemFecharProjeto_actionPerformed(ActionEvent e) {
      this.fecharProjeto();
   }

   public void jButtonClose_mouseClicked(MouseEvent e) {
      if (this.jButtonClose.isEnabled()){
          this.fecharProjeto();
      }

  }



    public void jMenuItemCicloDesenvolvimento_actionPerformed(ActionEvent e) {
        this.addIteracao();
    }

   
    public void jMenuItemModelo_actionPerformed(ActionEvent e) {
        //ao para criar um modelo
    	new WizardProjeto(this,WizardProjeto.WIZARD_MODELO);
    }

    public void this_windowClosing(WindowEvent e) {
        if (this.jButtonClose.isEnabled()){
            this.fecharProjeto();
        }
    }

    public void jMenuItemSair_actionPerformed(ActionEvent e) {
    	this.fecharProjeto();
    	System.exit(0);
    }


}


class FramePrincipal_jMenuItemSair_actionAdapter implements ActionListener {
    private FramePrincipal adaptee;
    FramePrincipal_jMenuItemSair_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItemSair_actionPerformed(e);
    }
}


class FramePrincipal_this_windowAdapter extends WindowAdapter {
    private FramePrincipal adaptee;
    FramePrincipal_this_windowAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void windowClosing(WindowEvent e) {
        adaptee.this_windowClosing(e);
    }
}


class FramePrincipal_jButtonSalvar_mouseAdapter extends MouseAdapter {
    private FramePrincipal adaptee;
    FramePrincipal_jButtonSalvar_mouseAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jButtonSalvar_mouseClicked(e);
    }
}


class FramePrincipal_jButtonClose_mouseAdapter extends MouseAdapter {
    private FramePrincipal adaptee;
    FramePrincipal_jButtonClose_mouseAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jButtonClose_mouseClicked(e);
    }
}


class FramePrincipal_jButtonOpen_mouseAdapter extends MouseAdapter {
    private FramePrincipal adaptee;
    FramePrincipal_jButtonOpen_mouseAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jButtonOpen_mouseClicked(e);
    }
}


class FramePrincipal_jButtonNew_mouseAdapter extends MouseAdapter {
    private FramePrincipal adaptee;
    FramePrincipal_jButtonNew_mouseAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jButtonNew_mouseClicked(e);
    }
}


class FramePrincipal_jMenuItemModelo_actionAdapter implements ActionListener {
    private FramePrincipal adaptee;
    FramePrincipal_jMenuItemModelo_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItemModelo_actionPerformed(e);
    }
}




class FramePrincipal_jMenuItemSalvar_actionAdapter implements ActionListener {
    private FramePrincipal adaptee;
    FramePrincipal_jMenuItemSalvar_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItemSalvar_actionPerformed(e);
    }
}


class FramePrincipal_jMenuItemCicloDesenvolvimento_actionAdapter implements
        ActionListener {
    private FramePrincipal adaptee;
    FramePrincipal_jMenuItemCicloDesenvolvimento_actionAdapter(FramePrincipal
            adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItemCicloDesenvolvimento_actionPerformed(e);
    }
}


class FramePrincipal_jMenuItemAbrirProjeto_actionAdapter implements
        ActionListener {
    private FramePrincipal adaptee;
    FramePrincipal_jMenuItemAbrirProjeto_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItemAbrirProjeto_actionPerformed(e);
    }
}


class FramePrincipal_jMenuItemFecharProjeto_actionAdapter implements
        ActionListener {
    private FramePrincipal adaptee;
    FramePrincipal_jMenuItemFecharProjeto_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItemFecharProjeto_actionPerformed(e);
    }
}


class FramePrincipal_jMenuItemProjeto_actionAdapter implements ActionListener {
    private FramePrincipal adaptee;
    FramePrincipal_jMenuItemProjeto_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItemProjeto_actionPerformed(e);
    }
}
