package br.ufsc.fcama.ig;

import java.text.SimpleDateFormat;
import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

import br.ufsc.fcama.logica.objAux.Anexo;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class TableModelAnexo extends AbstractTableModel {

    private ArrayList anexos;
    private SimpleDateFormat format; 

    public TableModelAnexo(ArrayList anexos) {
       this.anexos = anexos;
       this.format = new SimpleDateFormat("dd/MM/yyyy  'as'  H:mm" );
    }

    /**
     * Returns the number of columns in the model.
     *
     * @return the number of columns in the model
     * @todo Implement this javax.swing.table.TableModel method
     */
    public int getColumnCount() {
        return 2;
    }

    /**
     * Returns the number of rows in the model.
     *
     * @return the number of rows in the model
     * @todo Implement this javax.swing.table.TableModel method
     */
    public int getRowCount() {
        return this.anexos.size();
    }

    /**
     * Returns the value for the cell at <code>columnIndex</code> and <code>rowIndex</code>.
     *
     * @param rowIndex the row whose value is to be queried
     * @param columnIndex the column whose value is to be queried
     * @return the value Object at the specified cell
     * @todo Implement this javax.swing.table.TableModel method
     */
    public Object getValueAt(int rowIndex, int columnIndex) {
        switch (columnIndex){
          case 0: return   ((Anexo)this.anexos.get(rowIndex)).getNome();
          case 1: return   this.format.format(((Anexo)this.anexos.get(rowIndex)).getDtCriacao());
          case 2: return   ((Anexo)this.anexos.get(rowIndex)).getDescricao();
          case 3: return   ((Anexo)this.anexos.get(rowIndex)).getCaminho();
        }

        return null;
    }

    public String getColumnName(int c){
        switch(c){
          case 0 : return "Documento";
          case 1 : return "Data Criaao";
        }
        return "";
    }

    public void addAnexo(Anexo anexo){
    	this.anexos.add(anexo);
    }
    
    public Anexo removeAnexo(int row){
    	return (Anexo) this.anexos.remove(row);
    }
    
    public Anexo getAnexo(int row){
    	return (Anexo) this.anexos.get(row);
    }


}
