package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.border.Border;

import br.ufsc.fcama.exception.ExceptionArquivoJaExiste;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.tableModel.TableModelAnexo;
import br.ufsc.fcama.logica.objAux.Anexo;
import br.ufsc.fcama.logica.pratica.Pratica;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelAnexos extends JPanel {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
	private FramePrincipal frame;
	private Object[] objetos;
	private Pratica atividade;
	private SimpleDateFormat format;
	private Anexo anexo;
	private File fileOrigem;

    public JPanelAnexos(FramePrincipal frame, Object[] objetos) {
        try {
        	this.frame = frame;
                this.objetos = objetos;
        	this.atividade = (Pratica) this.objetos[(this.objetos.length - 1)];
        	this.tableModelAnexo = new TableModelAnexo(new ArrayList(this.atividade.getAnexos()));
        	this.jTableAnexo = new JTable(this.tableModelAnexo);
            jbInit();
            this.format = new SimpleDateFormat("dd/MM/yyyy 'as' H:mm" );

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    
    public void jButtonExcluir_actionPerformed(ActionEvent e) {
        if (this.jTableAnexo.getSelectedRow() != -1){
    		this.frame.getControlador().excluirAnexo(this.tableModelAnexo.getAnexo(this.jTableAnexo.getSelectedRow()), this.atividade);
    		this.frame.projetoAlterado();
    		this.tableModelAnexo.removeAnexo(this.jTableAnexo.getSelectedRow());
    		this.jTableAnexo.clearSelection();
    		this.jTableAnexo.addNotify();
    		this.jTextAreaDescricao.setText("");
    	}else{
  		  JOptionPane.showConfirmDialog(this.frame,this.rb.getString("jPanelAnexos.erro.msn.excluirAnexo") ,this.rb.getString("jPanelAnexos.msn.excluirAnexo.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
		}
    }

    public void jButtonEditar_actionPerformed(ActionEvent e) {
        if (this.jTableAnexo.getSelectedRow() != -1){
  		  this.anexo = this.tableModelAnexo.getAnexo(this.jTableAnexo.getSelectedRow());
  		  this.jTextFieldDocumento.setText(this.anexo.getNome());
  		  this.jTextArea2Descricao.setText(this.anexo.getDescricao());
  		  this.jTextFieldDataCriacao.setText(this.format.format(this.anexo.getDtCriacao()));
  		  this.jButtonAnexar.setEnabled(false);
                this.jButtonAnexar.setVisible(true);
  		  this.jButtonCriar.setEnabled(false);
                this.jTextFieldDocumento.setEditable(false);
      	  this.jTextFieldDocumento.setRequestFocusEnabled(false);
                this.jComboBoxModelos.setVisible(false);
        }else{
  		  JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelAnexos.erro.msn.editarAnexo") ,this.rb.getString("jPanelAnexos.erro.msn.editarAnexo.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
  	  }
    }

    public void jButtonAbrir_actionPerformed(ActionEvent e) {
        if (this.jTableAnexo.getSelectedRow() != -1){
  		  this.visualizarAnexo(this.tableModelAnexo.getAnexo(this.jTableAnexo.getSelectedRow()));
		  }else{
  		  JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelAnexos.erro.msn.abrirAnexo") ,this.rb.getString("jPanelAnexos.erro.msn.abrirAnexo.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
  	  }
    }

    public void jButtonAnexar_actionPerformed(ActionEvent e) {
	  JFileChooser jFileChooser = new JFileChooser();
	  jFileChooser.setDialogTitle(this.rb.getString("jPanelAnexos.msn.anexar.titulo"));
	  if(jFileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION){
		  this.fileOrigem = jFileChooser.getSelectedFile();
		  this.jTextFieldDocumento.setText(this.fileOrigem.getName());
		  this.jButtonCriar.setEnabled(false);
		  this.jTextFieldDataCriacao.setText(this.format.format(new Date()));
	  }
  	  
    }

    public void jButtonCriar_actionPerformed(ActionEvent e) {
        this.setModelosCombo();
    	this.jTextFieldDocumento.setEditable(true);
    	this.jTextFieldDocumento.setRequestFocusEnabled(true);
    	this.jButtonAnexar.setEnabled(false);
        this.jComboBoxModelos.setVisible(true);
        this.jButtonAnexar.setVisible(false);
        this.jTextFieldDataCriacao.setText(this.format.format(new Date()));
    }

    public void jButtonSalvar_actionPerformed(ActionEvent e) {
        //para salvar um anexo
  	  if (this.jTextFieldDocumento.getText().trim().equals("")){
  		  JOptionPane.showConfirmDialog(this.frame,this.rb.getString("jPanelAnexos.erro.msn.salvar.documento") ,this.rb.getString("jPanelAnexos.erro.msn.salvar.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
  	  }else if (this.jTextArea2Descricao.getText().trim().equals("")){
  		  JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelAnexos.erro.msn.salvar.descricao") ,this.rb.getString("jPanelAnexos.erro.msn.salvar.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
  	  }else {// se os dados esto ok salva
  		  //se o anexo no for null  pq o anexo est sendo editado ento  s setar o campo descrio
  		  if (!this.jButtonAnexar.isEnabled() && !this.jButtonCriar.isEnabled() ){
  			  this.anexo.setDescricao(this.jTextArea2Descricao.getText().trim());
  			  this.frame.projetoAlterado();
  			  this.jTextAreaDescricao.setText("");
  			  this.jTableAnexo.clearSelection();
  			  this.jTableAnexo.addNotify();
  			  this.limparCampos();
  		  }else{
  			  //se o boto anexar est liberado ento tem que copiar o anexo
  			  if (this.jButtonAnexar.isEnabled()){
  				  this.anexarAnexo();
  			  }else{
  				  this.criarAnexo();
  			  }
  		  }
  	  }
    }

    public void jButtonCancelar_actionPerformed(ActionEvent e) {
        //para cancelar o cadastro de um anexo
   	 	this.limparCampos();
   	 	this.anexo = null;
    }
    
    public void jTableAnexo_mouseClicked(MouseEvent e) {
        //para quando o celula da tabela  selecionada
     	this.jTextAreaDescricao.setText((String)this.tableModelAnexo.getValueAt(this.jTableAnexo.getSelectedRow(), 2));
    }
    
    private void setModelosCombo(){
    	  String[] modelos = this.frame.persistencia.getModelos();
    	  for (int i = 0; i < modelos.length; i++){
    		  this.jComboBoxModelos.addItem(modelos[i]);
    	  }
      }

    private void criarAnexo(){
    	  String modelo = (String)this.jComboBoxModelos.getSelectedItem();
    	  this.anexo = new Anexo();
    	  this.anexo.setNome(this.jTextFieldDocumento.getText().trim());
    	  this.anexo.setNome(this.anexo.getNome()+ "." + modelo.substring((modelo.lastIndexOf(".")+ 1) , modelo.length()));
    	  this.anexo.setDescricao(this.jTextArea2Descricao.getText().trim());
    	  this.anexo.setDtCriacao(new Date());
    	  try {
			this.frame.getControlador().criarArquivo(this.frame.persistencia.getModelo(modelo),this.objetos, anexo);
			this.atividade.addAnexo(this.anexo);
			this.tableModelAnexo.addAnexo(this.anexo);
			this.jTableAnexo.addNotify();
			this.frame.projetoAlterado();
			this.limparCampos();
			this.visualizarAnexo(this.anexo);
			this.anexo = null;
			this.frame.projetoAlterado();
		} catch (IOException e) {
			JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelAnexos.erro.msn.salvar.anexoNaoIncluido") ,this.rb.getString("jPanelAnexos.erro.msn.salvar.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
		} catch (ExceptionArquivoJaExiste e) {
			JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelAnexos.erro.msn.salvar.anexoJaExiste") ,this.rb.getString("jPanelAnexos.erro.msn.salvar.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
		}

      }
    private void anexarAnexo(){
    	  this.anexo = new Anexo();
    	  this.anexo.setNome(this.jTextFieldDocumento.getText().trim());
    	  this.anexo.setDescricao(this.jTextArea2Descricao.getText().trim());
    	  this.anexo.setDtCriacao(new Date());
    	  try {
			this.frame.getControlador().copiarArquivo(this.fileOrigem,this.objetos, anexo);
			this.atividade.addAnexo(this.anexo);
			this.tableModelAnexo.addAnexo(this.anexo);
			this.jTableAnexo.addNotify();
			this.frame.projetoAlterado();
			this.limparCampos();
			this.anexo = null;
			this.fileOrigem = null;
		} catch (IOException e) {
			JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelAnexos.erro.msn.salvar.naoIncluido") ,this.rb.getString("jPanelAnexos.erro.msn.salvar.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
		}

      }

    private void visualizarAnexo(Anexo anexo){
    	  try {
  			this.frame.getControlador().visualizarAnexo(anexo);
  		} catch (IOException e) {
  			JOptionPane.showConfirmDialog(this.frame,this.rb.getString("jPanelAnexos.erro.msn.visualizar") ,this.rb.getString("jPanelAnexos.erro.msn.visualizar.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
  		}
      }

    private void limparCampos(){
    	 this.jTextFieldDocumento.setText("");
     	 this.jTextFieldDocumento.setEditable(false);
     	 this.jTextFieldDocumento.setRequestFocusEnabled(false);
     	 this.jButtonAnexar.setEnabled(true);
         this.jButtonAnexar.setVisible(true);
     	 this.jButtonCriar.setEnabled(true);
         this.jComboBoxModelos.setVisible(false);
     	 this.jTextArea2Descricao.setText("");
     	 this.jTextFieldDataCriacao.setText("");
      }

     
      






    private void jbInit() throws Exception {
        this.jComboBoxModelos.setVisible(false);
        this.jTableAnexo.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        this.setLayout(borderLayout1);
        this.setBorder(border9);
        this.setPreferredSize(new Dimension(700, 600));
        this.setToolTipText("");
        jPanel2.setLayout(borderLayout3);
        jPanel2.setBackground(SystemColor.control);
        jPanel2.setBorder(null);

        jPanel3.setBackground(SystemColor.control);
        jPanel3.setBorder(null);
        jPanel3.setBorder(null);
        jPanel3.setLayout(borderLayout2);
        jPanel1.setLayout(gridLayout1);
        jPanel1.setMinimumSize(new Dimension(10, 10));
        jPanel4.setBackground(SystemColor.control);
        jPanel4.setBorder(null);
        jPanel4.setLayout(borderLayout4);
        jLabelCadastrado.setFont(new java.awt.Font("Arial Black", Font.PLAIN,
                11));
        jLabelCadastrado.setToolTipText("");
        jLabelCadastrado.setText(this.rb.getString("jPanelAnexos.jLabel.anexos"));
        jPanel5.setBorder(null);
        jPanel5.setLayout(gridLayout2);
        jPanel6.setLayout(borderLayout5);
        jPanel6.setBorder(null);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 11));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("jPanelAnexos.jLabel.cadastroAnexos"));
        jPanel7.setLayout(borderLayout6);
        jPanel7.setBackground(Color.white);
        jPanel7.setBorder(border7);
        jPanel8.setLayout(borderLayout7);
        jPanel8.setBackground(Color.white);
        jPanel8.setBorder(border11);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(2);
        gridLayout2.setColumns(1);
        gridLayout2.setRows(2);
        jPanel10.setLayout(gridBagLayout1);
        jPanel11.setBackground(UIManager.getColor("control"));
        jPanel11.setLayout(gridBagLayout2);
        jPanel10.setBackground(UIManager.getColor("control"));
        jButtonExcluir.setText(this.rb.getString("jPanelAnexos.jButton.excluir"));
        jButtonExcluir.addActionListener(new
                JPanelBase_jButtonExcluir_actionAdapter(this));
        jButtonEditar.setText(this.rb.getString("jPanelAnexos.jButton.editar"));
        jButtonEditar.addActionListener(new
                                        JPanelBase_jButtonEditar_actionAdapter(this));
        jButtonAbrir.setText(this.rb.getString("jPanelAnexos.jButton.abrir"));
        jButtonAbrir.addActionListener(new
                                       JPanelBase_jButtonAbrir_actionAdapter(this));
        jPanel12.setLayout(flowLayout1);
        flowLayout1.setAlignment(FlowLayout.RIGHT);
        jLabel2.setToolTipText("");
        jLabel2.setText(this.rb.getString("jPanelAnexos.jButton.descricao"));
        jTextAreaDescricao.setRequestFocusEnabled(false);
        jTextAreaDescricao.setEditable(false);
        jTextAreaDescricao.setText("");
        jTextAreaDescricao.setLineWrap(true);
        jPanel9.setBackground(SystemColor.control);
        jPanel9.setLayout(gridBagLayout3);
        jLabelDocumento.setText(this.rb.getString("jPanelAnexos.jLabel.documento"));
        jTextFieldDocumento.setPreferredSize(new Dimension(200, 20));
        jTextFieldDocumento.setRequestFocusEnabled(false);
        jTextFieldDocumento.setEditable(false);
        jButtonAnexar.setText(this.rb.getString("jPanelAnexos.jButton.anexar"));
        jButtonAnexar.addActionListener(new
                                        JPanelBase_jButtonAnexar_actionAdapter(this));
        jButtonCriar.setText(this.rb.getString("jPanelAnexos.jButton.criar"));
        jButtonCriar.addActionListener(new
                                       JPanelBase_jButtonCriar_actionAdapter(this));
        jLabel2Descricao.setText(this.rb.getString("jPanelAnexos.jLabel.descricao"));
        jTextArea2Descricao.setText("");
        jTextArea2Descricao.setLineWrap(true);
        jLabelDataCriacao.setToolTipText("");
        jLabelDataCriacao.setText(this.rb.getString("jPanelAnexos.jLabel.dtCriacao"));
        jButtonSalvar.setText(this.rb.getString("jPanelAnexos.jButton.salvar"));
        jButtonSalvar.addActionListener(new
                                        JPanelBase_jButtonSalvar_actionAdapter(this));
        jButtonCancelar.setText(this.rb.getString("jPanelAnexos.jButton.cancelar"));
        jButtonCancelar.addActionListener(new
                JPanelBase_jButtonCancelar_actionAdapter(this));
        jPanel13.setLayout(flowLayout2);
        flowLayout2.setAlignment(FlowLayout.LEFT);
        jPanel14.setLayout(flowLayout3);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        jTextFieldDataCriacao.setPreferredSize(new Dimension(116, 20));
        jTextFieldDataCriacao.setToolTipText("");
        jTextFieldDataCriacao.setEditable(false);
        jTextFieldDataCriacao.setText("");
        jPanel15.setLayout(flowLayout4);
        flowLayout4.setAlignment(FlowLayout.RIGHT);
        flowLayout4.setHgap(0);
        flowLayout4.setVgap(0);
        jTableAnexo.addMouseListener(new JPanelBase_jTableAnexo_mouseAdapter(this));
        jComboBoxModelos.setPreferredSize(new Dimension(200, 20));
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel3.add(jPanel4, java.awt.BorderLayout.NORTH);
        jPanel2.add(jPanel6, java.awt.BorderLayout.NORTH);
        jPanel6.add(jPanel8, java.awt.BorderLayout.SOUTH);
        jPanel4.add(jLabelCadastrado, java.awt.BorderLayout.CENTER);
        jPanel4.add(jPanel7, java.awt.BorderLayout.SOUTH);
        jPanel1.add(jPanel3, null);
        jPanel1.add(jPanel2, null);
        jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);
        jPanel5.add(jPanel10);
        jPanel5.add(jPanel11);
        jScrollPane1.getViewport().add(jTableAnexo);
        jPanel10.add(jScrollPane1, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(4, 50, 4, 50), 48, -294));
        jPanel12.add(jButtonExcluir);
        jPanel12.add(jButtonEditar);
        jPanel12.add(jButtonAbrir);
        jScrollPane2.getViewport().add(jTextAreaDescricao);
        jPanel11.add(jScrollPane2, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 48, 0, 49), 0, 39));
        jPanel11.add(jLabel2, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(4, 48, 0, 49), 448, 0));
        jPanel11.add(jPanel12, new GridBagConstraints(0, 2, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 48, 2, 49), 299, 0));
        jPanel6.add(jLabel1, java.awt.BorderLayout.CENTER);
        jPanel2.add(jPanel9, java.awt.BorderLayout.CENTER);
        jPanel13.add(jTextFieldDocumento);
        jPanel13.add(jComboBoxModelos);
        jPanel13.add(jButtonAnexar);
        jPanel13.add(jButtonCriar);
        jPanel14.add(jTextFieldDataCriacao);
        jPanel15.add(jButtonSalvar);
        jPanel15.add(jButtonCancelar);
        jScrollPane3.getViewport().add(jTextArea2Descricao);
        jPanel9.add(jScrollPane3, new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 49, 0, 49), 0, 37));
        jPanel9.add(jLabel2Descricao,
                    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 49, 0, 49), 448, 0));
        jPanel9.add(jLabelDataCriacao,
                    new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 49, 0, 49), 435, 0));
        jPanel9.add(jPanel14, new GridBagConstraints(0, 5, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 49, 0, 49), 374, 2));
        jPanel9.add(jPanel15, new GridBagConstraints(0, 6, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 49, 11, 49), 347, -2));
        jPanel9.add(jPanel13, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 49, 0, 49), 119, 0));
        jPanel9.add(jLabelDocumento,
                    new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.NONE,
                                           new Insets(22, 49, 0, 49), 443, -1));
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    JLabel jLabelCadastrado = new JLabel();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    Border border2 = BorderFactory.createLineBorder(Color.white, 2);
    Border border3 = BorderFactory.createLineBorder(Color.white, 2);
    Border border4 = BorderFactory.createLineBorder(Color.white, 2);
    Border border5 = BorderFactory.createLineBorder(Color.white, 2);
    BorderLayout borderLayout4 = new BorderLayout();
    JPanel jPanel6 = new JPanel();
    BorderLayout borderLayout5 = new BorderLayout();
    Border border6 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel1 = new JLabel();
    JPanel jPanel7 = new JPanel();
    BorderLayout borderLayout6 = new BorderLayout();
    Border border7 = BorderFactory.createLineBorder(Color.white, 1);
    JPanel jPanel8 = new JPanel();
    BorderLayout borderLayout7 = new BorderLayout();
    Border border8 = BorderFactory.createLineBorder(Color.white, 2);
    Border border9 = BorderFactory.createLineBorder(Color.white, 1);
    Border border10 = BorderFactory.createLineBorder(Color.white, 2);
    Border border11 = BorderFactory.createLineBorder(Color.white, 1);
    JPanel jPanel9 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    GridLayout gridLayout2 = new GridLayout();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    JScrollPane jScrollPane1 = new JScrollPane();
    TableModelAnexo tableModelAnexo = new TableModelAnexo(new ArrayList());
    JTable jTableAnexo = new JTable(tableModelAnexo);
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    JButton jButtonExcluir = new JButton();
    JButton jButtonEditar = new JButton();
    JButton jButtonAbrir = new JButton();
    JPanel jPanel12 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JScrollPane jScrollPane2 = new JScrollPane();
    JLabel jLabel2 = new JLabel();
    JTextArea jTextAreaDescricao = new JTextArea();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    JLabel jLabelDocumento = new JLabel();
    JTextField jTextFieldDocumento = new JTextField();
    JButton jButtonAnexar = new JButton();
    JButton jButtonCriar = new JButton();
    JLabel jLabel2Descricao = new JLabel();
    JTextArea jTextArea2Descricao = new JTextArea();
    JScrollPane jScrollPane3 = new JScrollPane();
    JLabel jLabelDataCriacao = new JLabel();
    JButton jButtonSalvar = new JButton();
    JButton jButtonCancelar = new JButton();
    JPanel jPanel13 = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();
    JPanel jPanel14 = new JPanel();
    FlowLayout flowLayout3 = new FlowLayout();
    JTextField jTextFieldDataCriacao = new JTextField();
    JPanel jPanel15 = new JPanel();
    FlowLayout flowLayout4 = new FlowLayout();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    JComboBox jComboBoxModelos = new JComboBox();
    
}





class JPanelBase_jButtonCancelar_actionAdapter implements ActionListener {
    private JPanelAnexos adaptee;
    JPanelBase_jButtonCancelar_actionAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancelar_actionPerformed(e);
    }
}


class JPanelBase_jTableAnexo_mouseAdapter extends MouseAdapter {
    private JPanelAnexos adaptee;
    JPanelBase_jTableAnexo_mouseAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableAnexo_mouseClicked(e);
    }
}





class JPanelBase_jButtonSalvar_actionAdapter implements ActionListener {
    private JPanelAnexos adaptee;
    JPanelBase_jButtonSalvar_actionAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonSalvar_actionPerformed(e);
    }
}





class JPanelBase_jButtonCriar_actionAdapter implements ActionListener {
    private JPanelAnexos adaptee;
    JPanelBase_jButtonCriar_actionAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCriar_actionPerformed(e);
    }
}





class JPanelBase_jButtonAnexar_actionAdapter implements ActionListener {
    private JPanelAnexos adaptee;
    JPanelBase_jButtonAnexar_actionAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAnexar_actionPerformed(e);
    }
}





class JPanelBase_jButtonAbrir_actionAdapter implements ActionListener {
    private JPanelAnexos adaptee;
    JPanelBase_jButtonAbrir_actionAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAbrir_actionPerformed(e);
    }
}





class JPanelBase_jButtonEditar_actionAdapter implements ActionListener {
    private JPanelAnexos adaptee;
    JPanelBase_jButtonEditar_actionAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonEditar_actionPerformed(e);
    }
}



class JPanelBase_jButtonExcluir_actionAdapter implements ActionListener {
    private JPanelAnexos adaptee;
    JPanelBase_jButtonExcluir_actionAdapter(JPanelAnexos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonExcluir_actionPerformed(e);
    }
}

