package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Date;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.objAux.JDiologVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitoAnexoVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitosVisualizar;
import br.ufsc.fcama.ig.objAux.UserStoryVisualizar;
import br.ufsc.fcama.ig.tableModel.TableModelReqImplementacao;
import br.ufsc.fcama.logica.Iteracao;
import br.ufsc.fcama.logica.objAux.Requisito;
import br.ufsc.fcama.logica.objAux.RequisitoAnexo;
import br.ufsc.fcama.logica.objAux.UserStory;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelDesenvolverIncremento extends JPanel {
	
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
	private TableModelReqImplementacao modelNaoIniciado;
	private TableModelReqImplementacao modelIniciado;
	private TableModelReqImplementacao modelConcluido;
	private FramePrincipal frame;
	private Object[] objs;
	private Iteracao ciclo;
	private JPanelAnexos panelAnexos;
	
	
	public JPanelDesenvolverIncremento(FramePrincipal frame, Object[] objetos) {
        try {
        	this.frame = frame;
        	this.objs = objetos;
        	this.ciclo = (Iteracao)objetos[objetos.length - 3];
        	this.iniciarValores();
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
	
	private void iniciarValores(){
		this.panelAnexos = new JPanelAnexos(this.frame, this.objs);
		ArrayList requisitos = new ArrayList(this.frame.getControlador().getProjeto().getRequisitosDoProjeto());
		
		this.modelNaoIniciado = new TableModelReqImplementacao(this.ciclo.getNumero(), TableModelReqImplementacao.NAO_INICIADO, requisitos, new ArrayList());
		this.modelIniciado = new TableModelReqImplementacao(this.ciclo.getNumero(), TableModelReqImplementacao.INICIADO, requisitos, new ArrayList());
		this.modelConcluido = new TableModelReqImplementacao(this.ciclo.getNumero(), TableModelReqImplementacao.CONCLUIDO, requisitos, new ArrayList());
		this.jTableReqNaoInicicados = new JTable(this.modelNaoIniciado);
		this.jTableReqIniciados = new JTable(this.modelIniciado);
		this.jTableReqConcluidos = new JTable(this.modelConcluido);
		
		if (this.ciclo.getDtInicioEfetiva() == null){
			this.jButtonConcluir.setEnabled(false);
			this.jButtonIniciar.setEnabled(false);
			this.jButtonReiniicar.setEnabled(false);
		}
		if (this.ciclo.getDtFimEfetiva() != null){
			this.jButtonConcluir.setEnabled(false);
			this.jButtonIniciar.setEnabled(false);
		}
	}
    
    public void jTableReqConcluidos_mouseClicked(MouseEvent e) {
    	if (this.jTableReqConcluidos.getSelectedRow() != -1){
	    	if (e.getClickCount() == 2 ){
	    		this.visualizar(this.modelConcluido.getRequisito(this.jTableReqConcluidos.getSelectedRow()));
	    	}else if(e.getClickCount() == 1){
	    		this.jTableReqIniciados.clearSelection();
	    		this.jTableReqNaoInicicados.clearSelection();
	    	}
    	}
    }

    public void jTableReqIniciados_mouseClicked(MouseEvent e) {
    	if (this.jTableReqIniciados.getSelectedRow() != -1){
	    	if (e.getClickCount() == 2 ){
	    		this.visualizar(this.modelIniciado.getRequisito(this.jTableReqIniciados.getSelectedRow()));
	    	}else if(e.getClickCount() == 1){
	    		this.jTableReqConcluidos.clearSelection();
	    		this.jTableReqNaoInicicados.clearSelection();
	    	}
    	}
    }

    public void jTableReqNaoInicicados_mouseClicked(MouseEvent e) {
    	if (this.jTableReqNaoInicicados.getSelectedRow() != -1){
	    	if (e.getClickCount() == 2 ){
	    		this.visualizar(this.modelNaoIniciado.getRequisito(this.jTableReqNaoInicicados.getSelectedRow()));
	    	}else if(e.getClickCount() == 1){
	    		this.jTableReqConcluidos.clearSelection();
	    		this.jTableReqIniciados.clearSelection(); 
	    	}
    	}
    }
    
    public void jButtonVisualizar_actionPerformed(ActionEvent e) {
    	if(this.jTableReqConcluidos.getSelectedRow() != -1){
    		this.visualizar(this.modelConcluido.getRequisito(this.jTableReqConcluidos.getSelectedRow()));
    	}else if(this.jTableReqIniciados.getSelectedRow() != -1){
    		this.visualizar(this.modelIniciado.getRequisito(this.jTableReqIniciados.getSelectedRow()));
    	}else if(this.jTableReqNaoInicicados.getSelectedRow() != -1){
    		this.visualizar(this.modelNaoIniciado.getRequisito(this.jTableReqNaoInicicados.getSelectedRow()));
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelDesenvolverIncremento.erro.visualizarReq") ,this.rb.getString("jPanelDesenvolverIncremento.erro.visualizarReq.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }
    
    private void visualizar(Requisito req){ 
    	JDiologVisualizar d;
    	String titulo;
    	JPanel p;
    	if (req.getClass() ==  Requisito.class){
    		  p = new RequisitosVisualizar(this.frame, req);
    		  titulo =this.rb.getString("jPanelDesenvolverIncremento.visualizarReq");
    	}else if(req.getClass() ==  UserStory.class){
    		p = new UserStoryVisualizar(this.frame, (UserStory)req);
    		titulo = this.rb.getString("jPanelDesenvolverIncremento.visualizarUS");
    	}else{
    		p = new RequisitoAnexoVisualizar(this.frame, (RequisitoAnexo)req);
    		titulo = this.rb.getString("jPanelDesenvolverIncremento.visualizarReq");
    	}
    	d = new JDiologVisualizar(p, this.frame, titulo);
    	d.setModal(true);
    	d.setLocation(this.jTabbedPane1.getLocationOnScreen());
    	d.setSize(600,500);
    	d.setVisible(true);
    }
    
    public void jButtonIniciar_actionPerformed(ActionEvent e) {
    	if (this.jTableReqNaoInicicados.getSelectedRow() != -1){
    		Requisito req = this.modelNaoIniciado.removerRequisito(this.jTableReqNaoInicicados.getSelectedRow());
    		req.setDtInicio(new Date());
    		this.modelIniciado.addRequisito(req);
    		this.jTableReqNaoInicicados.addNotify();
    		this.jTableReqNaoInicicados.clearSelection();
    		this.jTableReqIniciados.addNotify();
    		this.frame.projetoAlterado();
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelDesenvolverIncremento.erro.msn.iniciarReq") ,this.rb.getString("jPanelDesenvolverIncremento.erro.msn.iniciarReq.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonConcluir_actionPerformed(ActionEvent e) {
    	if (this.jTableReqIniciados.getSelectedRow() != -1){
    		Requisito req = this.modelIniciado.removerRequisito(this.jTableReqIniciados.getSelectedRow());
    		req.setDtFim(new Date());
    		this.modelConcluido.addRequisito(req);
    		this.jTableReqIniciados.addNotify();
    		this.jTableReqIniciados.clearSelection();
    		this.jTableReqConcluidos.addNotify();
    		this.frame.projetoAlterado();
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelDesenvolverIncremento.erro.msn.concluirReq") ,this.rb.getString("jPanelDesenvolverIncremento.erro.msn.concluirReq.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonReiniicar_actionPerformed(ActionEvent e) {
    	if(this.jTableReqConcluidos.getSelectedRow() != -1){
    		Requisito req = this.modelConcluido.removerRequisito(this.jTableReqConcluidos.getSelectedRow());
    		req.setDtFim(null);
    		this.modelIniciado.addRequisito(req);
    		this.jTableReqConcluidos.addNotify();
    		this.jTableReqConcluidos.clearSelection();
    		this.jTableReqIniciados.addNotify();
    		this.frame.projetoAlterado();
    	}else{
    		JOptionPane.showConfirmDialog(this.frame,this.rb.getString("jPanelDesenvolverIncremento.erro.msn.reiniciarReq") ,this.rb.getString("jPanelDesenvolverIncremento.erro.msn.reiniciarReq.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    

    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        jPanel1.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(3);
        jPanel2.setBackground(Color.pink);
        jPanel2.setLayout(borderLayout2);
        jPanel3.setBackground(Color.orange);
        jPanel3.setLayout(borderLayout3);
        jPanel4.setBackground(Color.pink);
        jPanel4.setLayout(borderLayout4);
        jPanel7.setLayout(flowLayout1);
        jPanel11.setLayout(flowLayout2);
        jPanel10.setLayout(flowLayout3);
        jPanel13.setLayout(flowLayout4);
        flowLayout1.setAlignment(FlowLayout.LEFT);
        flowLayout2.setAlignment(FlowLayout.LEFT);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setText(this.rb.getString("jPanelDesenvolverIncremento.jLabel.reqNaoIniciado"));
        jLabel2.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel2.setText(this.rb.getString("jPanelDesenvolverIncremento.jLabel.reqIniciado"));
        jLabel3.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel3.setText(this.rb.getString("jPanelDesenvolverIncremento.jLabel.reqConcluidos"));
        jButtonIniciar.setPreferredSize(new Dimension(81, 23));
        jButtonIniciar.setText(this.rb.getString("jPanelDesenvolverIncremento.jButton.iniciar"));
        jButtonIniciar.addActionListener(new
                JPanelDesenvolverIncremento_jButtonIniciar_actionAdapter(this));
        jButtonConcluir.setPreferredSize(new Dimension(81, 23));
        jButtonConcluir.setText(this.rb.getString("jPanelDesenvolverIncremento.jButton.concluir"));
        jButtonConcluir.addActionListener(new
                JPanelDesenvolverIncremento_jButtonConcluir_actionAdapter(this));
        jButtonReiniicar.setPreferredSize(new Dimension(81, 23));
        jButtonReiniicar.setText(this.rb.getString("jPanelDesenvolverIncremento.jButton.reiniciar"));
        jButtonReiniicar.addActionListener(new
                JPanelDesenvolverIncremento_jButtonReiniicar_actionAdapter(this));
        jButtonVisualizar.setText(this.rb.getString("jPanelDesenvolverIncremento.jButton.visualizar"));
        jButtonVisualizar.addActionListener(new
                JPanelDesenvolverIncremento_jButtonVisualizar_actionAdapter(this));
        jTableReqConcluidos.addMouseListener(new
                JPanelDesenvolverIncremento_jTableReqConcluidos_mouseAdapter(this));
        jTableReqIniciados.addMouseListener(new
                JPanelDesenvolverIncremento_jTableReqIniciados_mouseAdapter(this));
        jTableReqNaoInicicados.addMouseListener(new
                JPanelDesenvolverIncremento_jTableReqNaoInicicados_mouseAdapter(this));
        this.add(jTabbedPane1, java.awt.BorderLayout.CENTER);
        jTabbedPane1.add(jPanel1, this.rb.getString("jPanelDesenvolverIncremento.tab.controleReq"));
        jTabbedPane1.add(this.panelAnexos, this.rb.getString("jPanelDesenvolverIncremento.tab.CadAnexos"));
        jPanel1.add(jPanel2);
        jPanel2.add(jPanel6, java.awt.BorderLayout.WEST);
        jPanel2.add(jPanel7, java.awt.BorderLayout.NORTH);
        jPanel7.add(jLabel1);
        jPanel2.add(jPanel8, java.awt.BorderLayout.EAST);
        jPanel2.add(jScrollPane3, java.awt.BorderLayout.CENTER);
        jScrollPane3.getViewport().add(jTableReqNaoInicicados);
        jPanel1.add(jPanel3);
        jPanel3.add(jPanel9, java.awt.BorderLayout.WEST);
        jPanel3.add(jPanel11, java.awt.BorderLayout.NORTH);
        jPanel11.add(jLabel2);
        jPanel3.add(jPanel5, java.awt.BorderLayout.EAST);
        jPanel3.add(jScrollPane2, java.awt.BorderLayout.CENTER);
        jScrollPane2.getViewport().add(jTableReqIniciados);
        jPanel1.add(jPanel4);
        jPanel4.add(jPanel12, java.awt.BorderLayout.WEST);
        jPanel4.add(jPanel13, java.awt.BorderLayout.SOUTH);
        jPanel13.add(jButtonIniciar);
        jPanel13.add(jButtonConcluir);
        jPanel13.add(jButtonReiniicar);
        jPanel13.add(jButtonVisualizar);
        jPanel4.add(jPanel14, java.awt.BorderLayout.EAST);
        jPanel4.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jPanel4.add(jPanel10, java.awt.BorderLayout.NORTH);
        jPanel10.add(jLabel3);
        jScrollPane1.getViewport().add(jTableReqConcluidos);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JTabbedPane jTabbedPane1 = new JTabbedPane();
    JPanel jPanel1 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel6 = new JPanel();
    JPanel jPanel7 = new JPanel();
    JPanel jPanel8 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    JPanel jPanel9 = new JPanel();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    JPanel jPanel5 = new JPanel();
    BorderLayout borderLayout4 = new BorderLayout();
    JPanel jPanel12 = new JPanel();
    JPanel jPanel13 = new JPanel();
    JPanel jPanel14 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    FlowLayout flowLayout2 = new FlowLayout();
    FlowLayout flowLayout3 = new FlowLayout();
    FlowLayout flowLayout4 = new FlowLayout();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JButton jButtonIniciar = new JButton();
    JButton jButtonConcluir = new JButton();
    JButton jButtonReiniicar = new JButton();
    JButton jButtonVisualizar = new JButton();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable jTableReqConcluidos = new JTable();
    JScrollPane jScrollPane2 = new JScrollPane();
    JTable jTableReqIniciados = new JTable();
    JScrollPane jScrollPane3 = new JScrollPane();
    JTable jTableReqNaoInicicados = new JTable();
    
}


class JPanelDesenvolverIncremento_jButtonVisualizar_actionAdapter implements
        ActionListener {
    private JPanelDesenvolverIncremento adaptee;
    JPanelDesenvolverIncremento_jButtonVisualizar_actionAdapter(
            JPanelDesenvolverIncremento adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonVisualizar_actionPerformed(e);
    }
}


class JPanelDesenvolverIncremento_jButtonReiniicar_actionAdapter implements
        ActionListener {
    private JPanelDesenvolverIncremento adaptee;
    JPanelDesenvolverIncremento_jButtonReiniicar_actionAdapter(
            JPanelDesenvolverIncremento adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonReiniicar_actionPerformed(e);
    }
}


class JPanelDesenvolverIncremento_jButtonConcluir_actionAdapter implements
        ActionListener {
    private JPanelDesenvolverIncremento adaptee;
    JPanelDesenvolverIncremento_jButtonConcluir_actionAdapter(
            JPanelDesenvolverIncremento adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonConcluir_actionPerformed(e);
    }
}


class JPanelDesenvolverIncremento_jButtonIniciar_actionAdapter implements
        ActionListener {
    private JPanelDesenvolverIncremento adaptee;
    JPanelDesenvolverIncremento_jButtonIniciar_actionAdapter(
            JPanelDesenvolverIncremento adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonIniciar_actionPerformed(e);
    }
}


class JPanelDesenvolverIncremento_jTableReqNaoInicicados_mouseAdapter extends
        MouseAdapter {
    private JPanelDesenvolverIncremento adaptee;
    JPanelDesenvolverIncremento_jTableReqNaoInicicados_mouseAdapter(
            JPanelDesenvolverIncremento adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableReqNaoInicicados_mouseClicked(e);
    }
}


class JPanelDesenvolverIncremento_jTableReqIniciados_mouseAdapter extends
        MouseAdapter {
    private JPanelDesenvolverIncremento adaptee;
    JPanelDesenvolverIncremento_jTableReqIniciados_mouseAdapter(
            JPanelDesenvolverIncremento adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableReqIniciados_mouseClicked(e);
    }
}


class JPanelDesenvolverIncremento_jTableReqConcluidos_mouseAdapter extends
        MouseAdapter {
    private JPanelDesenvolverIncremento adaptee;
    JPanelDesenvolverIncremento_jTableReqConcluidos_mouseAdapter(
            JPanelDesenvolverIncremento adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableReqConcluidos_mouseClicked(e);
    }
}
