package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.objAux.JDialogSelecao;
import br.ufsc.fcama.ig.objAux.JDiologVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitoAnexoVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitosVisualizar;
import br.ufsc.fcama.ig.objAux.UserStoryVisualizar;
import br.ufsc.fcama.ig.tableModel.TableModelRequisitos;
import br.ufsc.fcama.ig.tableModel.TableModelStakeholder;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Requisito;
import br.ufsc.fcama.logica.objAux.RequisitoAnexo;
import br.ufsc.fcama.logica.objAux.UserStory;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelDistribuicaoRequisitos extends JPanel {
 
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
	private JPanelAnexos panelAnexos;
	private TableModelRequisitos modelRequisitos;
    private TableModelStakeholder modelStakeholder;
	private FramePrincipal frame;
	private Object[] objetos;
	
	public JPanelDistribuicaoRequisitos(FramePrincipal frame, Object[] objetos) {
        try {
        	this.frame = frame;
        	this.objetos = objetos;
        	this.setValores();
            jbInit();
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
	
	private void setValores(){
		this.panelAnexos = new JPanelAnexos(this.frame, this.objetos);
		this.modelStakeholder = new TableModelStakeholder(new ArrayList());
		this.jTableResp = new JTable(this.modelStakeholder);
		
		ArrayList requisitos = new ArrayList();
		Projeto projeto = this.frame.getControlador().getProjeto();
		requisitos.addAll(projeto.getRequisitosDoProjeto());
		this.modelRequisitos = new TableModelRequisitos(requisitos, null, 4);
		this.jTableRequisitos = new JTable(this.modelRequisitos);
		
	}
    
    public void jButtonAdicionar_actionPerformed(ActionEvent e) {
    	if (this.jTableRequisitos.getSelectedRow() != -1){
    		TableModelStakeholder model = new TableModelStakeholder(new ArrayList(this.frame.getControlador().getProjeto().getStakeholders()), this.modelStakeholder.getStakeholders());
        	JDialogSelecao dialogSelecao = new JDialogSelecao(this.frame, this.rb.getString("jPanelDistribuicaoRequisitos.jDialogResponsavel"), model);
        	Point point = this.jButtonAdicionar.getLocationOnScreen();
        	point.setLocation(point.x - 100, point.y - 200 );
        	dialogSelecao.setLocation(point);
        	dialogSelecao.setLocation(point);
        	dialogSelecao.setSize( new Dimension(300,200));
        	int row = dialogSelecao.selecionar();
        	if (row != -1){
        		this.modelStakeholder.addStakeholder(model.getStakeholder(row));
        		this.jTableResp.addNotify();
        	}
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelDistribuicaoRequisitos.erro.msn.addResponsavel") ,this.rb.getString("jPanelDistribuicaoRequisitos.erro.msn.addResponsavel.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonRemover_actionPerformed(ActionEvent e) {
    	if (this.jTableResp.getSelectedRow() != -1){
    		Requisito req = this.modelRequisitos.getRequisito(this.jTableRequisitos.getSelectedRow());
    		req.removeResponsavel(this.modelStakeholder.removeStakeholder(this.jTableResp.getSelectedRow()));
    		this.jTableResp.addNotify();
    		this.frame.projetoAlterado();
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelDistribuicaoRequisitos.erro.msn.removerResponsavel") ,this.rb.getString("jPanelDistribuicaoRequisitos.erro.msn.removerResponsavel.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jTableRequisitos_mouseClicked(MouseEvent e) {
    	if (this.jTableRequisitos.getSelectedRow() != -1 && e.getClickCount() == 2){
    		JDiologVisualizar d;
        	String titulo;
        	JPanel p;
        	Requisito obj = this.modelRequisitos.getRequisito(this.jTableRequisitos.getSelectedRow());
        	if (obj.getClass() ==  Requisito.class){
        		  p = new RequisitosVisualizar(this.frame, (Requisito)obj);
        		  titulo = this.rb.getString("jPanelDistribuicaoRequisitos.visualizar.requisito");
        	}else if(obj.getClass() ==  UserStory.class){
        		p = new UserStoryVisualizar(this.frame, (UserStory)obj);
        		titulo = this.rb.getString("jPanelDistribuicaoRequisitos.visualizar.userStory");
        	}else{
        		p = new RequisitoAnexoVisualizar(this.frame, (RequisitoAnexo)obj);
        		titulo = this.rb.getString("jPanelDistribuicaoRequisitos.visualizar.requisito");
        	}
        	d = new JDiologVisualizar(p, this.frame, titulo);
        	d.setModal(true);
        	d.setLocation(this.jTabbedPane1.getLocationOnScreen());
        	d.setSize(600,500);
        	d.setVisible(true);
    	}else if(this.jTableRequisitos.getSelectedRow() != -1 && e.getClickCount() == 1){
    		Requisito req = this.modelRequisitos.getRequisito(this.jTableRequisitos.getSelectedRow());
    		this.jTextAreaDesc.setText(req.getDescricao());
    		this.modelStakeholder.setStakeholders(req.getResponsaveis());
    		this.jTableResp.addNotify();
    	}

    }

    private void jbInit() throws Exception {
    	
        this.setLayout(borderLayout1);
        jPanel1.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(3);
        jPanel2.setBackground(Color.pink);
        jPanel2.setLayout(borderLayout2);
        jPanel3.setBackground(Color.orange);
        jPanel3.setLayout(borderLayout3);
        jPanel4.setBackground(Color.pink);
        jPanel4.setLayout(borderLayout4);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("jPanelDistribuicaoRequisitos.jLabel.requisitos"));
        jPanel6.setLayout(flowLayout1);
        flowLayout1.setAlignment(FlowLayout.LEFT);
        jPanel10.setLayout(flowLayout2);
        jPanel11.setLayout(flowLayout3);
        flowLayout2.setAlignment(FlowLayout.LEFT);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        jLabel2.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel2.setText(this.rb.getString("jPanelDistribuicaoRequisitos.jLabel.descricao"));
        jLabel3.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel3.setToolTipText("");
        jLabel3.setText(this.rb.getString("jPanelDistribuicaoRequisitos.jLabel.stakeholders"));
        jTextAreaDesc.setEditable(false);
        jTextAreaDesc.setLineWrap(true);
        jPanel15.setLayout(flowLayout4);
        jButtonAdicionar.setText(this.rb.getString("jPanelDistribuicaoRequisitos.jButton.adicionar"));
        jButtonAdicionar.addActionListener(new
                JPanelDistribuicaoRequisitos_jButtonAdicionar_actionAdapter(this));
        jButtonRemover.setText(this.rb.getString("jPanelDistribuicaoRequisitos.jButton.remover"));
        jButtonRemover.addActionListener(new
                JPanelDistribuicaoRequisitos_jButtonRemover_actionAdapter(this));
        jTableRequisitos.addMouseListener(new
                JPanelDistribuicaoRequisitos_jTableRequisitos_mouseAdapter(this));
        this.add(jTabbedPane1, java.awt.BorderLayout.CENTER);
        jTabbedPane1.add(jPanel1, this.rb.getString("jPanelDistribuicaoRequisitos.tab.definirResponsaveis"));
        this.jTabbedPane1.add(this.panelAnexos, this.rb.getString("jPanelDistribuicaoRequisitos.tab.cadastroAnexos"));
        jPanel1.add(jPanel2);
        jPanel2.add(jPanel5, java.awt.BorderLayout.WEST);
        jPanel2.add(jPanel6, java.awt.BorderLayout.NORTH);
        jPanel6.add(jLabel1);
        jPanel2.add(jPanel7, java.awt.BorderLayout.EAST);
        jPanel2.add(jPanel8, java.awt.BorderLayout.SOUTH);
        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jTableRequisitos);
        jPanel1.add(jPanel3);
        jPanel3.add(jPanel10, java.awt.BorderLayout.NORTH);
        jPanel10.add(jLabel2);
        jPanel3.add(jPanel11, java.awt.BorderLayout.SOUTH);
        jPanel11.add(jLabel3);
        jPanel1.add(jPanel4);
        jPanel4.add(jPanel13, java.awt.BorderLayout.WEST);
        jPanel4.add(jPanel14, java.awt.BorderLayout.EAST);
        jPanel4.add(jPanel15, java.awt.BorderLayout.SOUTH);
        jPanel15.add(jButtonAdicionar);
        jPanel15.add(jButtonRemover);
        jPanel4.add(jScrollPane3, java.awt.BorderLayout.CENTER);
        jScrollPane3.getViewport().add(jTableResp);
        jPanel3.add(jPanel9, java.awt.BorderLayout.EAST);
        jPanel3.add(jPanel12, java.awt.BorderLayout.WEST);
        jPanel3.add(jScrollPane2, java.awt.BorderLayout.CENTER);
        jScrollPane2.getViewport().add(jTextAreaDesc);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JTabbedPane jTabbedPane1 = new JTabbedPane();
    JPanel jPanel1 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel5 = new JPanel();
    JPanel jPanel6 = new JPanel();
    JPanel jPanel7 = new JPanel();
    JPanel jPanel8 = new JPanel();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable jTableRequisitos = new JTable();
    JLabel jLabel1 = new JLabel();
    FlowLayout flowLayout1 = new FlowLayout();
    BorderLayout borderLayout3 = new BorderLayout();
    JPanel jPanel9 = new JPanel();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    JPanel jPanel12 = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();
    FlowLayout flowLayout3 = new FlowLayout();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JScrollPane jScrollPane2 = new JScrollPane();
    JTextArea jTextAreaDesc = new JTextArea();
    BorderLayout borderLayout4 = new BorderLayout();
    JPanel jPanel13 = new JPanel();
    JPanel jPanel14 = new JPanel();
    JPanel jPanel15 = new JPanel();
    FlowLayout flowLayout4 = new FlowLayout();
    JScrollPane jScrollPane3 = new JScrollPane();
    JTable jTableResp = new JTable();
    JButton jButtonAdicionar = new JButton();
    JButton jButtonRemover = new JButton();
    
}


class JPanelDistribuicaoRequisitos_jTableRequisitos_mouseAdapter extends
        MouseAdapter {
    private JPanelDistribuicaoRequisitos adaptee;
    JPanelDistribuicaoRequisitos_jTableRequisitos_mouseAdapter(
            JPanelDistribuicaoRequisitos adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableRequisitos_mouseClicked(e);
    }
}


class JPanelDistribuicaoRequisitos_jButtonRemover_actionAdapter implements
        ActionListener {
    private JPanelDistribuicaoRequisitos adaptee;
    JPanelDistribuicaoRequisitos_jButtonRemover_actionAdapter(
            JPanelDistribuicaoRequisitos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonRemover_actionPerformed(e);
    }
}


class JPanelDistribuicaoRequisitos_jButtonAdicionar_actionAdapter implements
        ActionListener {
    private JPanelDistribuicaoRequisitos adaptee;
    JPanelDistribuicaoRequisitos_jButtonAdicionar_actionAdapter(
            JPanelDistribuicaoRequisitos adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAdicionar_actionPerformed(e);
    }
}
