package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.objAux.DateChooser;
import br.ufsc.fcama.ig.objAux.JDialogSelecao;
import br.ufsc.fcama.ig.objAux.JDiologVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitoAnexoVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitosVisualizar;
import br.ufsc.fcama.ig.objAux.UserStoryVisualizar;
import br.ufsc.fcama.ig.tableModel.TableModelRequisitos;
import br.ufsc.fcama.logica.Iteracao;
import br.ufsc.fcama.logica.objAux.Requisito;
import br.ufsc.fcama.logica.objAux.RequisitoAnexo;
import br.ufsc.fcama.logica.objAux.UserStory;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelIteracao extends JPanel {
    private Iteracao ciclo;
    private FramePrincipal frame;
    private TableModelRequisitos  modelRequisitos;
    private SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy" );
    private DateChooser dtChooser;
    private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
	public JPanelIteracao(FramePrincipal frame, Iteracao ciclo) {
        try {
        	this.frame = frame;
        	this.ciclo = ciclo;
        	this.iniciarCampos();
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
	
	private void iniciarCampos(){
		this.dtChooser = new DateChooser(this.frame, this.rb.getString("jPanelIteracao.dtChooser.titulo1"));
		this.modelRequisitos = new TableModelRequisitos(6, this.ciclo.getNumero(), new ArrayList(this.frame.getControlador()
				.getProjeto().getRequisitosDoProjeto()),new ArrayList());
		this.jTableRequisitos = new JTable(this.modelRequisitos);
		
		if (this.ciclo.getDtInicioPrevista() != null){
			this.jTextFieldIncioPrevisto.setText(this.format.format(this.ciclo.getDtInicioPrevista()));
			this.jTextFieldFimPrevisto.setText(this.ciclo.getDtFimPrevista() == null 
					? "" : this.format.format(this.ciclo.getDtFimPrevista()));
		}else{
			this.jButtonFimPrevisto.setEnabled(false);
		}
		if(this.ciclo.getDtInicioEfetiva() != null){
			this.jTextFieldInicioEfetivo.setText(this.format.format(this.ciclo.getDtInicioEfetiva()));
			this.jTextFieldFimEfetivo.setText(this.ciclo.getDtFimEfetiva() == null 
					? "" : this.format.format(this.ciclo.getDtFimEfetiva()));
		}else{
			this.jButtonFimEfetivo.setEnabled(false);
		}
		
		if (this.ciclo.getDtFimEfetiva() != null ){
			this.jButtonAdicionar.setEnabled(false);
		}
		
	}
    
    public void jButtonRemover_actionPerformed(ActionEvent e) {
    	if (this.jTableRequisitos.getSelectedRow() != -1){
    		Requisito req = this.modelRequisitos.removeRequisito(this.jTableRequisitos.getSelectedRow());
    		req.setNuCincloDeDesenvolvimento(0);
    		this.jTableRequisitos.addNotify();
    		this.jTableRequisitos.clearSelection();
    		this.frame.projetoAlterado();
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelIteracao.erro.removerRequisito.msn") ,this.rb.getString("jPanelIteracao.erro.removerRequisito.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonVisualizar_actionPerformed(ActionEvent e) {
    	if (this.jTableRequisitos.getSelectedRow() != -1){
    		this.visualizar(this.modelRequisitos.getRequisito(this.jTableRequisitos.getSelectedRow()));
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelIteracao.erro.visualizarrequisito.msn") ,this.rb.getString("jPanelIteracao.erro.visualizarRequisito.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }
    public void jButtonAdicionar_actionPerformed(ActionEvent e) {
    	TableModelRequisitos modelAux = new TableModelRequisitos(1, 0, new ArrayList(this.frame.getControlador()
				.getProjeto().getRequisitosDoProjeto()), new ArrayList());
    	JDialogSelecao dialogSelecao = new JDialogSelecao(this.frame, this.rb.getString("jPanelIteracao.dialog.req.titulo"), modelAux); 
    	Point point = this.jButtonAdicionar.getLocationOnScreen();
    	point.setLocation(point.x - 100, point.y - 200 );
    	dialogSelecao.setLocation(point);
    	dialogSelecao.setSize( new Dimension(300,200));
    	int row = dialogSelecao.selecionar();
    	if (row != -1){
    		Requisito req = (Requisito)modelAux.removeRequisito(row);
    		req.setNuCincloDeDesenvolvimento(this.ciclo.getNumero());
    		this.modelRequisitos.addRequisito(req);
    		this.jTableRequisitos.addNotify();
    		this.frame.projetoAlterado();
    	}
    }

    public void jButtonInicioPrevisto_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelIteracao.dtChooser.titulo1"));
    	this.dtChooser.setLocation(this.jLabel1.getLocationOnScreen());
    	Date dtInicio = this.dtChooser.select(this.ciclo.getDtInicioPrevista() == null ? new Date() : this.ciclo.getDtInicioPrevista());
    	if (dtInicio !=  null){
    		Date dtFim = this.ciclo.getDtFimPrevista();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.ciclo.setDtInicioPrevista(dtInicio);
    			this.jButtonFimPrevisto.setEnabled(true);
    			this.jTextFieldIncioPrevisto.setText(this.format.format(dtInicio));
    			this.frame.projetoAlterado();
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelIteracao.erro.dt1.msn") ,this.rb.getString("jPanelIteracao.erro.dt1.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonFimPrevisto_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelIteracao.dtChooser.titulo2"));
    	this.dtChooser.setLocation(this.jLabel2.getLocationOnScreen());
    	Date dtFim = this.dtChooser.select(this.ciclo.getDtFimPrevista() == null ? new Date() : this.ciclo.getDtFimPrevista());
    	if (dtFim !=  null){
    		Date dtInicio = this.ciclo.getDtInicioPrevista();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.ciclo.setDtFimPrevista(dtFim);
    			this.jTextFieldFimPrevisto.setText(this.format.format(dtFim));
    			this.frame.projetoAlterado();
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelIteracao.erro.dt2.msn") ,this.rb.getString("jPanelIteracao.erro.dt2.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonInicioEfetivo_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelIteracao.dtChooser.titulo3"));
    	this.dtChooser.setLocation(this.jLabel3.getLocationOnScreen());
    	Date dtInicio = this.dtChooser.select(this.ciclo.getDtInicioEfetiva() == null ? new Date() : this.ciclo.getDtInicioEfetiva());
    	if (dtInicio !=  null){
    		Date dtFim = this.ciclo.getDtFimEfetiva();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.ciclo.setDtInicioEfetiva(dtInicio);
    			this.jButtonFimEfetivo.setEnabled(true);
    			this.jTextFieldInicioEfetivo.setText(this.format.format(dtInicio));
    			this.frame.projetoAlterado();
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelIteracao.erro.dt3.msn") ,this.rb.getString("jPanelIteracao.erro.dt3.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonFimEfetivo_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelIteracao.dtChooser.titulo4"));
    	this.dtChooser.setLocation(this.jLabel4.getLocationOnScreen());
    	Date dtFim = this.dtChooser.select(this.ciclo.getDtFimEfetiva() == null ? new Date() : this.ciclo.getDtFimEfetiva());
    	if (dtFim !=  null){
    		Date dtInicio = this.ciclo.getDtInicioEfetiva();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.ciclo.setDtFimEfetiva(dtFim);
    			this.jTextFieldFimEfetivo.setText(this.format.format(dtFim));
    			this.frame.projetoAlterado();
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelIteracao.erro.dt4.msn") ,this.rb.getString("jPanelIteracao.erro.dt4.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jTableRequisitos_mouseClicked(MouseEvent e) {
    	if (this.jTableRequisitos.getSelectedRow() != -1){
	    	Requisito req = this.modelRequisitos.getRequisito(this.jTableRequisitos.getSelectedRow());
    		if (e.getClickCount() == 1){
	    		if (req.getDtFim() != null){
	    			this.jButtonRemover.setEnabled(false);
	    		}else{
	    			this.jButtonRemover.setEnabled(true);
	    		}
	    	}else if (e.getClickCount() == 2){
	    		this.visualizar(req);
	    	}
    	}
    }

    private void visualizar(Requisito req){
    	JDiologVisualizar d;
    	String titulo;
    	JPanel p;
    	if (req.getClass() ==  Requisito.class){
    		  p = new RequisitosVisualizar(this.frame, (Requisito)req);
    		  titulo = this.rb.getString("jPanelIteracao.visualizarReq.titulo1");
    	}else if(req.getClass() ==  UserStory.class){
    		p = new UserStoryVisualizar(this.frame, (UserStory)req);
    		titulo = this.rb.getString("jPanelIteracao.visualizarReq.titulo2");
    	}else{
    		p = new RequisitoAnexoVisualizar(this.frame, (RequisitoAnexo)req);
    		titulo = this.rb.getString("jPanelIteracao.visualizarReq.titulo1");
    	}
    	
    	d = new JDiologVisualizar(p, this.frame, titulo);
    	d.setModal(true);
    	d.setLocation(this.getLocationOnScreen());
    	d.setSize(600,500);
    	d.setVisible(true);
    }
    

    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        jPanel1.setBackground(SystemColor.control);
        jPanel1.setMinimumSize(new Dimension(570, 50));
        jPanel1.setPreferredSize(new Dimension(10, 50));
        jPanel1.setLayout(gridLayout1);
        gridLayout1.setColumns(4);
        jPanel2.setBackground(SystemColor.control);
        jPanel2.setToolTipText("");
        jPanel2.setLayout(gridBagLayout1);
        jPanel5.setBackground(SystemColor.control);
        jPanel5.setLayout(gridBagLayout2);
        jPanel4.setBackground(SystemColor.control);
        jPanel4.setLayout(gridBagLayout3);
        jPanel3.setBackground(SystemColor.control);
        jPanel3.setLayout(gridBagLayout4);
        jLabel1.setText("Inicio Previsto:");
        jLabel2.setText("Fim Previsto:");
        jLabel3.setText("Inicio Efetivo:");
        jLabel4.setText("Fim Efetivo:");
        jTextFieldIncioPrevisto.setPreferredSize(new Dimension(80, 20));
        jTextFieldIncioPrevisto.setEditable(false);
        jTextFieldFimPrevisto.setPreferredSize(new Dimension(80, 20));
        jTextFieldFimPrevisto.setEditable(false);
        jTextFieldInicioEfetivo.setPreferredSize(new Dimension(80, 20));
        jTextFieldInicioEfetivo.setEditable(false);
        jTextFieldFimEfetivo.setPreferredSize(new Dimension(80, 20));
        jTextFieldFimEfetivo.setEditable(false);
        jButtonInicioPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setIcon(iconDate);
        jButtonInicioPrevisto.addActionListener(new
                JPanelCicloDeDesenvolvimento_jButtonInicioPrevisto_actionAdapter(this));
        jButtonFimPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonFimPrevisto.setIcon(iconDate);
        jButtonFimPrevisto.addActionListener(new
                JPanelCicloDeDesenvolvimento_jButtonFimPrevisto_actionAdapter(this));
        jButtonInicioEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setIcon(iconDate);
        jButtonInicioEfetivo.addActionListener(new
                JPanelCicloDeDesenvolvimento_jButtonInicioEfetivo_actionAdapter(this));
        jButtonFimEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonFimEfetivo.setIcon(iconDate);
        jButtonFimEfetivo.addActionListener(new
                JPanelCicloDeDesenvolvimento_jButtonFimEfetivo_actionAdapter(this));
        jPanel6.setLayout(borderLayout2);
        jPanel6.setBackground(Color.orange);
        jPanel7.setPreferredSize(new Dimension(10, 40));
        jPanel7.setLayout(borderLayout4);
        jPanel12.setLayout(flowLayout1);
        jPanel11.setLayout(flowLayout2);
        jPanel9.setLayout(flowLayout3);
        flowLayout1.setAlignment(FlowLayout.LEFT);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        flowLayout3.setHgap(5);
        jLabel5.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel5.setText(this.rb.getString("jPanelIteracao.titulo1"));
        jLabel6.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel6.setToolTipText("");
        jLabel6.setText(this.rb.getString("jPanelIteracao.titulo2"));
        jButtonRemover.setPreferredSize(new Dimension(81, 23));
        jButtonRemover.setText(this.rb.getString("jPanelIteracao.button.remover"));
        jButtonRemover.addActionListener(new
                JPanelCicloDeDesenvolvimento_jButtonRemover_actionAdapter(this));
        jButtonVisualizar.setText(this.rb.getString("jPanelIteracao.button.visualizar"));
        jButtonVisualizar.addActionListener(new
                JPanelCicloDeDesenvolvimento_jButton2_actionAdapter(this));
        jPanel13.setPreferredSize(new Dimension(10, 100));
        jPanel13.setLayout(borderLayout3);
        jTableRequisitos.addMouseListener(new
                JPanelCicloDeDesenvolvimento_jTableRequisitos_mouseAdapter(this));
        jButtonAdicionar.setPreferredSize(new Dimension(81, 23));
        jButtonAdicionar.setText(this.rb.getString("jPanelIteracao.button.adicionar"));
        jButtonAdicionar.addActionListener(new
                JPanelCicloDeDesenvolvimento_jButtonAdicionar_actionAdapter(this));
        jPanel1.add(jPanel2);
        jPanel2.add(jTextFieldIncioPrevisto,
                    new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.HORIZONTAL,
                                           new Insets(0, 6, 9, 0), 0, 0));
        jPanel2.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(5, 6, 0, 30), 0, 0));
        jPanel2.add(jButtonInicioPrevisto,
                    new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 0, 9, 10), 0, 0));
        jPanel1.add(jPanel5);
        jPanel5.add(jLabel2, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(5, 6, 0, 38), 0, 0));
        jPanel5.add(jTextFieldFimPrevisto,
                    new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.HORIZONTAL,
                                           new Insets(0, 6, 10, 0), 0, 0));
        jPanel5.add(jButtonFimPrevisto,
                    new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 0, 10, 10), 0, 0));
        jPanel1.add(jPanel4);
        jPanel4.add(jLabel3, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(4, 7, 0, 37), 0, 0));
        jPanel4.add(jTextFieldInicioEfetivo,
                    new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.HORIZONTAL,
                                           new Insets(0, 7, 10, 0), 0, 0));
        jPanel4.add(jButtonInicioEfetivo,
                    new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 0, 10, 10), 0, 0));
        jPanel1.add(jPanel3);
        jPanel3.add(jTextFieldFimEfetivo,
                    new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.HORIZONTAL,
                                           new Insets(0, 7, 10, 0), 0, 0));
        jPanel3.add(jLabel4, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(4, 7, 0, 44), 0, 0));
        jPanel3.add(jButtonFimEfetivo,
                    new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 0, 10, 10), 0, 0));
        this.add(jPanel6, java.awt.BorderLayout.CENTER);
        jPanel6.add(jPanel7, java.awt.BorderLayout.SOUTH);
        jPanel11.add(jButtonRemover);
        jPanel11.add(jButtonAdicionar);
        jPanel11.add(jButtonVisualizar);
        jPanel6.add(jPanel8, java.awt.BorderLayout.WEST);
        jPanel6.add(jPanel9, java.awt.BorderLayout.NORTH);
        jPanel9.add(jLabel6);
        jPanel6.add(jPanel10, java.awt.BorderLayout.EAST);
        jPanel6.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        this.add(jPanel13, java.awt.BorderLayout.NORTH);
        jPanel13.add(jPanel12, java.awt.BorderLayout.NORTH);
        jPanel12.add(jLabel5);
        jPanel13.add(jPanel1, java.awt.BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jTableRequisitos);
        jPanel7.add(jPanel11, java.awt.BorderLayout.CENTER);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    Icon iconDate = new ImageIcon("imagens/date.gif");
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JTextField jTextFieldIncioPrevisto = new JTextField();
    JTextField jTextFieldFimPrevisto = new JTextField();
    JTextField jTextFieldInicioEfetivo = new JTextField();
    JTextField jTextFieldFimEfetivo = new JTextField();
    JButton jButtonInicioPrevisto = new JButton();
    JButton jButtonFimPrevisto = new JButton();
    JButton jButtonInicioEfetivo = new JButton();
    JButton jButtonFimEfetivo = new JButton();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    GridBagLayout gridBagLayout4 = new GridBagLayout();
    JPanel jPanel6 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel7 = new JPanel();
    JPanel jPanel8 = new JPanel();
    JPanel jPanel9 = new JPanel();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    JPanel jPanel12 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    FlowLayout flowLayout2 = new FlowLayout();
    FlowLayout flowLayout3 = new FlowLayout();
    JLabel jLabel5 = new JLabel();
    JLabel jLabel6 = new JLabel();
    JButton jButtonRemover = new JButton();
    JButton jButtonVisualizar = new JButton();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable jTableRequisitos = new JTable();
    JPanel jPanel13 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    BorderLayout borderLayout4 = new BorderLayout();
    JButton jButtonAdicionar = new JButton();
    


}


class JPanelCicloDeDesenvolvimento_jButtonAdicionar_actionAdapter implements
        ActionListener {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jButtonAdicionar_actionAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAdicionar_actionPerformed(e);
    }
}


class JPanelCicloDeDesenvolvimento_jTableRequisitos_mouseAdapter extends
        MouseAdapter {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jTableRequisitos_mouseAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableRequisitos_mouseClicked(e);
    }
}


class JPanelCicloDeDesenvolvimento_jButtonFimEfetivo_actionAdapter implements
        ActionListener {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jButtonFimEfetivo_actionAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonFimEfetivo_actionPerformed(e);
    }
}


class JPanelCicloDeDesenvolvimento_jButtonInicioEfetivo_actionAdapter implements
        ActionListener {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jButtonInicioEfetivo_actionAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonInicioEfetivo_actionPerformed(e);
    }
}


class JPanelCicloDeDesenvolvimento_jButtonFimPrevisto_actionAdapter implements
        ActionListener {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jButtonFimPrevisto_actionAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonFimPrevisto_actionPerformed(e);
    }
}


class JPanelCicloDeDesenvolvimento_jButtonInicioPrevisto_actionAdapter implements
        ActionListener {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jButtonInicioPrevisto_actionAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonInicioPrevisto_actionPerformed(e);
    }
}


class JPanelCicloDeDesenvolvimento_jButton2_actionAdapter implements
        ActionListener {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jButton2_actionAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonVisualizar_actionPerformed(e);
    }
}


class JPanelCicloDeDesenvolvimento_jButtonRemover_actionAdapter implements
        ActionListener {
    private JPanelIteracao adaptee;
    JPanelCicloDeDesenvolvimento_jButtonRemover_actionAdapter(
            JPanelIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonRemover_actionPerformed(e);
    }
}

