package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.border.Border;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.objAux.JDialogSelecao;
import br.ufsc.fcama.ig.objAux.JDiologVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitoAnexoVisualizar;
import br.ufsc.fcama.ig.objAux.RequisitosVisualizar;
import br.ufsc.fcama.ig.objAux.UserStoryVisualizar;
import br.ufsc.fcama.ig.tableModel.TableModelRequisitos;
import br.ufsc.fcama.logica.Iteracao;
import br.ufsc.fcama.logica.objAux.Requisito;
import br.ufsc.fcama.logica.objAux.RequisitoAnexo;
import br.ufsc.fcama.logica.objAux.UserStory;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelPlanejamentoIteracoes extends JPanel {
   private JPanelAnexos jPanelAnexos;   
   private Object[] objetos;
   protected FramePrincipal frame;
   protected TableModelRequisitos model;
   private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    
    public JPanelPlanejamentoIteracoes(FramePrincipal frame, Object[] obj){
        try {
            this.frame = frame;
            this.objetos = obj;
            this.jPanelAnexos = new JPanelAnexos(this.frame,this.objetos);
            this.setTabCiclos();
            this.model = new TableModelRequisitos(3,0,new ArrayList(this.frame.getControlador().getProjeto().getRequisitosDoProjeto()),
            		new ArrayList());
            this.jTable1 = new JTable(this.model);
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private void setTabCiclos(){
        ArrayList ciclos = this.frame.getControlador().getProjeto().getIteracoes();
        Iterator it  = ciclos.iterator();
        Iteracao c;
        while(it.hasNext()){
            c = (Iteracao)it.next();
            this.jTabbedPane1.add(new JPanelTabIteracao(c,this, this.frame.getControlador()), c.toString());
        }
        
    }
    
    public void jButtonAdicionar_actionPerformed(ActionEvent e) {
    	JPanelTabIteracao tabCiclo = (JPanelTabIteracao)this.jTabbedPane1.getSelectedComponent(); 
    	TableModelRequisitos modelAux = new TableModelRequisitos(1,new ArrayList(this.model.getRequisitos()),new ArrayList() );
    	JDialogSelecao dialogSelecao = new JDialogSelecao(this.frame, this.rb.getString("jPanelPlanejamentoIteracoes.digReq.titulo"), modelAux); 
    	Point point = this.jButtonAdicionar.getLocationOnScreen();
    	point.setLocation(point.x - 100, point.y - 200 );
    	dialogSelecao.setLocation(point);
    	dialogSelecao.setSize( new Dimension(300,200));
    	int row = dialogSelecao.selecionar();
    	if (row != -1){
    		Requisito req = (Requisito)this.model.removeRequisito(row);
    		this.jTable1.addNotify();
    		tabCiclo.addRequisito(req);
    		this.frame.projetoAlterado();
    	}
    }

    public void jButtonRemover_actionPerformed(ActionEvent e) {
    	JPanelTabIteracao tabCiclo = (JPanelTabIteracao)this.jTabbedPane1.getSelectedComponent(); 
    	if (tabCiclo.jTable1.getSelectedRow() != -1){
    		this.model.addRequisito(tabCiclo.removerRequisito());
    		this.jTable1.addNotify();
    		this.frame.projetoAlterado();
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelPlanejamentoIteracoes.erro.removerReq.msn") ,this.rb.getString("jPanelPlanejamentoIteracoes.erro.removerReq.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonVisualizar_actionPerformed(ActionEvent e) {
    	if (this.jTable1.getSelectedRow() != -1){
    		this.visualizar(this.model.getRequisito(this.jTable1.getSelectedRow() ));
    	}else if (((JPanelTabIteracao)this.jTabbedPane1.getSelectedComponent()).jTable1.getSelectedRow() != -1){
    		JPanelTabIteracao jtc = (JPanelTabIteracao)this.jTabbedPane1.getSelectedComponent();
    		this.visualizar(jtc.model.getRequisito(jtc.jTable1.getSelectedRow()));
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelPlanejamentoIteracoes.erro.visualizarReq.msn") ,this.rb.getString("jPanelPlanejamentoIteracoes.erro.visualizarReq.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    		
    }

    public void jTable1_mouseClicked(MouseEvent e) {
    	if (e.getClickCount() == 2 && this.jTable1.getSelectedRow() != -1){
    		this.visualizar(this.model.getRequisito(this.jTable1.getSelectedRow() ));
    	}else if(e.getClickCount() == 1 && this.jTable1.getSelectedRow() != -1){
    		((JPanelTabIteracao)this.jTabbedPane1.getSelectedComponent()).jTable1.clearSelection();
    	}
    }
    
    
    protected void visualizar(Object obj){
    	JDiologVisualizar d;
    	String titulo;
    	JPanel p;
    	if (obj.getClass() ==  Requisito.class){
    		  p = new RequisitosVisualizar(this.frame, (Requisito)obj);
    		  titulo = this.rb.getString("jPanelPlanejamentoIteracoes.visualizarReq.titulo1");
    	}else if(obj.getClass() ==  UserStory.class){
    		p = new UserStoryVisualizar(this.frame, (UserStory)obj);
    		titulo = this.rb.getString("jPanelPlanejamentoIteracoes.visualizarReq.titulo2");
    	}else{
    		p = new RequisitoAnexoVisualizar(this.frame, (RequisitoAnexo)obj);
    		titulo = this.rb.getString("jPanelPlanejamentoIteracoes.visualizarReq.titulo1");
    	}
    	d = new JDiologVisualizar(p, this.frame, titulo);
    	d.setModal(true);
    	d.setLocation(this.jTabbedPaneGeral.getLocationOnScreen());
    	d.setSize(600,500);
    	d.setVisible(true);
    }

    private void jbInit() throws Exception {
        this.setLayout(borderLayout6);
        jPanel1.setBackground(Color.pink);
        jPanel1.setLayout(borderLayout2);
        jPanel2.setBackground(Color.orange);
        jPanel2.setLayout(borderLayout1);
        jPanel3.setLayout(borderLayout3);
        jPanel5.setLayout(borderLayout4);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("jPanelPlanejamentoIteracoes.iteracoes"));
        jPanel7.setBorder(border1);
        jPanel7.setPreferredSize(new Dimension(2, 2));
        jPanel7.setToolTipText("");
        jPanel7.setLayout(flowLayout1);
        jPanel6.setLayout(flowLayout2);
        flowLayout2.setAlignment(FlowLayout.LEFT);
        jPanel4.setLayout(borderLayout5);
        jPanel8.setBorder(border2);
        jPanel8.setPreferredSize(new Dimension(2, 2));
        jPanel9.setLayout(flowLayout3);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        jLabel2.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel2.setText(this.rb.getString("jPanelPlanejamentoIteracoes.reqnaAtribuidos"));
        jPanelDistribuicao.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(2);
        jPanel11.setLayout(flowLayout4);
        jButtonAdicionar.setText(this.rb.getString("jPanelPlanejamentoIteracoes.button.adicionar"));
        jButtonAdicionar.addActionListener(new
                JPanelPlanejamentoIteracoes_jButtonAdicionar_actionAdapter(this));
        jButtonRemover.setText(this.rb.getString("jPanelPlanejamentoIteracoes.button.remover"));
        jButtonRemover.addActionListener(new
                JPanelPlanejamentoIteracoes_jButtonRemover_actionAdapter(this));
        jButtonVisualizar.setToolTipText("");
        jButtonVisualizar.setText(this.rb.getString("jPanelPlanejamentoIteracoes.button.visualizar"));
        jButtonVisualizar.addActionListener(new
                JPanelPlanejamentoIteracoes_jButtonVisualizar_actionAdapter(this));
        jPanel10.setBackground(Color.pink);
        jPanel10.setLayout(borderLayout8);
        jPanel12.setBackground(SystemColor.control);
        jPanel12.setLayout(borderLayout7);
        jPanel13.setLayout(flowLayout5);
        jTable1.addMouseListener(new
                JPanelPlanejamentoIteracoes_jTable1_mouseAdapter(this));
        jPanel5.add(jPanel6, java.awt.BorderLayout.CENTER);
        jPanel6.add(jLabel1);
        jPanel5.add(jPanel7, java.awt.BorderLayout.SOUTH);
        jPanelDistribuicao.add(jPanel1);

        jPanel4.add(jPanel9, java.awt.BorderLayout.CENTER);
        jPanel9.add(jLabel2);
        jPanel4.add(jPanel8, java.awt.BorderLayout.SOUTH);
        jPanel1.add(jPanel10, java.awt.BorderLayout.CENTER);
        jPanel10.add(jPanel13, java.awt.BorderLayout.SOUTH);
        jPanel10.add(jPanel14, java.awt.BorderLayout.WEST);
        jPanel10.add(jPanel15, java.awt.BorderLayout.EAST);
        jPanel10.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jPanel10.add(jPanel16, java.awt.BorderLayout.NORTH);
        jScrollPane1.getViewport().add(jTable1);
        jPanelDistribuicao.add(jPanel2);
        jPanel2.add(jPanel11, java.awt.BorderLayout.SOUTH);
        jPanel11.add(jButtonAdicionar);
        jPanel11.add(jButtonRemover);
        jPanel11.add(jButtonVisualizar);
        jPanel2.add(jPanel12, java.awt.BorderLayout.CENTER);
        jPanel12.add(jTabbedPane1, java.awt.BorderLayout.CENTER);
        //jTabbedPane1.add(jPanelTabCiclo, "jPanel17");
        jPanel1.add(jPanel3, java.awt.BorderLayout.SOUTH);
        jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);
        jPanel1.add(jPanel4, java.awt.BorderLayout.NORTH);

        jTabbedPaneGeral.add(jPanelDistribuicao, this.rb.getString("jPanelPlanejamentoIteracoes.tab.distribuicaoRequisitos"));
        this.jTabbedPaneGeral.add(this.jPanelAnexos, this.rb.getString("jPanelPlanejamentoIteracoes.tab.cadastroAnexos"));
        this.add(jTabbedPaneGeral, java.awt.BorderLayout.CENTER);
    }

    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    JPanel jPanel6 = new JPanel();
    BorderLayout borderLayout4 = new BorderLayout();
    JPanel jPanel7 = new JPanel();
    JLabel jLabel1 = new JLabel();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    FlowLayout flowLayout1 = new FlowLayout();
    FlowLayout flowLayout2 = new FlowLayout();
    JPanel jPanel8 = new JPanel();
    JPanel jPanel9 = new JPanel();
    BorderLayout borderLayout5 = new BorderLayout();
    Border border2 = BorderFactory.createLineBorder(Color.white, 2);
    FlowLayout flowLayout3 = new FlowLayout();
    JLabel jLabel2 = new JLabel();
    BorderLayout borderLayout6 = new BorderLayout();
    JTabbedPane jTabbedPaneGeral = new JTabbedPane();
    JPanel jPanelDistribuicao = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    FlowLayout flowLayout4 = new FlowLayout();
    JButton jButtonAdicionar = new JButton();
    JButton jButtonRemover = new JButton();
    JButton jButtonVisualizar = new JButton();
    JPanel jPanel12 = new JPanel();
    BorderLayout borderLayout7 = new BorderLayout();
    JTabbedPane jTabbedPane1 = new JTabbedPane();
    BorderLayout borderLayout8 = new BorderLayout();
    JPanel jPanel13 = new JPanel();
    FlowLayout flowLayout5 = new FlowLayout();
    JPanel jPanel14 = new JPanel();
    JPanel jPanel15 = new JPanel();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable jTable1 = new JTable();
    JPanel jPanel16 = new JPanel();
    //JPanelTabCiclo jPanelTabCiclo = new JPanelTabCiclo();
    
}


class JPanelPlanejamentoIteracoes_jTable1_mouseAdapter extends MouseAdapter {
    private JPanelPlanejamentoIteracoes adaptee;
    JPanelPlanejamentoIteracoes_jTable1_mouseAdapter(
            JPanelPlanejamentoIteracoes adaptee) {
        this.adaptee = adaptee;
        
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTable1_mouseClicked(e);
    }
}


class JPanelPlanejamentoIteracoes_jButtonVisualizar_actionAdapter implements
        ActionListener {
    private JPanelPlanejamentoIteracoes adaptee;
    JPanelPlanejamentoIteracoes_jButtonVisualizar_actionAdapter(
            JPanelPlanejamentoIteracoes adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonVisualizar_actionPerformed(e);
    }
}


class JPanelPlanejamentoIteracoes_jButtonAdicionar_actionAdapter implements
        ActionListener {
    private JPanelPlanejamentoIteracoes adaptee;
    JPanelPlanejamentoIteracoes_jButtonAdicionar_actionAdapter(
            JPanelPlanejamentoIteracoes adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {

        adaptee.jButtonAdicionar_actionPerformed(e);
    }
}


class JPanelPlanejamentoIteracoes_jButtonRemover_actionAdapter implements
        ActionListener {
    private JPanelPlanejamentoIteracoes adaptee;
    JPanelPlanejamentoIteracoes_jButtonRemover_actionAdapter(
            JPanelPlanejamentoIteracoes adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonRemover_actionPerformed(e);
    }
}
