package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.border.Border;

import br.ufsc.fcama.exception.ExceptionStakeholderAlocado;
import br.ufsc.fcama.exception.ExceptionStakeholderJaCadastrado;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.tableModel.TableModelIteracao;
import br.ufsc.fcama.ig.tableModel.TableModelStakeholder;
import br.ufsc.fcama.logica.objAux.Stakeholder;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelProjeto extends JPanel {
    public JPanelProjeto() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private FramePrincipal frame;
    private Stakeholder stakeholder;

    public JPanelProjeto(FramePrincipal frame) {
        try {
            this.frame = frame;
            this.tableModelCiclos = new TableModelIteracao(new ArrayList(this.frame.getControlador().getProjeto().getIteracoes()));
            this.jTableCiclo = new JTable(this.tableModelCiclos);
            this.tableModelStakeholder = new TableModelStakeholder(new ArrayList(this.frame.getControlador().getProjeto().getStakeholders()));
            this.jTableStakeholdres = new JTable(this.tableModelStakeholder);
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public void jButtonEditar_actionPerformed(ActionEvent e) {
        if (this.jTableStakeholdres.getSelectedRow() != -1){
    		this.stakeholder = this.tableModelStakeholder.getStakeholder(this.jTableStakeholdres.getSelectedRow());
    		this.jTextFieldNome.setText(this.stakeholder.getNome());
    		this.jTextFieldFuncao.setText(this.stakeholder.getFuncao());
    	}else{
  		  JOptionPane.showConfirmDialog(this.frame,this.rb.getString("jPanelProjeto.erro.msn.editarSh") ,this.rb.getString("jPanelProjeto.erro.msn.editarSh.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
  	  }
    }

    public void jButtonExcluir_actionPerformed(ActionEvent e) {
        if (this.jTableStakeholdres.getSelectedRow() != -1){
    		try {
				this.frame.getControlador().excluirStakeholder(this.tableModelStakeholder.getStakeholder(this.jTableStakeholdres.getSelectedRow()));
				this.tableModelStakeholder.removeStakeholder(this.jTableStakeholdres.getSelectedRow());
				this.jTableStakeholdres.addNotify();
				this.frame.projetoAlterado();
			} catch (ExceptionStakeholderAlocado e1) {
				JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelProjeto.erro.msn.excluirSh")+ "/n" + e1.getLocalUso() ,this.rb.getString("jPanelProjeto.erro.msn.excluirSh.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
			}
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelProjeto.erro.msn.selecionarSh") ,this.rb.getString("jPanelProjeto.erro.msn.excluirSh.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonSalvar_actionPerformed(ActionEvent e) {
        if (!this.jTextFieldFuncao.getText().trim().equals("")
    			&& !this.jTextFieldNome.getText().trim().equals("") ){
    		try {
	    		if (this.stakeholder != null){
		    		if (this.jTextFieldFuncao.getText().trim().equals(this.stakeholder.getFuncao())
		    				&& this.jTextFieldNome.getText().trim().equals(this.stakeholder.getNome()) ){
		    			this.stakeholder = null;
		    			this.limparCampos();
		    		}else{
		    			this.stakeholder.setNome(this.jTextFieldNome.getText().trim());
		    			this.stakeholder.setFuncao(this.jTextFieldFuncao.getText().trim());
		    			this.jTableStakeholdres.repaint();
		    			this.stakeholder = null;
		    			this.limparCampos();
		    			this.frame.projetoAlterado();
		    		}
		    	}else{
		    		this.stakeholder = new Stakeholder();
		    		this.stakeholder.setNome(this.jTextFieldNome.getText().trim());
		    		this.stakeholder.setFuncao(this.jTextFieldFuncao.getText().trim());
		    		this.frame.getControlador().getProjeto().addStakeholder(this.stakeholder);
					this.tableModelStakeholder.addStakeholder(this.stakeholder);
					this.jTableStakeholdres.addNotify();
					this.stakeholder = null;
		    		this.limparCampos();
		    		this.frame.projetoAlterado();
		    	}
	    	} catch (ExceptionStakeholderJaCadastrado e1) {
	    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelProjeto.erro.msn.jaExiste")  ,this.rb.getString("jPanelProjeto.erro.msn.jaExiste.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
			}
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelProjeto.erro.msn.camposObrigatorios") ,this.rb.getString("jPanelProjeto.erro.msn.camposObrigatorios.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonCancelar_actionPerformed(ActionEvent e) {
        this.limparCampos();
    	this.stakeholder = null;
    }

    public void jTableCiclo_mouseClicked(MouseEvent e) {
    	// no faz nada
    }

    public void jTableStakeholdres_mouseClicked(MouseEvent e) {
    	// no faz nada
    }

    private void limparCampos(){
    	this.jTextFieldNome.setText("");
    	this.jTextFieldFuncao.setText("");
    	this.stakeholder = null;
    }


    private void jbInit() throws Exception {
        this.setInputVerifier(null);
        this.jTableCiclo.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        this.jTableStakeholdres.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        this.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(3);
        jPanel1.setBackground(Color.cyan);
        jPanel1.setLayout(borderLayout1);
        jPanel2.setBackground(Color.green);
        jPanel2.setLayout(borderLayout4);
        jPanel3.setBackground(Color.black);
        jPanel3.setLayout(borderLayout7);
        jPanel5.setLayout(borderLayout2);
        jPanel4.setLayout(borderLayout3);
        jPanel5.setBorder(border2);
        jPanel5.setPreferredSize(new Dimension(2, 2));
        jLabelCiclo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabelCiclo.setText(this.rb.getString("jPanelProjeto.jLabel.iteracoes"));
        jPanel7.setLayout(borderLayout5);
        jPanel9.setBorder(border3);
        jPanel9.setPreferredSize(new Dimension(2, 2));
        jPanel9.setToolTipText("");
        jPanel9.setLayout(borderLayout6);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setText(this.rb.getString("jPanelProjeto.jLabel.sh"));
        jPanel10.setLayout(borderLayout8);
        jPanel11.setBorder(border4);
        jPanel11.setPreferredSize(new Dimension(2, 2));
        jPanel11.setLayout(borderLayout9);
        jLabel2.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel2.setToolTipText("");
        jLabel2.setText(this.rb.getString("jPanelProjeto.jLabel.cadSh"));
        jPanel6.setLayout(gridBagLayout2);
        jPanel8.setLayout(gridBagLayout3);
        jPanel13.setLayout(flowLayout1);
        flowLayout1.setAlignment(FlowLayout.RIGHT);
        jButtonExcluir.setText(this.rb.getString("jPanelProjeto.jButton.excluir"));
        jButtonExcluir.addActionListener(new
                JPanelProjeto_jButtonExcluir_actionAdapter(this));
        jButtonEditar.setText(this.rb.getString("jPanelProjeto.jButton.editar"));
        jButtonEditar.addActionListener(new
                JPanelProjeto_jButtonEditar_actionAdapter(this));
        jScrollPaneStakehlders.setPreferredSize(new Dimension(500, 108));
        jPanel14.setBackground(SystemColor.control);
        jPanel14.setLayout(borderLayout10);
        jTableCiclo.addMouseListener(new JPanelProjeto_jTableCiclo_mouseAdapter(this));
        jTableStakeholdres.addMouseListener(new
                JPanelProjeto_jTableStakeholdres_mouseAdapter(this));
        jPanel12.setLayout(gridBagLayout4);
        jPanel15.setBackground(SystemColor.control);
        jPanel15.setLayout(flowLayout2);
        jPanel16.setBackground(SystemColor.control);
        jPanel16.setLayout(flowLayout3);
        jPanel17.setBackground(SystemColor.control);
        jPanel17.setLayout(flowLayout4);
        jLabelNome.setText(this.rb.getString("jPanelProjeto.jLabel.nome"));
        flowLayout2.setAlignment(FlowLayout.LEFT);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        flowLayout4.setAlignment(FlowLayout.RIGHT);
        jTextFieldNome.setPreferredSize(new Dimension(300, 20));
        jTextFieldNome.setText("");
        jTextFieldFuncao.setPreferredSize(new Dimension(300, 20));
        jTextFieldFuncao.setText("");
        jLabelFuncao.setText(this.rb.getString("jPanelProjeto.jlabel.funcao"));
        jButtonCancelar.setText(this.rb.getString("jPanelProjeto.jButton.cancelar"));
        jButtonCancelar.addActionListener(new
                JPanelProjeto_jButtonCancelar_actionAdapter(this));
        jButtonSalvar.setText(this.rb.getString("jPanelProjeto.jButton.salvar"));
        jButtonSalvar.addActionListener(new
                JPanelProjeto_jButtonSalvar_actionAdapter(this));
        this.add(jPanel1);
        this.add(jPanel2);
        this.add(jPanel3);
        jPanel3.add(jPanel10, java.awt.BorderLayout.NORTH);
        jPanel1.add(jPanel4, java.awt.BorderLayout.NORTH);
        jPanel4.add(jPanel5, java.awt.BorderLayout.SOUTH);
        jPanel4.add(jLabelCiclo, java.awt.BorderLayout.WEST);
        jPanel1.add(jPanel6, java.awt.BorderLayout.CENTER);
        jPanel2.add(jPanel7, java.awt.BorderLayout.NORTH);
        jPanel7.add(jPanel9, java.awt.BorderLayout.SOUTH);
        jPanel7.add(jLabel1, java.awt.BorderLayout.CENTER);
        jPanel10.add(jPanel11, java.awt.BorderLayout.SOUTH);
        jPanel10.add(jLabel2, java.awt.BorderLayout.CENTER);
        jPanel3.add(jPanel12, java.awt.BorderLayout.CENTER);
        jScrollPaneCiclo.getViewport().add(jTableCiclo);
        jPanel6.add(jScrollPaneCiclo,
                    new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.BOTH,
                                           new Insets(17, 50, 17, 51), 50, -291));
        jPanel13.add(jButtonEditar);
        jPanel13.add(jButtonExcluir);
        jPanel14.add(jScrollPaneStakehlders, java.awt.BorderLayout.CENTER);
        jPanel14.add(jPanel13, java.awt.BorderLayout.SOUTH);
        jScrollPaneStakehlders.getViewport().add(jTableStakeholdres);
        jPanel2.add(jPanel8, java.awt.BorderLayout.CENTER);
        jPanel8.add(jPanel14, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(8, 46, 0, 55), 50, -296));
        jPanel16.add(jTextFieldFuncao);
        jPanel15.add(jTextFieldNome);
        jPanel17.add(jButtonSalvar);
        jPanel17.add(jButtonCancelar);
        jPanel12.add(jPanel17, new GridBagConstraints(0, 4, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(8, 50, 12, 50), 347, -1));
        jPanel12.add(jPanel16, new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 50, 0, 50), 190, -3));
        jPanel12.add(jPanel15, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 50, 0, 50), 191, -2));
        jPanel12.add(jLabelFuncao, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 56, 0, 50), 458, 0));
        jPanel12.add(jLabelNome, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(6, 56, 0, 50), 464, 0));
    }

    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel5 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel4 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabelCiclo = new JLabel();
    JPanel jPanel6 = new JPanel();
    Border border2 = BorderFactory.createLineBorder(Color.white, 2);
    BorderLayout borderLayout4 = new BorderLayout();
    JPanel jPanel7 = new JPanel();
    BorderLayout borderLayout5 = new BorderLayout();
    JPanel jPanel8 = new JPanel();
    JPanel jPanel9 = new JPanel();
    Border border3 = BorderFactory.createLineBorder(Color.white, 2);
    BorderLayout borderLayout6 = new BorderLayout();
    JLabel jLabel1 = new JLabel();
    BorderLayout borderLayout7 = new BorderLayout();
    JPanel jPanel10 = new JPanel();
    BorderLayout borderLayout8 = new BorderLayout();
    JPanel jPanel11 = new JPanel();
    Border border4 = BorderFactory.createLineBorder(Color.white, 2);
    BorderLayout borderLayout9 = new BorderLayout();
    JLabel jLabel2 = new JLabel();
    JPanel jPanel12 = new JPanel();
    JScrollPane jScrollPaneCiclo = new JScrollPane();
    TableModelIteracao  tableModelCiclos = new TableModelIteracao(new ArrayList());
    JTable jTableCiclo = new JTable(tableModelCiclos);
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    JScrollPane jScrollPaneStakehlders = new JScrollPane();
    JPanel jPanel13 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JButton jButtonExcluir = new JButton();
    JButton jButtonEditar = new JButton();
    TableModelStakeholder tableModelStakeholder = new TableModelStakeholder(new ArrayList());
    JTable jTableStakeholdres = new JTable(tableModelStakeholder);
    JPanel jPanel14 = new JPanel();
    BorderLayout borderLayout10 = new BorderLayout();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    JPanel jPanel15 = new JPanel();
    JPanel jPanel16 = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();
    FlowLayout flowLayout3 = new FlowLayout();
    JPanel jPanel17 = new JPanel();
    FlowLayout flowLayout4 = new FlowLayout();
    JLabel jLabelNome = new JLabel();
    JTextField jTextFieldNome = new JTextField();
    JTextField jTextFieldFuncao = new JTextField();
    JLabel jLabelFuncao = new JLabel();
    JButton jButtonCancelar = new JButton();
    JButton jButtonSalvar = new JButton();
    GridBagLayout gridBagLayout4 = new GridBagLayout();



}





class JPanelProjeto_jButtonCancelar_actionAdapter implements ActionListener {
    private JPanelProjeto adaptee;
    JPanelProjeto_jButtonCancelar_actionAdapter(JPanelProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancelar_actionPerformed(e);
    }
}





class JPanelProjeto_jButtonSalvar_actionAdapter implements ActionListener {
    private JPanelProjeto adaptee;
    JPanelProjeto_jButtonSalvar_actionAdapter(JPanelProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonSalvar_actionPerformed(e);
    }
}





class JPanelProjeto_jButtonExcluir_actionAdapter implements ActionListener {
    private JPanelProjeto adaptee;
    JPanelProjeto_jButtonExcluir_actionAdapter(JPanelProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonExcluir_actionPerformed(e);
    }
}





class JPanelProjeto_jButtonEditar_actionAdapter implements ActionListener {
    private JPanelProjeto adaptee;
    JPanelProjeto_jButtonEditar_actionAdapter(JPanelProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonEditar_actionPerformed(e);
    }
}


class JPanelProjeto_jTableStakeholdres_mouseAdapter extends MouseAdapter {
    private JPanelProjeto adaptee;
    JPanelProjeto_jTableStakeholdres_mouseAdapter(JPanelProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableStakeholdres_mouseClicked(e);
    }
}


class JPanelProjeto_jTableCiclo_mouseAdapter extends MouseAdapter {
    private JPanelProjeto adaptee;
    JPanelProjeto_jTableCiclo_mouseAdapter(JPanelProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableCiclo_mouseClicked(e);
    }
}
