package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.UIManager;

import br.ufsc.fcama.ig.objAux.DateChooser;
import br.ufsc.fcama.ig.tableModel.TableModelRequisitos;
import br.ufsc.fcama.logica.Controlador;
import br.ufsc.fcama.logica.objAux.Requisito;
import br.ufsc.fcama.logica.Iteracao;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelTabIteracao extends JPanel {
    protected TableModelRequisitos model ;
    private Controlador controlador;
    protected Iteracao ciclo;
    private JPanelPlanejamentoIteracoes panelPlan;
    private DateChooser dtChooser;
    private SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy" );
    private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");

    public JPanelTabIteracao(Iteracao ciclo,JPanelPlanejamentoIteracoes panelPlan, Controlador controlador) {
        try {
            this.controlador = controlador;
            this.ciclo = ciclo;
            this.panelPlan = panelPlan;
            this.setCampos();
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    protected void addRequisito(Requisito requisito){
    	requisito.setNuCincloDeDesenvolvimento(this.ciclo.getNumero());
    	this.model.addRequisito(requisito);
    	this.jTable1.addNotify();
    }

    protected Requisito removerRequisito(){
    	Requisito requisito = this.model.removeRequisito(this.jTable1.getSelectedRow());
    	requisito.setNuCincloDeDesenvolvimento(0);
    	this.jTable1.addNotify();
    	return requisito;
    }

    private void setCampos(){
    	this.model = new TableModelRequisitos(3,this.ciclo.getNumero(), new ArrayList( this.controlador.getProjeto().getRequisitosDoProjeto()),
        		new ArrayList());
        this.jTable1 = new JTable(this.model);
        this.dtChooser = new DateChooser(this.panelPlan.frame, "Data");

        this.jTextFieldInicioPrevisto.setText( this.ciclo.getDtInicioPrevista() == null ? "" : this.format.format(this.ciclo.getDtInicioPrevista()));
        this.jTextFieldFimPrevisto.setText( this.ciclo.getDtFimPrevista() == null ? "" : this.format.format(this.ciclo.getDtFimPrevista()));
        this.jTextFieldInicioEfetivo.setText(this.ciclo.getDtInicioEfetiva() == null ? "" : this.format.format(this.ciclo.getDtInicioEfetiva()));
        this.jTextFieldFimEfetivo.setText(this.ciclo.getDtFimEfetiva() == null ? "" : this.format.format(this.ciclo.getDtFimEfetiva()));
        if(this.ciclo.getDtInicioPrevista() == null){
        	this.jButtonFimPrevisto.setEnabled(false);
        }
    }


    public void jButtonInicioPrevisto_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelTabIteracao.dtChooser.titulo1"));
    	Point point = this.jButtonInicioPrevisto.getLocationOnScreen();
    	point.setLocation(point.x - 120, point.y - 200 );
    	this.dtChooser.setLocation(point);
    	Date dtInicio = this.dtChooser.select(this.ciclo.getDtInicioPrevista() == null ? new Date() : this.ciclo.getDtInicioPrevista());
    	if (dtInicio !=  null){
    		Date dtFim = this.ciclo.getDtFimPrevista();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.ciclo.setDtInicioPrevista(dtInicio);
    			this.jButtonFimPrevisto.setEnabled(true);
    			this.jTextFieldInicioPrevisto.setText(this.format.format(dtInicio));
    			this.panelPlan.frame.projetoAlterado();
    		}else{
    			 JOptionPane.showConfirmDialog(this.panelPlan.frame, this.rb.getString("jPanelTabIteracao.erro.dt1.msn") ,this.rb.getString("jPanelTabIteracao.erro.dt1.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonFimPrevisto_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelTabIteracao.dtChooser.titulo2"));
    	Point point = this.jButtonFimPrevisto.getLocationOnScreen();
    	point.setLocation(point.x - 120, point.y - 200 );
    	this.dtChooser.setLocation(point);
    	Date dtFim = this.dtChooser.select(this.ciclo.getDtFimPrevista() == null ? new Date() : this.ciclo.getDtFimPrevista());
    	if (dtFim !=  null){
    		Date dtInicio = this.ciclo.getDtInicioPrevista();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.ciclo.setDtFimPrevista(dtFim);
    			this.jTextFieldFimPrevisto.setText(this.format.format(dtFim));
    		}else{
    			 JOptionPane.showConfirmDialog(this.panelPlan.frame, this.rb.getString("jPanelTabIteracao.erro.dt2.msn") ,this.rb.getString("jPanelTabIteracao.erro.dt2.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonInicioEfetivo_actionPerformed(ActionEvent e) {

    }

    public void jButtonFimEfetivo_actionPerformed(ActionEvent e) {

    }

    public void jTable1_mouseClicked(MouseEvent e) {
    	if (e.getClickCount() == 2 && this.jTable1.getSelectedRow() != -1){
    		this.panelPlan.visualizar(this.model.getRequisito(this.jTable1.getSelectedRow()));
    	}else if (e.getClickCount() == 1 && this.jTable1.getSelectedRow() != -1) {
    		this.panelPlan.jTable1.clearSelection();
    	}
    }



    public void jTable1_mouseDragged(MouseEvent e) {
    }


    private void jbInit() throws Exception {
    	this.jButtonInicioEfetivo.setEnabled(false);
    	this.jButtonFimEfetivo.setEnabled(false);
        this.setLayout(borderLayout1);
        this.setBackground(SystemColor.textHighlight);
        this.setPreferredSize(new Dimension(600, 200));
        jPanel1.setBackground(Color.pink);
        jPanel1.setToolTipText("");
        jPanel1.setLayout(borderLayout3);
        jPanel2.setLayout(borderLayout2);
        jPanel2.setBackground(Color.pink);
        jPanel2.setPreferredSize(new Dimension(400, 200));
        jPanel2.setToolTipText("");
        jPanel10.setBackground(SystemColor.control);
        jPanel10.setToolTipText("");
        jPanel10.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(4);
        jPanel11.setLayout(gridBagLayout1);
        jPanel12.setLayout(gridBagLayout2);
        jPanel13.setLayout(gridBagLayout3);
        jPanel14.setLayout(gridBagLayout4);
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("jPanelTabIteracao.label.inicioPrevisto"));
        jTextFieldInicioPrevisto.setPreferredSize(new Dimension(119, 20));
        jTextFieldInicioPrevisto.setEditable(false);
        jPanel11.setBackground(UIManager.getColor("control"));
        jPanel12.setBackground(SystemColor.control);
        jPanel13.setBackground(UIManager.getColor("control"));
        jPanel14.setBackground(UIManager.getColor("control"));
        jButtonInicioPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setIcon(iconDate);
        jButtonInicioPrevisto.setText("");
        jButtonInicioPrevisto.addActionListener(new
                JPanelTabCiclo_jButtonInicioPrevisto_actionAdapter(this));
        jLabel2.setText(this.rb.getString("jPanelTabIteracao.label.fimPrevisto"));
        jTextFieldFimPrevisto.setPreferredSize(new Dimension(119, 20));
        jTextFieldFimPrevisto.setEditable(false);
        jButtonFimPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonFimPrevisto.setIcon(iconDate);
        jButtonFimPrevisto.addActionListener(new
                JPanelTabCiclo_jButtonFimPrevisto_actionAdapter(this));
        jLabel3.setText(this.rb.getString("jPanelTabIteracao.label.inicioEfetivo"));
        jLabel4.setText(this.rb.getString("jPanelTabIteracao.label.fimEfetivo"));
        jTextFieldInicioEfetivo.setPreferredSize(new Dimension(119, 20));
        jTextFieldInicioEfetivo.setEditable(false);
        jButtonInicioEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setIcon(iconDate);
        jButtonInicioEfetivo.setText("");
        jButtonInicioEfetivo.addActionListener(new
                JPanelTabCiclo_jButtonInicioEfetivo_actionAdapter(this));
        jTextFieldFimEfetivo.setPreferredSize(new Dimension(119, 20));
        jTextFieldFimEfetivo.setEditable(false);
        jTextFieldFimEfetivo.setText("");
        jButtonFimEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonFimEfetivo.setToolTipText("");
        jButtonFimEfetivo.setIcon(iconDate);
        jButtonFimEfetivo.setText("");
        jButtonFimEfetivo.addActionListener(new
                JPanelTabCiclo_jButtonFimEfetivo_actionAdapter(this));
        jTable1.addMouseListener(new JPanelTabCiclo_jTable1_mouseAdapter(this));
        jTable1.addMouseMotionListener(new
                JPanelTabCiclo_jTable1_mouseMotionAdapter(this));
        this.add(jPanel1, java.awt.BorderLayout.EAST);
        jPanel1.add(jPanel7, java.awt.BorderLayout.NORTH);
        jPanel1.add(jPanel8, java.awt.BorderLayout.EAST);
        jPanel1.add(jPanel9, java.awt.BorderLayout.SOUTH);
        jPanel1.add(jPanel10, java.awt.BorderLayout.CENTER);
        jPanel10.add(jPanel11);
        jPanel10.add(jPanel12);
        jPanel10.add(jPanel13);
        jPanel10.add(jPanel14);
        this.add(jPanel2, java.awt.BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jTable1);
        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jPanel2.add(jPanel3, java.awt.BorderLayout.WEST);
        jPanel2.add(jPanel4, java.awt.BorderLayout.NORTH);
        jPanel2.add(jPanel5, java.awt.BorderLayout.EAST);
        jPanel2.add(jPanel6, java.awt.BorderLayout.SOUTH);

        jPanel11.add(jTextFieldInicioPrevisto,
                     new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.HORIZONTAL,
                                            new Insets(0, 6, 9, 0), 0, 0));
        jPanel11.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(8, 6, 0, 49), 0, 0));
        jPanel12.add(jLabel2, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(8, 6, 0, 57), 0, 0));
        jPanel12.add(jTextFieldFimPrevisto,
                     new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.HORIZONTAL,
                                            new Insets(0, 6, 9, 0), 0, 0));
        jPanel13.add(jLabel3, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(8, 6, 0, 55), 0, 0));
        jPanel13.add(jTextFieldInicioEfetivo,
                     new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.HORIZONTAL,
                                            new Insets(0, 6, 9, 0), 0, 0));
        jPanel13.add(jButtonInicioEfetivo,
                     new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.NONE,
                                            new Insets(0, 0, 9, 43), 0, 0));
        jPanel14.add(jLabel4, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(8, 6, 0, 55), 0, 0));
        jPanel14.add(jTextFieldFimEfetivo,
                     new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.HORIZONTAL,
                                            new Insets(0, 6, 9, 0), 0, 0));
        jPanel14.add(jButtonFimEfetivo,
                     new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.NONE,
                                            new Insets(0, 0, 9, 43), 0, 0));
        jPanel12.add(jButtonFimPrevisto,
                     new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.NONE,
                                            new Insets(0, 0, 9, 43), 0, 0));
        jPanel11.add(jButtonInicioPrevisto,
                     new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                            , GridBagConstraints.WEST,
                                            GridBagConstraints.NONE,
                                            new Insets(0, 0, 9, 43), 0, 0));
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    JPanel jPanel6 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    JPanel jPanel7 = new JPanel();
    JPanel jPanel8 = new JPanel();
    JPanel jPanel9 = new JPanel();
    JPanel jPanel10 = new JPanel();
    JTable jTable1 = new JTable(new TableModelRequisitos(5, new ArrayList(), new ArrayList()));
    JScrollPane jScrollPane1 = new JScrollPane();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel11 = new JPanel();
    JPanel jPanel12 = new JPanel();
    JPanel jPanel13 = new JPanel();
    JPanel jPanel14 = new JPanel();
    JLabel jLabel1 = new JLabel();
    JTextField jTextFieldInicioPrevisto = new JTextField();
    JButton jButtonInicioPrevisto = new JButton();
    JLabel jLabel2 = new JLabel();
    JTextField jTextFieldFimPrevisto = new JTextField();
    JButton jButtonFimPrevisto = new JButton();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JTextField jTextFieldInicioEfetivo = new JTextField();
    JButton jButtonInicioEfetivo = new JButton();
    JTextField jTextFieldFimEfetivo = new JTextField();
    JButton jButtonFimEfetivo = new JButton();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    GridBagLayout gridBagLayout4 = new GridBagLayout();
    Icon iconDate = new ImageIcon("imagens/date.gif");


}


class JPanelTabCiclo_jTable1_mouseMotionAdapter extends MouseMotionAdapter {
    private JPanelTabIteracao adaptee;
    JPanelTabCiclo_jTable1_mouseMotionAdapter(JPanelTabIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseDragged(MouseEvent e) {
        adaptee.jTable1_mouseDragged(e);
    }
}


class JPanelTabCiclo_jTable1_mouseAdapter extends MouseAdapter {
    private JPanelTabIteracao adaptee;
    JPanelTabCiclo_jTable1_mouseAdapter(JPanelTabIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTable1_mouseClicked(e);
    }
}


class JPanelTabCiclo_jButtonFimEfetivo_actionAdapter implements ActionListener {
    private JPanelTabIteracao adaptee;
    JPanelTabCiclo_jButtonFimEfetivo_actionAdapter(JPanelTabIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonFimEfetivo_actionPerformed(e);
    }
}


class JPanelTabCiclo_jButtonInicioEfetivo_actionAdapter implements
        ActionListener {
    private JPanelTabIteracao adaptee;
    JPanelTabCiclo_jButtonInicioEfetivo_actionAdapter(JPanelTabIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonInicioEfetivo_actionPerformed(e);
    }
}


class JPanelTabCiclo_jButtonFimPrevisto_actionAdapter implements ActionListener {
    private JPanelTabIteracao adaptee;
    JPanelTabCiclo_jButtonFimPrevisto_actionAdapter(JPanelTabIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonFimPrevisto_actionPerformed(e);
    }
}


class JPanelTabCiclo_jButtonInicioPrevisto_actionAdapter implements
        ActionListener {
    private JPanelTabIteracao adaptee;
    JPanelTabCiclo_jButtonInicioPrevisto_actionAdapter(JPanelTabIteracao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonInicioPrevisto_actionPerformed(e);
    }
}

