package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.JTree;
import javax.swing.border.Border;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreePath;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Iteracao;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.atividade.Atividade;
import br.ufsc.fcama.logica.pratica.Pratica;
import br.ufsc.fcama.logica.pratica.PraticaDistribuicaoDosRequisitos;
import br.ufsc.fcama.logica.pratica.PraticaDocumentacaoDetalhada;
import br.ufsc.fcama.logica.pratica.PraticaImplementacao;
import br.ufsc.fcama.logica.pratica.PraticaListaDeRequisitos;
import br.ufsc.fcama.logica.pratica.PraticaPlanejamentoDasIteracoes;
import br.ufsc.fcama.logica.pratica.PraticaUserStories;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelTree extends JPanel {

    private FramePrincipal frame;
    public Object atual;
    private HashMap mensagens;
    private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");

    public JPanelTree(FramePrincipal frame , Projeto projeto) {
        try {
            this.frame = frame;
            if (projeto != null){
                this.setProjeto(projeto);
            }
            jbInit();
        
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        try {
			mensagens = this.frame.persistencia.getMensagens();
		} catch (Exception e) {
			this.mensagens = new HashMap();
			e.printStackTrace();
		} 
    }

    private void jbInit() throws Exception {
        this.setPreferredSize(new Dimension(200, 600));
        this.setLayout(borderLayout1);
        jPanelDescricao.setBorder(border1);
        jPanelDescricao.setPreferredSize(new Dimension(200, 200));
        jPanelDescricao.setToolTipText("");
        jPanelDescricao.setLayout(borderLayout2);
        jPanelTree.setLayout(borderLayout3);
        jPanelTree.setBorder(border2);
        jTree1.addMouseListener(new JPanelTree_jTree1_mouseAdapter(this));
        jTree1.addTreeSelectionListener(new
                                        JPanelTree_jTree1_treeSelectionAdapter(this));
        jTextPaneDescricaoAtividade.setBackground(Color.white);
        jTextPaneDescricaoAtividade.setFont(new java.awt.Font("Default",
                Font.PLAIN, 12));
        jTextPaneDescricaoAtividade.setRequestFocusEnabled(false);
        jTextPaneDescricaoAtividade.setToolTipText("");
        jTextPaneDescricaoAtividade.setDisabledTextColor(Color.white);
        jTextPaneDescricaoAtividade.setEditable(false);
        jTextPaneDescricaoAtividade.setText(
                "");
        this.add(jPanelDescricao, java.awt.BorderLayout.SOUTH);
        jPanelDescricao.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jTextPaneDescricaoAtividade);
        this.add(jPanelTree, java.awt.BorderLayout.CENTER);
        jPanelTree.add(jScrollPaneTree, java.awt.BorderLayout.CENTER);
        jScrollPaneTree.getViewport().add(jTree1);
    }

    public void jTree1_mouseClicked(MouseEvent e) {
    	if (e.getClickCount() == 2 && ! this.jTree1.isSelectionEmpty() ){
    		TreePath path = this.jTree1.getSelectionPath();
    		Object[] objetos = path.getPath();
    		if(((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject() != this.atual){
	    		if(((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass()  == PraticaListaDeRequisitos.class){
                          this.setPanelListaDeRequisitos(objetos);
                      }else if(((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass()  == PraticaUserStories.class){
                         this.setPanelUserStories(objetos);
                     }else if(((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass()  == PraticaPlanejamentoDasIteracoes.class){
                        this.setPanelPlanejamentoIteracoes(objetos);
                    }else if(((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass()  == PraticaDistribuicaoDosRequisitos.class){
                                this.setPanelDistribucaoRequisitos(objetos);
                    }else /*if(((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass()  == AtividadeDuracaoDasIteracoes.class){
                                this.setPanelDuracaoIteracao(objetos);
                    }else */if (((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass() == PraticaImplementacao.class){
                    		this.setPanelDesenvolverIncremento(objetos);
                    }else if (((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass() == PraticaDocumentacaoDetalhada.class){
                    		this.setDocumentacaoDetalhada(objetos);
                    }else if (((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass().getSuperclass() == Pratica.class){
                                this.setPanelAtividades(objetos);
                    }else if (((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass() == Projeto.class) {
	                        this.setPanelProjeto();
	            }else if (((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass().getSuperclass() == Atividade.class){
	                this.setPanelEtapa((Atividade)((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject());
                    }else if (((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass() == Iteracao.class){
                         this.setPanelCicloDesenvolvimento(objetos);
                    }else if ( ((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass()== String.class && ((String)((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject()).equals(this.rb.getString("jPanelTree.iteracoes"))){
	                this.frame.setAreaDeTrabalho(this.rb.getString("jPanelTree.iteracoes"), new JPanelImagem("SemDestaque.gif"));
	            }
	    		this.atual = ((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject() ;
	    		String mensagem = (String)this.mensagens.get(((DefaultMutableTreeNode)objetos[(objetos.length - 1)]).getUserObject().getClass());
	    		this.jTextPaneDescricaoAtividade.setText(mensagem == null ? "" : mensagem);
    		}
    	}

    }
    private void setPanelCicloDesenvolvimento(Object[] objetos){
        Object[] obj = new Object[objetos.length];
          for (int i = 0 ; i < objetos.length; i++){
            obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
          }

        this.frame.setAreaDeTrabalho(  obj[(obj.length - 1)].toString(),
                                new JPanelIteracao(this.frame, (Iteracao)obj[(obj.length - 1)]));
    }

    private void setPanelDesenvolverIncremento(Object[] objetos){
        Object[] obj = new Object[objetos.length];
          for (int i = 0 ; i < objetos.length; i++){
            obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
          }

        this.frame.setAreaDeTrabalho( "Atividade"+" " +   obj[(obj.length - 1)].toString(),
                                new JPanelDesenvolverIncremento(this.frame, obj));
    }



    /*private void setPanelDuracaoIteracao(Object[] objetos){
        Object[] obj = new Object[objetos.length];
          for (int i = 0 ; i < objetos.length; i++){
            obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
          }

        this.frame.setAreaDeTrabalho( "Atividade"+" " + obj[(obj.length - 1)].toString(),
                                new JPanelDuracaoIteracao());
    }*/


    private void setPanelDistribucaoRequisitos(Object[] objetos){
        Object[] obj = new Object[objetos.length];
          for (int i = 0 ; i < objetos.length; i++){
            obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
          }

        this.frame.setAreaDeTrabalho( this.rb.getString("jPanelTree.pratica")+" " + obj[(obj.length - 1)].toString(),
				new JPanelDistribuicaoRequisitos(this.frame, obj));
    }

    private void setPanelEtapa(Atividade etapa){
        this.frame.setAreaDeTrabalho(this.rb.getString("jPanelTree.atividade") + etapa.toString(), new JPanelImagem(etapa.toString() + ".gif"));
    }
    private void setPanelAtividades(Object[] objetos){
    	Object[] obj = new Object[objetos.length];
		for (int i = 0 ; i < objetos.length; i++){
			obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
		}
		this.frame.setAreaDeTrabalho(  this.rb.getString("jPanelTree.pratica")+" " + obj[(obj.length - 1)].toString(),
				new JPanelAnexos(this.frame,obj));
    }

    private void setPanelProjeto(){
        this.frame.setAreaDeTrabalho(this.rb.getString("jPanelTree.projeto") + this.frame.getControlador().getProjeto().getNomeProjeto(), new JPanelProjeto(this.frame));
    }

    private void setPanelUserStories(Object[] objetos){
        Object[] obj = new Object[objetos.length];
                for (int i = 0 ; i < objetos.length; i++){
                        obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
                }
                this.frame.setAreaDeTrabalho(  this.rb.getString("jPanelTree.pratica")+" " + obj[(obj.length - 1)].toString(),
                                new JPanelUserStories(this.frame, obj));

    }


    private void setPanelListaDeRequisitos(Object[] objetos){
        Object[] obj = new Object[objetos.length];
                for (int i = 0 ; i < objetos.length; i++){
                        obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
                }
                this.frame.setAreaDeTrabalho(  this.rb.getString("jPanelTree.pratica")+" " + obj[(obj.length - 1)].toString(),
                                new JPanelRequisitos(this.frame, obj));

    }
    
    private void setDocumentacaoDetalhada(Object[] objetos){
        Object[] obj = new Object[objetos.length];
                for (int i = 0 ; i < objetos.length; i++){
                        obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
                }
                this.frame.setAreaDeTrabalho(  this.rb.getString("jPanelTree.pratica")+" " + obj[(obj.length - 1)].toString(),
                                new JPanelDocumentacaoDetalhada(this.frame, obj));

    }

    private void setPanelPlanejamentoIteracoes(Object[] objetos){
        Object[] obj = new Object[objetos.length];
                for (int i = 0 ; i < objetos.length; i++){
                        obj[i] = ((DefaultMutableTreeNode)objetos[i]).getUserObject();
                }
                this.frame.setAreaDeTrabalho( this.rb.getString("jPanelTree.pratica")+" " + obj[(obj.length - 1)].toString(),
                                new JPanelPlanejamentoIteracoes(this.frame, obj));

    }


    public void jTree1_valueChanged(TreeSelectionEvent e) {

    }

    public void setProjeto(Projeto projeto){

        //######################################################################
        DefaultMutableTreeNode root = new DefaultMutableTreeNode(projeto);

        //Etapa Definio dos Requisitos
        DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(projeto.getAtividadeDefinicaoDosRequisitos());
        root.add(node1);
          if (projeto.getAtividadeDefinicaoDosRequisitos().getPraticaUserStories().isSelecionada()){
              DefaultMutableTreeNode node11 = new DefaultMutableTreeNode(projeto.
                      getAtividadeDefinicaoDosRequisitos().getPraticaUserStories());
              node1.add(node11);
          }
          if (projeto.getAtividadeDefinicaoDosRequisitos().getPraticaListaDeRequisitos().isSelecionada()){
              DefaultMutableTreeNode node12 = new DefaultMutableTreeNode(projeto.
                      getAtividadeDefinicaoDosRequisitos().getPraticaListaDeRequisitos());
              node1.add(node12);
          }
          if (projeto.getAtividadeDefinicaoDosRequisitos().getPraticaDocumentacaoDetalhada().isSelecionada()){
              DefaultMutableTreeNode node13 = new DefaultMutableTreeNode(projeto.
                      getAtividadeDefinicaoDosRequisitos().getPraticaDocumentacaoDetalhada());
              node1.add(node13);
          }
          if (projeto.getAtividadeDefinicaoDosRequisitos().getPraticaOrganizacaoDaDocumentacao().isSelecionada()){
              DefaultMutableTreeNode node14 = new DefaultMutableTreeNode(projeto.
                      getAtividadeDefinicaoDosRequisitos().getPraticaOrganizacaoDaDocumentacao());
              node1.add(node14);
          }
        //Etapa Atribuio dos Requisitos
        DefaultMutableTreeNode node2 = new DefaultMutableTreeNode(projeto.getAtividadeAtribuicaoDosRequisitos());
        root.add(node2);
          if (projeto.getAtividadeAtribuicaoDosRequisitos().getPraticaPlanejamentoDasIteracoes().isSelecionada()){
              DefaultMutableTreeNode node21 = new DefaultMutableTreeNode(projeto.
                      getAtividadeAtribuicaoDosRequisitos().getPraticaPlanejamentoDasIteracoes());
              node2.add(node21);
          }
          if (projeto.getAtividadeAtribuicaoDosRequisitos().getPraticaDuracaoDasIteracoes().isSelecionada()){
              DefaultMutableTreeNode node22 = new DefaultMutableTreeNode(projeto.
                      getAtividadeAtribuicaoDosRequisitos().getPraticaDuracaoDasIteracoes());
              node2.add(node22);
          }
          if (projeto.getAtividadeAtribuicaoDosRequisitos().getPraticaDistribuicaoDosRequisitos().isSelecionada()){
              DefaultMutableTreeNode node23 = new DefaultMutableTreeNode(projeto.
                      getAtividadeAtribuicaoDosRequisitos().getPraticaDistribuicaoDosRequisitos());
              node2.add(node23);
          }
          if (projeto.getAtividadeAtribuicaoDosRequisitos().getPraticaAtualizacaoDaDocumentacao().isSelecionada()){
              DefaultMutableTreeNode node24 = new DefaultMutableTreeNode(projeto.
                      getAtividadeAtribuicaoDosRequisitos().getPraticaAtualizacaoDaDocumentacao());
              node2.add(node24);
          }
        //Etapa  Projeto do Sistema
        DefaultMutableTreeNode node3 = new DefaultMutableTreeNode(projeto.getAtividadeProjetoDoSistema());
        root.add(node3);
          if (projeto.getAtividadeProjetoDoSistema().getPraticaProjetoGeral().isSelecionada()){
              DefaultMutableTreeNode node31 = new DefaultMutableTreeNode(projeto.
                      getAtividadeProjetoDoSistema().getPraticaProjetoGeral());
              node3.add(node31);
          }
           if (projeto.getAtividadeProjetoDoSistema().getPraticaProjetoDetalhado().isSelecionada()){
               DefaultMutableTreeNode node32 = new DefaultMutableTreeNode(projeto.
                       getAtividadeProjetoDoSistema().getPraticaProjetoDetalhado());
               node3.add(node32);
           }
           if (projeto.getAtividadeProjetoDoSistema().getPraticaDocumentacaoDoProjeto().isSelecionada()){
               DefaultMutableTreeNode node33 = new DefaultMutableTreeNode(projeto.
                       getAtividadeProjetoDoSistema().getPraticaDocumentacaoDoProjeto());
               node3.add(node33);
           }
        //###### Ciclos de Desenvolvimentos ###############
        DefaultMutableTreeNode  node4 = new DefaultMutableTreeNode(this.rb.getString("jPanelTree.iteracoes"));
        root.add(node4);
        ArrayList ciclosDeDesenvolvimento  = projeto.getIteracoes();
        Iterator it = ciclosDeDesenvolvimento.iterator();
        Iteracao ciclo = null;
        while(it.hasNext()){
            ciclo = (Iteracao)it.next();

            ////////// Ciclo de Desenvolvimento
            DefaultMutableTreeNode node41 = new DefaultMutableTreeNode(ciclo);
            node4.add(node41);
              // Etapa Desenvolvimento incremental do Sistema
              DefaultMutableTreeNode node411 = new DefaultMutableTreeNode(ciclo.getAtividadeDesenvolverIncrementoDoSistema());
              node41.add(node411);
                if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaImplementacao().isSelecionada()){
                    DefaultMutableTreeNode node4111 = new DefaultMutableTreeNode(ciclo.
                            getAtividadeDesenvolverIncrementoDoSistema().getPraticaImplementacao());
                    node411.add(node4111);
                }
               if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaEscritaDosTestesAntesDaImplementacao().isSelecionada()){
                   DefaultMutableTreeNode node4112 = new DefaultMutableTreeNode(ciclo.
                           getAtividadeDesenvolverIncrementoDoSistema().getPraticaEscritaDosTestesAntesDaImplementacao());
                   node411.add(node4112);
               }
               if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoColetivo().isSelecionada()){
                   DefaultMutableTreeNode node4113 = new DefaultMutableTreeNode(ciclo.
                           getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoColetivo());
                   node411.add(node4113);
               }
                if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoEmDuplas().isSelecionada()){
                    DefaultMutableTreeNode node4114 = new DefaultMutableTreeNode(ciclo.
                            getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoEmDuplas());
                    node411.add(node4114);
                }
                if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoLadoALado().isSelecionada()){
                    DefaultMutableTreeNode node4115 = new DefaultMutableTreeNode(ciclo.
                            getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoLadoALado());
                    node411.add(node4115);
                }
               if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaRefactoring().isSelecionada()){
                   DefaultMutableTreeNode node4116 = new DefaultMutableTreeNode(ciclo.
                           getAtividadeDesenvolverIncrementoDoSistema().getPraticaRefactoring());
                   node411.add(node4116);
               }
              if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaReunioesDiarias().isSelecionada()){
                  DefaultMutableTreeNode node4117 = new DefaultMutableTreeNode(ciclo.
                          getAtividadeDesenvolverIncrementoDoSistema().getPraticaReunioesDiarias());
                  node411.add(node4117);
              }
               if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoSimultaneo().isSelecionada()){
                   DefaultMutableTreeNode node4118 = new DefaultMutableTreeNode(ciclo.
                           getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoSimultaneo());
                   node411.add(node4118);
               }
               if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaIntegracaoParalela().isSelecionada()){
                   DefaultMutableTreeNode node4119 = new DefaultMutableTreeNode(ciclo.
                           getAtividadeDesenvolverIncrementoDoSistema().getPraticaIntegracaoParalela());
                   node411.add(node4119);
               }
               if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDocumentacaoDoDesenvolvimento().isSelecionada()){
                   DefaultMutableTreeNode node41110 = new DefaultMutableTreeNode(ciclo.
                           getAtividadeDesenvolverIncrementoDoSistema().getPraticaDocumentacaoDoDesenvolvimento());
                   node411.add(node41110);
               }
               if (ciclo.getAtividadeDesenvolverIncrementoDoSistema().getPraticaControleDeVersoes().isSelecionada()){
                   DefaultMutableTreeNode node41111 = new DefaultMutableTreeNode(ciclo.
                           getAtividadeDesenvolverIncrementoDoSistema().getPraticaControleDeVersoes());
                   node411.add(node41111);
               }
              //Etapa Validar Incremento
              DefaultMutableTreeNode node412 = new DefaultMutableTreeNode(ciclo.getAtividadeValidarIncremento());
              node41.add(node412);
                 if (ciclo.getAtividadeValidarIncremento().getPraticaIntegracaoAntesDaValidacao().isSelecionada()){
                     DefaultMutableTreeNode node4121 = new DefaultMutableTreeNode(ciclo.
                             getAtividadeValidarIncremento().getPraticaIntegracaoAntesDaValidacao());
                     node412.add(node4121);
                 }
                if (ciclo.getAtividadeValidarIncremento().getPraticaExecucaoDosTestes().isSelecionada()){
                    DefaultMutableTreeNode node4122 = new DefaultMutableTreeNode(ciclo.
                            getAtividadeValidarIncremento().getPraticaExecucaoDosTestes());
                    node412.add(node4122);
                }
                if (ciclo.getAtividadeValidarIncremento().getPraticaInspecaoDeCodigo().isSelecionada()){
                    DefaultMutableTreeNode node4123 = new DefaultMutableTreeNode(ciclo.
                            getAtividadeValidarIncremento().getPraticaInspecaoDeCodigo());
                    node412.add(node4123);
                }
              //Etapa Integra Incremento
               if (ciclo.getAtividadeIntegracaoIncremento().getPraticaIntegracaoDepoisDaValidacao().isSelecionada()){
                   DefaultMutableTreeNode node413 = new DefaultMutableTreeNode(ciclo.getAtividadeIntegracaoIncremento());
                   node41.add(node413);
                     DefaultMutableTreeNode node4131 = new DefaultMutableTreeNode(ciclo.getAtividadeIntegracaoIncremento().getPraticaIntegracaoDepoisDaValidacao());
                     node413.add(node4131);
               }
              //Etapa Validar Sistema
              DefaultMutableTreeNode node414 = new DefaultMutableTreeNode(ciclo.getAtividadeValidarSistema());
              node41.add(node414);
                if (ciclo.getAtividadeValidarSistema().getPraticaReuniaoDeRevisao().isSelecionada()){
                    DefaultMutableTreeNode node4141 = new DefaultMutableTreeNode(ciclo.
                            getAtividadeValidarSistema().getPraticaReuniaoDeRevisao());
                    node414.add(node4141);
                }
                 if (ciclo.getAtividadeValidarSistema().getPraticaColocarSistemaEmOperacao().isSelecionada()){
                     DefaultMutableTreeNode node4142 = new DefaultMutableTreeNode(ciclo.
                             getAtividadeValidarSistema().getPraticaColocarSistemaEmOperacao());
                     node414.add(node4142);
                 }
        }
        // ########

        //Etapa Entrega Final
        DefaultMutableTreeNode node5 = new DefaultMutableTreeNode(projeto.getAtividadeEntregaFinal());
        root.add(node5);
          if (projeto.getAtividadeEntregaFinal().getPraticaEntregaDoSistema().isSelecionada()){
              DefaultMutableTreeNode node51 = new DefaultMutableTreeNode(projeto.
                      getAtividadeEntregaFinal().getPraticaEntregaDoSistema());
              node5.add(node51);
          }
          if (projeto.getAtividadeEntregaFinal().getPraticaBreveDocumentacao().isSelecionada()){
              DefaultMutableTreeNode node52 = new DefaultMutableTreeNode(projeto.
                      getAtividadeEntregaFinal().getPraticaBreveDocumentacao());
              node5.add(node52);
          }
          if (projeto.getAtividadeEntregaFinal().getPraticaRefinamentoDaDocumentacao().isSelecionada()){
              DefaultMutableTreeNode node53 = new DefaultMutableTreeNode(projeto.
                      getAtividadeEntregaFinal().getPraticaRefinamentoDaDocumentacao());
              node5.add(node53);
          }if (projeto.getAtividadeEntregaFinal().getPraticaElaboracaoDoManual().isSelecionada()){
              DefaultMutableTreeNode node54 = new DefaultMutableTreeNode(projeto.
                      getAtividadeEntregaFinal().getPraticaElaboracaoDoManual());
              node5.add(node54);
          }
        //######################################################################
        this.jTree1 = new JTree(root);
        this.renderer.setOpenIcon(this.iconLogo);
        this.renderer.setClosedIcon(this.iconLogo);
        this.renderer.setLeafIcon(this.IconAtividade);
        this.jTree1.setCellRenderer(this.renderer);

        this.jTree1.setRootVisible(true);

    }


    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelDescricao = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanelTree = new JPanel();
    JScrollPane jScrollPaneTree = new JScrollPane();
    BorderLayout borderLayout3 = new BorderLayout();
    DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
    JTree jTree1 = new JTree(new DefaultMutableTreeNode(this.rb.getString("jPanelTree.semProjeto")));
    Border border1 = BorderFactory.createLineBorder(Color.white, 5);
    Border border2 = BorderFactory.createLineBorder(Color.white, 5);
    JScrollPane jScrollPane1 = new JScrollPane();
    JTextPane jTextPaneDescricaoAtividade = new JTextPane();
    Icon iconLogo = new ImageIcon("imagens/logo.gif");
    Icon IconAtividade = new ImageIcon("imagens/atividade.gif");
}


class JPanelTree_jTree1_treeSelectionAdapter implements TreeSelectionListener {
    private JPanelTree adaptee;
    JPanelTree_jTree1_treeSelectionAdapter(JPanelTree adaptee) {
        this.adaptee = adaptee;
    }

    public void valueChanged(TreeSelectionEvent e) {
        adaptee.jTree1_valueChanged(e);
    }
}


class JPanelTree_jTree1_mouseAdapter extends MouseAdapter {
    private JPanelTree adaptee;
    JPanelTree_jTree1_mouseAdapter(JPanelTree adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTree1_mouseClicked(e);
    }
}
