package br.ufsc.fcama.ig.jPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.UIManager;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.objAux.DateChooser;
import br.ufsc.fcama.ig.objAux.JDialogSelecao;
import br.ufsc.fcama.ig.objAux.JNumberTextField;
import br.ufsc.fcama.ig.tableModel.TableModelRequisitos;
import br.ufsc.fcama.ig.tableModel.TableModelStakeholder;
import br.ufsc.fcama.logica.objAux.UserStory;
import br.ufsc.fcama.logica.pratica.PraticaUserStories;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JPanelUserStories extends JPanel {
	
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private FramePrincipal frame;
    private Object[] objetos;
    private PraticaUserStories atividadeUserStories;
    private TableModelRequisitos tableModelMuitoAlto;
    private TableModelRequisitos tableModelAlto;
    private TableModelRequisitos tableModelMedio;
    private TableModelStakeholder tableModelStakeholder;
    private TableModelRequisitos tableModelDependencias;
    private UserStory requisito;
    private DateChooser dtChooser;
    //para saber se est sendo editado ou se  incluso
    private boolean isEdicao = false;
    private SpinnerNumberModel spinnerNumberCiclos;
    private SpinnerNumberModel spinnerNumberOrdem;
    private SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy" );

    public JPanelUserStories(FramePrincipal frame, Object[] objetos) {
        try {
        	this.frame = frame;
            this.objetos = objetos;
            this.atividadeUserStories = (PraticaUserStories) objetos[objetos.length - 1];
            this.iniciarComponentes();

            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void jButtonAdicionar_actionPerformed(ActionEvent e) {
    	this.limparCampos();
    	this.jTabbedPane.setSelectedIndex(1);
    }

    public void jButtonEditar_actionPerformed(ActionEvent e) {
    	if (this.jTableAltoList.getSelectedRow() != -1){
    		this.limparCampos();
    		this.requisito = ((UserStory)this.tableModelAlto.removeRequisito(this.jTableAltoList.getSelectedRow()));
    	}else if (this.jTableMuitAltoList.getSelectedRow() != -1){
    		this.limparCampos();
    		this.requisito = ((UserStory)this.tableModelMuitoAlto.removeRequisito(this.jTableMuitAltoList.getSelectedRow()));
    	}else if (this.jTableMedia.getSelectedRow() != -1){
    		this.limparCampos();
    		this.requisito = ((UserStory)this.tableModelMedio.removeRequisito(this.jTableMedia.getSelectedRow()));
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelUserStories.erro.msn.editarUS") ,this.rb.getString("jPanelUserStories.erro.msn.editarUS.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    		return;
    	}

    	this.jTextAreaDescCad.setText(this.requisito.getDescricao());
    	this.jTextFieldNome.setText(this.requisito.getNome());
    	this.jNumberTextField.setText(String.valueOf(this.requisito.getTempoEstimado()));
    	if (this.requisito.getDtInicioPrevisto() != null){
    		this.jTextFieldInicioPrevisto.setText(this.format.format(this.requisito.getDtInicioPrevisto()));
    		this.jButtonFimPrevisto.setEnabled(true);
    	}
    	if (this.requisito.getDtFimPrevisto() != null){
    		this.jTextFieldFimPrevisto.setText(this.format.format(this.requisito.getDtFimPrevisto()));
    	}
    	if (this.requisito.getDtInicio() != null){
    		this.jTextFieldInicioEfetivo.setText(this.format.format(this.requisito.getDtInicio()));
    		this.jButtonFimEfetivo.setEnabled(true);
    	}
    	if (this.requisito.getDtFim() != null){
    		this.jTextFieldFimEfetivo.setText(this.format.format(this.requisito.getDtFim()));
    	}
    	this.spinnerNumberCiclos.setValue(new Integer(this.requisito.getNuCincloDeDesenvolvimento()));
    	this.spinnerNumberOrdem.setValue(new Integer(this.requisito.getOrdem()));
    	if(this.requisito.getPrioridade().equals("Alta")){
    		this.jComboBoxPrioridade.setSelectedIndex(0);
    	}else if(this.requisito.getPrioridade().equals("Mdia")){
    		this.jComboBoxPrioridade.setSelectedIndex(1);
    	}else{
    		this.jComboBoxPrioridade.setSelectedIndex(2);
    	}
    	this.tableModelStakeholder.setStakeholders(new ArrayList(this.requisito.getResponsaveis()));
    	this.jTableResponsavel.addNotify();
    	this.tableModelDependencias.setRequisitos(new ArrayList(this.requisito.getReferencias()));
    	this.jTableDepen.addNotify();
    	this.jTextAreaNota.setText(this.requisito.getNota());
    	this.isEdicao= true;
    	this.jTabbedPane.setSelectedIndex(1);
    }

    public void jButtonExcluir_actionPerformed(ActionEvent e) {
    	if (this.jTableAltoList.getSelectedRow() != -1){
    		this.atividadeUserStories.removeUserStory((UserStory)this.tableModelAlto.removeRequisito(this.jTableAltoList.getSelectedRow()));
    		this.frame.projetoAlterado();
    		this.atualizarTabelasRequisitos();
    	}else if (this.jTableMuitAltoList.getSelectedRow() != -1){
    		this.atividadeUserStories.removeUserStory((UserStory)this.tableModelMuitoAlto.removeRequisito(this.jTableMuitAltoList.getSelectedRow()));
    		this.frame.projetoAlterado();
    		this.atualizarTabelasRequisitos();
    	}else if (this.jTableMedia.getSelectedRow() != -1){
    		this.atividadeUserStories.removeUserStory((UserStory)this.tableModelMedio.removeRequisito(this.jTableMedia.getSelectedRow()));
    		this.frame.projetoAlterado();
    		this.atualizarTabelasRequisitos();
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelUserStories.erro.msn.excluirUS") ,this.rb.getString("jPanelUserStories.erro.msn.excluirUS.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jTableMuitAltoList_mouseClicked(MouseEvent e) {
    	if (this.jTableMuitAltoList.getSelectedRow() != -1){
    		this.jTextAreaDescList.setText((String)this.tableModelMuitoAlto.getValueAt(this.jTableMuitAltoList.getSelectedRow(), 6));
    		this.jTableAltoList.clearSelection();
    		this.jTableMedia.clearSelection();
    	}
    }

    public void jTableAltoList_mouseClicked(MouseEvent e) {
    	if (this.jTableAltoList.getSelectedRow() != -1){
    		this.jTextAreaDescList.setText((String)this.tableModelAlto.getValueAt(this.jTableAltoList.getSelectedRow(), 6));
    		this.jTableMuitAltoList.clearSelection();
    		this.jTableMedia.clearSelection();
    	}
    }

    public void jTableMedia_mouseClicked(MouseEvent e) {
    	if (this.jTableMedia.getSelectedRow() != -1){
    		this.jTextAreaDescList.setText((String)this.tableModelMedio.getValueAt(this.jTableMedia.getSelectedRow(), 6));
    		this.jTableMuitAltoList.clearSelection();
    		this.jTableAltoList.clearSelection();
    	}
    }

    public void jButtonInicioPrevisto_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelRequisitos.dtChooser.inicioPrevisto"));
    	this.dtChooser.setLocation(this.jButtonInicioPrevisto.getLocationOnScreen());
    	Date dtInicio = this.dtChooser.select(this.requisito.getDtInicioPrevisto() == null ? new Date() : this.requisito.getDtInicioPrevisto());
    	if (dtInicio !=  null){
    		Date dtFim = this.requisito.getDtFimPrevisto();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.requisito.setDtInicioPrevisto(dtInicio);
    			this.jButtonFimPrevisto.setEnabled(true);
    			this.jTextFieldInicioPrevisto.setText(this.format.format(dtInicio));
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelRequisitos.erro.dtInicio") ,this.rb.getString("jPanelRequisitos.erro.dtInicio.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonFimPrevisto_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelRequisitos.dtChooser.fimPrevisto"));
    	this.dtChooser.setLocation(this.jButtonFimPrevisto.getLocationOnScreen());
    	Date dtFim = this.dtChooser.select(this.requisito.getDtFimPrevisto() == null ? new Date() : this.requisito.getDtFimPrevisto());
    	if (dtFim !=  null){
    		Date dtInicio = this.requisito.getDtInicioPrevisto();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.requisito.setDtFimPrevisto(dtFim);
    			this.jTextFieldFimPrevisto.setText(this.format.format(dtFim));
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelRequisitos.erro.msn.dataFimPrevisto") ,this.rb.getString("jPanelRequisitos.erro.msn.dataFimPrevisto.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonInicioEfetivo_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelRequisitos.dtChooser.inicioEfetivo"));
    	this.dtChooser.setLocation(this.jButtonInicioEfetivo.getLocationOnScreen());
    	Date dtInicio = this.dtChooser.select(this.requisito.getDtInicio() == null ? new Date() : this.requisito.getDtInicio());
    	if (dtInicio !=  null){
    		Date dtFim = this.requisito.getDtFim();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.requisito.setDtInicio(dtInicio);
    			this.jButtonFimEfetivo.setEnabled(true);
    			this.jTextFieldInicioEfetivo.setText(this.format.format(dtInicio));
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelRequisitos.erro.dtInicioEfetiva="),this.rb.getString("jPanelRequisitos.erro.dtInicioEfetiva.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jButtonFimEfetivo_actionPerformed(ActionEvent e) {
    	this.dtChooser.setTitle(this.rb.getString("jPanelRequisitos.dtChooser.fimEfetivo"));
    	this.dtChooser.setLocation(this.jButtonFimEfetivo.getLocationOnScreen());
    	Date dtFim = this.dtChooser.select(this.requisito.getDtFim() == null ? new Date() : this.requisito.getDtFim());
    	if (dtFim !=  null){
    		Date dtInicio = this.requisito.getDtInicio();
    		if (!dtInicio.after(dtFim == null ? dtInicio : dtFim)){
    			this.requisito.setDtFim(dtFim);
    			this.jTextFieldFimEfetivo.setText(this.format.format(dtFim));
    		}else{
    			 JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelRequisitos.erro.msn.dtFimEfetivo") ,this.rb.getString("jPanelRequisitos.erro.msn.dtFimEfetivo.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
     		}
    	}
    }

    public void jTableResponsavel_mouseClicked(MouseEvent e) {

    }

    public void jButtonAdicionarResp_actionPerformed(ActionEvent e) {
    	TableModelStakeholder model = new TableModelStakeholder(new ArrayList(this.frame.getControlador().getProjeto().getStakeholders()), this.tableModelStakeholder.getStakeholders());
    	JDialogSelecao dialogSelecao = new JDialogSelecao(this.frame, this.rb.getString("jPanelRequisitos.jDialog.responsavel"), model);
    	dialogSelecao.setLocation(this.jTextFieldInicioEfetivo.getLocationOnScreen());
    	dialogSelecao.setSize( new Dimension(300,200));
    	int row = dialogSelecao.selecionar();
    	if (row != -1){
    		this.tableModelStakeholder.addStakeholder(model.getStakeholder(row));
    		this.jTableResponsavel.addNotify();
    	}
    }

    public void jButton2_actionPerformed(ActionEvent e) {
    	if (this.jTableResponsavel.getSelectedRow() != -1){
    		this.tableModelStakeholder.removeStakeholder(this.jTableResponsavel.getSelectedRow());
    		this.jTableResponsavel.addNotify();
  		}else{
  		  JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelRequisitos.erro.removerResp") ,this.rb.getString("jPanelRequisitos.erro.removerResp.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonAdiciobarDepen_actionPerformed(ActionEvent e) {
    	ArrayList remover = new ArrayList(this.tableModelDependencias.getRequisitos());
    	if (this.isEdicao){
    		remover.add(this.requisito);
    	}
    	TableModelRequisitos model = new TableModelRequisitos(1,new ArrayList(this.atividadeUserStories.getUserStories()),remover );
    	JDialogSelecao dialogSelecao = new JDialogSelecao(this.frame, this.rb.getString("jPanelUserStories.jDialog.depend"), model);
    	dialogSelecao.setLocation(this.jLabel15.getLocationOnScreen());
    	dialogSelecao.setSize( new Dimension(300,200));
    	int row = dialogSelecao.selecionar();
    	if (row != -1){
    		this.tableModelDependencias.addRequisito(model.getRequisito(row));
    		this.jTableDepen.addNotify();
    	}
    }

    public void jButtonRemoverDepend_actionPerformed(ActionEvent e) {
    	if (this.jTableDepen.getSelectedRow() != -1){
    		this.tableModelDependencias.removeRequisito(this.jTableDepen.getSelectedRow());
    		this.jTableDepen.addNotify();
  		}else{
  		  JOptionPane.showConfirmDialog(this.frame,this.rb.getString("jPanelUserStories.erro.msn.removerDepen")  ,this.rb.getString("jPanelUserStories.erro.msn.removerDepen.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jTableDepen_mouseClicked(MouseEvent e) {

    }

    public void jButtonSalvar_actionPerformed(ActionEvent e) {
    	if (! this.jTextFieldNome.getText().equals("") && ! this.jTextAreaDescCad.getText().equals("")){
    		try{
    			if (!this.jNumberTextField.getText().equals("")){
    				this.requisito.setTempoEstimado(new Float(this.jNumberTextField.getText()).floatValue());
    			}else{
    				this.requisito.setTempoEstimado(0);
    			}
    		}catch(Exception ex){
    			JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelRequisitos.erro.msn.duracaoInvalida"),this.rb.getString("jPanelRequisitos.erro.msn.duracaoInvalida.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
    			return;
    		}
   			this.requisito.setResponsaveis(new ArrayList(this.tableModelStakeholder.getStakeholders()));
    		this.requisito.setNome(this.jTextFieldNome.getText());
    		this.requisito.setDescricao(this.jTextAreaDescCad.getText());
    		this.requisito.setPrioridade((String)this.jComboBoxPrioridade.getSelectedItem());
    		this.requisito.setNuCincloDeDesenvolvimento(this.spinnerNumberCiclos.getNumber().intValue());
    		this.requisito.setOrdem(this.spinnerNumberOrdem.getNumber().intValue());
    		if (!this.isEdicao){
	    		this.atividadeUserStories.addUserStory(this.requisito);
	    	}
    		this.requisito.setNota(this.jTextAreaNota.getText());
    		this.requisito.setReferencias(this.tableModelDependencias.getRequisitos());

    		this.frame.projetoAlterado();
    		this.limparCampos();
    		this.atualizarTabelasRequisitos();
    		this.jTabbedPane.setSelectedIndex(0);
    	}else{
    		JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelRequisitos.erro.msn.camposObrigatorios") ,this.rb.getString("jPanelRequisitos.erro.msn.camposObrigatorios.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }


    private void atualizarTabelasRequisitos(){
    	this.tableModelMuitoAlto.setRequisitos(this.atividadeUserStories.getUserStories());
        this.jTableMuitAltoList.addNotify();

        this.tableModelMedio.setRequisitos(this.atividadeUserStories.getUserStories()) ;
        this.jTableMedia.addNotify() ;

        this.tableModelAlto.setRequisitos(this.atividadeUserStories.getUserStories()) ;
        this.jTableAltoList.addNotify() ;

    }

    public void jButtonCancelar_actionPerformed(ActionEvent e) {
    	this.limparCampos();
    	this.atualizarTabelasRequisitos();
    	this.jTabbedPane.setSelectedIndex(0);
    }

    private void limparCampos(){
    	this.jTextFieldNome.setText("");
    	this.jComboBoxPrioridade.setSelectedIndex(2);
    	this.jSpinnerCiclo.setValue(new Integer(0));
    	this.jSpinnerOrdem.setValue(new Integer(0));
    	this.jNumberTextField.setText("");
    	this.jTextFieldInicioPrevisto.setText("");
    	this.jTextFieldFimPrevisto.setText("");
    	this.jButtonFimPrevisto.setEnabled(false);
    	this.jTextFieldInicioEfetivo.setText("");
    	this.jTextFieldInicioEfetivo.setText("");
    	this.jButtonFimEfetivo.setEnabled(false);
    	this.tableModelStakeholder.clean();
    	this.jTableResponsavel.addNotify();
    	this.tableModelDependencias.clean();
    	this.jTableDepen.addNotify();
    	this.jTableResponsavel.repaint();
    	this.jTextAreaDescCad.setText("");
    	this.jTextAreaNota.setText("");
    	this.isEdicao = false;
    	this.requisito = new UserStory();
    }

    private void iniciarComponentes(){

    	this.jPanelAnexo = new JPanelAnexos(this.frame, this.objetos);

        this.tableModelMuitoAlto = new TableModelRequisitos(this.atividadeUserStories.getUserStories(), "Muito Alta", 6);
        this.jTableMuitAltoList = new JTable(this.tableModelMuitoAlto);

        this.tableModelMedio = new TableModelRequisitos(this.atividadeUserStories.getUserStories(), "Mdia", 6);
        this.jTableMedia =new JTable(this.tableModelMedio);

        this.tableModelAlto = new TableModelRequisitos(this.atividadeUserStories.getUserStories(), "Alta", 6);
        this.jTableAltoList = new JTable(this.tableModelAlto);

        this.tableModelStakeholder = new TableModelStakeholder(new ArrayList());
        this.jTableResponsavel = new JTable(this.tableModelStakeholder);

        this.tableModelDependencias = new TableModelRequisitos(new ArrayList(), null, 1);
        this.jTableDepen = new JTable(this.tableModelDependencias);

        this.dtChooser = new DateChooser(this.frame, this.rb.getString("jPanelRequisitos.dtChooser.titulo"));

        this.requisito = new UserStory();

        this.spinnerNumberCiclos = new SpinnerNumberModel(0,0,this.frame.getControlador().getProjeto().getIteracoes().size(), 1);
        this.jSpinnerCiclo = new JSpinner(this.spinnerNumberCiclos);

        this.spinnerNumberOrdem = new SpinnerNumberModel(0,0,10000,1);
        this.jSpinnerOrdem = new JSpinner(this.spinnerNumberOrdem);

    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.alta"));
    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.media"));
    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.muitoAlta"));
    	this.jComboBoxPrioridade.setSelectedIndex(2);

    	this.jButtonFimEfetivo.setEnabled(false);
    	this.jButtonFimPrevisto.setEnabled(false);

    	if (!this.frame.getControlador().getProjeto().getAtividadeAtribuicaoDosRequisitos()
    			.getPraticaDistribuicaoDosRequisitos().isSelecionada()){
    		 this.jButtonAdicionarResp.setEnabled(false);
    		 this.jButtonRemoveResp.setEnabled(false);
    	}

    	this.isEdicao = false;

    }

    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
       jTabbedPane.setBackground(UIManager.getColor("control"));
        jPanelLista.setLayout(borderLayout2);
        jPanelLista.setBackground(SystemColor.control);
        jPanel1.setBackground(UIManager.getColor("control"));
        jPanel1.setMinimumSize(new Dimension(10, 10));
        jPanel1.setToolTipText("");
        jPanel1.setLayout(borderLayout3);
        jPanel2.setLayout(gridBagLayout1);
        jPanel3.setLayout(flowLayout1);
        jButtonAdicionar.setEnabled(true);
        jButtonAdicionar.setText(this.rb.getString("jPanelRequisitos.jButton.adicionar"));
        jButtonAdicionar.addActionListener(new
                JPanelUserStory_jButtonAdicionar_actionAdapter(this));
        jButtonEditar.setPreferredSize(new Dimension(79, 23));
        jButtonEditar.setText(this.rb.getString("jPanelRequisitos.jButton.editar"));
        jButtonEditar.addActionListener(new
                JPanelUserStory_jButtonEditar_actionAdapter(this));
        jButtonExcluir.setPreferredSize(new Dimension(79, 23));
        jButtonExcluir.setText(this.rb.getString("jPanelRequisitos.jButton.excluir"));
        jButtonExcluir.addActionListener(new
                JPanelUserStory_jButtonExcluir_actionAdapter(this));
        jPanel2.setBackground(SystemColor.control);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setForeground(Color.red);
        jLabel1.setText(this.rb.getString("jPanelRequisitos.jLabel.muitoAlta"));
        jLabel2.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel2.setForeground(Color.black);
        jLabel2.setText(this.rb.getString("jPanelRequisitos.jLabel.alta"));
        jLabel3.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel3.setText(this.rb.getString("jPanelRequisitos.jLabel.media"));
        jLabel4.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 11));
        jLabel4.setText(this.rb.getString("jPanelRequisitos.jLabel.descricao"));
        //jTextAreaDescList.setEnabled(false);
        jTextAreaDescList.setRequestFocusEnabled(false);
        jTextAreaDescList.setEditable(false);
        jTextAreaDescList.setText("");
        jTextAreaDescList.setLineWrap(true);
        jScrollPaneMedio.setPreferredSize(new Dimension(500, 80));
        jScrollPaneAltoList.setPreferredSize(new Dimension(500, 80));
        jScrollPaneMuitoAltoList.setPreferredSize(new Dimension(500, 80));
        jTableMuitAltoList.addMouseListener(new
                JPanelUserStory_jTableMuitAltoList_mouseAdapter(this));
        jTableAltoList.addMouseListener(new
                JPanelUserStory_jTableAltoList_mouseAdapter(this));
        jTableMedia.addMouseListener(new
                                     JPanelUserStory_jTableMedia_mouseAdapter(this));
        jPanelCadastro.setLayout(borderLayout4);
        jPanel4.setBackground(SystemColor.control);
        jPanel4.setLayout(flowLayout2);
        jPanel5.setBackground(new Color(236, 233, 90));
        jPanel5.setLayout(gridLayout2);
        jButtonSalvar.setPreferredSize(new Dimension(75, 23));
        jButtonSalvar.setText(this.rb.getString("jPanelRequisitos.jButton.salvar"));
        jButtonSalvar.addActionListener(new
                JPanelUserStory_jButtonSalvar_actionAdapter(this));
        jButtonCancelar.setText(this.rb.getString("jPanelRequisitos.jButton.cancelar"));
        jButtonCancelar.addActionListener(new
                JPanelUserStory_jButtonCancelar_actionAdapter(this));
        jTextFieldNome.setPreferredSize(new Dimension(250, 20));
        jTextFieldNome.setText("");
        jTextFieldInicioPrevisto.setEnabled(false);
        jTextFieldInicioPrevisto.setPreferredSize(new Dimension(94, 20));
        jTextFieldInicioPrevisto.setRequestFocusEnabled(false);
        jTextFieldInicioPrevisto.setText("");
        jNumberTextField.setPreferredSize(new Dimension(70, 20));
        jButtonInicioPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setIcon(iconDate);
        jButtonInicioPrevisto.addActionListener(new
                JPanelUserStory_jButtonInicioPrevisto_actionAdapter(this));
        jTextFieldFimPrevisto.setEnabled(false);
        jTextFieldFimPrevisto.setPreferredSize(new Dimension(94, 20));
        jTextFieldFimPrevisto.setRequestFocusEnabled(false);
        jTextFieldFimPrevisto.setText("");
        jButtonFimPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonFimPrevisto.setIcon(iconDate);
        jButtonFimPrevisto.setText("");
        jButtonFimPrevisto.addActionListener(new
                JPanelUserStory_jButtonFimPrevisto_actionAdapter(this));
        jTextFieldInicioEfetivo.setEnabled(false);
        jTextFieldInicioEfetivo.setPreferredSize(new Dimension(94, 20));
        jTextFieldInicioEfetivo.setRequestFocusEnabled(false);
        jTextFieldInicioEfetivo.setText("");
        jButtonFimEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonFimEfetivo.setIcon(iconDate);
        jButtonFimEfetivo.setText("");
        jButtonFimEfetivo.addActionListener(new
                JPanelUserStory_jButtonFimEfetivo_actionAdapter(this));
        jTextFieldFimEfetivo.setEnabled(false);
        jTextFieldFimEfetivo.setPreferredSize(new Dimension(94, 20));
        jTextFieldFimEfetivo.setRequestFocusEnabled(false);
        jTextFieldFimEfetivo.setText("");
        jButtonInicioEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setIcon(iconDate);
        jButtonInicioEfetivo.setMnemonic('0');
        jButtonInicioEfetivo.addActionListener(new
                JPanelUserStory_jButtonInicioEfetivo_actionAdapter(this));
        jSpinnerCiclo.setMaximumSize(new Dimension(50, 20));
        jSpinnerCiclo.setPreferredSize(new Dimension(50, 20));
        jSpinnerOrdem.setMaximumSize(new Dimension(50, 20));
        jSpinnerOrdem.setPreferredSize(new Dimension(50, 20));
        jLabel5.setText(this.rb.getString("jPanelRequisitos.jLabel.nome"));
        jLabel6.setText(this.rb.getString("jPanelRequisitos.jLabel.prioridade"));
        jLabel7.setText(this.rb.getString("jPanelRequisitos.jLabel.ordem"));
        jLabel8.setText(this.rb.getString("jPanelRequisitos.jLabel.iteracao"));
        jLabel9.setText(this.rb.getString("jPanelRequisitos.jLabel.inicioEfetivo"));
        jLabel10.setText(this.rb.getString("jPanelRequisitos.jlabel.fimEfetivo"));
        jLabel12.setText(this.rb.getString("jPanelRequisitos.jLabel.inicioPrevisto"));
        jLabel13.setText(this.rb.getString("jPanelRequisitos.jlabel.fimPrevisto"));
        jLabel14.setText(this.rb.getString("jPanelRequisitos.jLabel.duracao"));
        jPanel6.setBackground(SystemColor.control);
        jPanel6.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(5);
        jPanel7.setBackground(SystemColor.control);
        jPanel7.setLayout(gridLayout6);
        jPanel8.setBackground(SystemColor.control);
        jPanel8.setLayout(gridLayout5);
        jPanel11.setBackground(SystemColor.control);
        jPanel11.setLayout(gridLayout8);
        jPanel13.setBackground(SystemColor.control);
        jPanel13.setLayout(gridLayout4);
        jPanel10.setLayout(gridLayout7);
        jPanel15.setLayout(flowLayout4);
        gridLayout5.setColumns(2);
        gridLayout5.setRows(2);
        jPanel18.setLayout(flowLayout5);
        jPanel19.setLayout(flowLayout6);
        jPanel17.setLayout(flowLayout7);
        flowLayout4.setAlignment(FlowLayout.LEFT);
        flowLayout4.setHgap(0);
        flowLayout6.setAlignment(FlowLayout.LEFT);
        flowLayout6.setHgap(0);
        flowLayout5.setAlignment(FlowLayout.LEFT);
        flowLayout5.setHgap(0);
        flowLayout7.setAlignment(FlowLayout.LEFT);
        flowLayout7.setHgap(0);
        jPanel20.setLayout(flowLayout8);
        jPanel23.setLayout(flowLayout9);
        jPanel22.setLayout(flowLayout10);
        jPanel21.setLayout(flowLayout11);
        flowLayout8.setAlignment(FlowLayout.LEFT);
        flowLayout8.setHgap(0);
        flowLayout9.setAlignment(FlowLayout.LEFT);
        flowLayout9.setHgap(0);
        flowLayout10.setAlignment(FlowLayout.LEFT);
        flowLayout10.setHgap(0);
        flowLayout11.setAlignment(FlowLayout.LEFT);
        flowLayout11.setHgap(0);
        gridLayout6.setColumns(1);
        gridLayout6.setRows(2);
        jPanel14.setLayout(flowLayout3);
        jPanel24.setLayout(flowLayout12);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        flowLayout3.setHgap(0);
        flowLayout12.setAlignment(FlowLayout.LEFT);
        flowLayout12.setHgap(0);
        gridLayout7.setColumns(2);
        gridLayout7.setRows(2);
        jPanel25.setLayout(flowLayout13);
        jPanel28.setLayout(flowLayout14);
        jPanel27.setLayout(flowLayout15);
        jPanel26.setLayout(flowLayout16);
        flowLayout13.setAlignment(FlowLayout.LEFT);
        flowLayout13.setHgap(0);
        flowLayout14.setAlignment(FlowLayout.LEFT);
        flowLayout14.setHgap(0);
        flowLayout15.setAlignment(FlowLayout.LEFT);
        flowLayout15.setHgap(0);
        flowLayout16.setAlignment(FlowLayout.LEFT);
        flowLayout16.setHgap(0);
        gridLayout8.setColumns(2);
        gridLayout8.setRows(2);
        gridLayout4.setColumns(2);
        gridLayout4.setRows(2);
        jPanel9.setLayout(flowLayout17);
        jPanel30.setLayout(flowLayout18);
        jPanel31.setLayout(flowLayout19);
        jPanel29.setLayout(flowLayout20);
        flowLayout17.setAlignment(FlowLayout.LEFT);
        flowLayout17.setHgap(0);
        flowLayout19.setAlignment(FlowLayout.LEFT);
        flowLayout19.setHgap(0);
        flowLayout18.setAlignment(FlowLayout.LEFT);
        flowLayout18.setHgap(0);
        flowLayout20.setAlignment(FlowLayout.LEFT);
        flowLayout20.setHgap(0);
        jPanel10.setBackground(SystemColor.control);
        jLabel11.setText(this.rb.getString("jPanelRequisitos.jLabel.responsaveis"));
        jPanel16.setLayout(flowLayout21);
        jButtonAdicionarResp.setText(this.rb.getString("jPanelRequisitos.jButton.adicionar"));
        jButtonAdicionarResp.addActionListener(new
                JPanelUserStory_jButtonAdicionarResp_actionAdapter(this));
        jButtonRemoveResp.setText(this.rb.getString("jPanelRequisitos.jButton.remover"));
        jButtonRemoveResp.addActionListener(new JPanelUserStory_jButton2_actionAdapter(this));
        jComboBoxPrioridade.setPreferredSize(new Dimension(100, 20));
        jPanel32.setLayout(flowLayout22);
        flowLayout22.setAlignment(FlowLayout.LEFT);
        flowLayout22.setHgap(0);
        jTextAreaDescricao.setText("");
        jTextAreaDescricao.setLineWrap(true);
        jPanel34.setLayout(borderLayout7);
        jPanel35.setLayout(borderLayout8);
        jPanel35.setPreferredSize(new Dimension(200, 175));
        jScrollPaneResp.setPreferredSize(new Dimension(100, 100));
        jPanel12.setLayout(flowLayout23);
        jPanel33.setLayout(flowLayout24);
        flowLayout24.setAlignment(FlowLayout.LEFT);
        flowLayout24.setHgap(13);
        jPanel37.setBackground(Color.pink);
        jPanel37.setLayout(borderLayout5);
        jPanel40.setLayout(borderLayout6);
        jPanel40.setBackground(new Color(236, 233, 145));
        jPanel40.setPreferredSize(new Dimension(200, 175));
        jPanel41.setBackground(new Color(236, 233, 97));
        jPanel41.setPreferredSize(new Dimension(200, 75));
        jPanel41.setLayout(borderLayout9);
        jPanel42.setBackground(new Color(236, 152, 216));
        jPanel42.setLayout(borderLayout10);
        jPanel46.setLayout(flowLayout25);
        jLabel15.setText(this.rb.getString("jPanelUserStories.jLabel.dependencias"));
        flowLayout25.setAlignment(FlowLayout.LEFT);
        flowLayout25.setHgap(13);
        jButtonAdiciobarDepen.setText(this.rb.getString("jPanelRequisitos.jButton.adicionar"));
        jButtonAdiciobarDepen.addActionListener(new
                JPanelUserStory_jButtonAdiciobarDepen_actionAdapter(this));
        jButtonRemoverDepend.setText(this.rb.getString("jPanelRequisitos.jButton.remover"));
        jButtonRemoverDepend.addActionListener(new
                JPanelUserStory_jButtonRemoverDepend_actionAdapter(this));
        jLabel16.setText(this.rb.getString("jPanelRequisitos.jLabel.descricao"));
        jPanel51.setLayout(flowLayout26);
        flowLayout26.setAlignment(FlowLayout.LEFT);
        flowLayout26.setHgap(0);
        jTextAreaDescCad.setText("");
        jTextAreaDescCad.setLineWrap(true);
        jPanel48.setLayout(flowLayout27);
        flowLayout27.setAlignment(FlowLayout.LEFT);
        flowLayout27.setHgap(13);
        jLabel17.setText(this.rb.getString("jPanelUserStories.jLabel.nota"));
        jTextAreaNota.setText("");
        jTextAreaNota.setLineWrap(true);
        jTableResponsavel.addMouseListener(new
                JPanelUserStory_jTableResponsavel_mouseAdapter(this));
        jTableDepen.addMouseListener(new
                                     JPanelUserStory_jTableDepen_mouseAdapter(this));
        this.add(jTabbedPane, java.awt.BorderLayout.CENTER);
        jTabbedPane.add(jPanelLista, this.rb.getString("jPanelUserStories.tab.listUS"));
        jPanelLista.add(jPanel1, java.awt.BorderLayout.SOUTH);
        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);
        jPanel3.add(jButtonAdicionar);
        jPanel3.add(jButtonEditar);
        jPanel3.add(jButtonExcluir);
        jTabbedPane.add(jPanelCadastro,this.rb.getString("jPanelUserStories.tab.cadUS"));
        jPanel4.add(jButtonSalvar);
        jPanel4.add(jButtonCancelar);
        jTabbedPane.add(jPanelAnexo,this.rb.getString("jPanelRequisitos.tab.cadAnexos") );
        jPanelLista.add(jPanel2, java.awt.BorderLayout.CENTER);
        jScrollPaneMuitoAltoList.getViewport().add(jTableMuitAltoList);
        jScrollPaneDescList.getViewport().add(jTextAreaDescList);
        jScrollPaneAltoList.getViewport().add(jTableAltoList);
        jScrollPaneMedio.getViewport().add(jTableMedia);
        jPanel2.add(jScrollPaneDescList,
                    new GridBagConstraints(0, 7, 1, 1, 1.0, 1.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.BOTH,
                                           new Insets(0, 45, 15, 47), 432, 91));
        jPanel2.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(1, 45, 0, 47), 355, 0));
        jPanel2.add(jScrollPaneMuitoAltoList,
                    new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.BOTH,
                                           new Insets(0, 45, 0, 47), 52, -320));
        jPanel2.add(jLabel2, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 45, 0, 47), 399, 0));
        jPanel2.add(jScrollPaneAltoList,
                    new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.BOTH,
                                           new Insets(0, 45, 0, 47), 52, -320));
        jPanel2.add(jLabel3, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 45, 0, 47), 386, 0));
        jPanel2.add(jLabel4, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 45, 0, 47), 436, 0));
        jPanel2.add(jScrollPaneMedio,
                    new GridBagConstraints(0, 5, 1, 1, 1.0, 1.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.BOTH,
                                           new Insets(0, 45, 0, 47), 52, -320));
        jPanel7.add(jPanel14);
        jPanel14.add(jLabel5);
        jPanel7.add(jPanel24);
        jPanel24.add(jTextFieldNome);
        jPanel10.add(jPanel25);
        jPanel25.add(jLabel9);
        jPanel10.add(jPanel28);
        jPanel28.add(jLabel10);
        jPanel10.add(jPanel27);
        jPanel27.add(jTextFieldInicioEfetivo);
        jPanel27.add(jButtonInicioEfetivo);
        jPanel10.add(jPanel26);
        jPanel26.add(jTextFieldFimEfetivo);
        jPanel26.add(jButtonFimEfetivo);
        jPanel6.add(jPanel7);
        jPanel6.add(jPanel8);

        jPanel13.add(jPanel9);
        jPanel9.add(jLabel12);
        jPanel13.add(jPanel31);
        jPanel31.add(jLabel13);
        jPanel13.add(jPanel29);
        jPanel29.add(jTextFieldInicioPrevisto);
        jPanel29.add(jButtonInicioPrevisto);
        jPanel13.add(jPanel30);
        jPanel30.add(jTextFieldFimPrevisto);
        jPanel30.add(jButtonFimPrevisto);
        jPanel6.add(jPanel11);

        jPanel8.add(jPanel15, null);
        jPanel15.add(jLabel6);
        jPanel8.add(jPanel19);
        jPanel19.add(jLabel8);
        jPanel8.add(jPanel18);
        jPanel18.add(jComboBoxPrioridade);
        jPanel8.add(jPanel17);
        jPanel17.add(jSpinnerCiclo);
        jPanel6.add(jPanel13);

        jPanelCadastro.add(jPanel5, java.awt.BorderLayout.CENTER);
        jPanelCadastro.add(jPanel4, java.awt.BorderLayout.SOUTH);
        jPanel16.add(jButtonAdicionarResp);
        jPanel16.add(jButtonRemoveResp);
        jPanel35.add(jPanel12, java.awt.BorderLayout.WEST);
        jPanel35.add(jPanel33, java.awt.BorderLayout.NORTH);
        jPanel33.add(jLabel11);
        jPanel34.add(jPanel36, java.awt.BorderLayout.WEST);
        jPanel34.add(jPanel6, java.awt.BorderLayout.CENTER);
        jPanel34.add(jPanel35, java.awt.BorderLayout.SOUTH);

        jPanel20.add(jPanel23);
        jPanel20.add(jSpinnerOrdem);
        jPanel6.add(jPanel10);

        jPanel11.add(jPanel22);
        jPanel22.add(jLabel14);
        jPanel11.add(jPanel32);
        jPanel32.add(jLabel7);
        jPanel11.add(jPanel21);
        jPanel21.add(jNumberTextField);
        jPanel11.add(jPanel20);

        jPanel35.add(jScrollPaneResp, java.awt.BorderLayout.CENTER);
        jPanel35.add(jPanel16, java.awt.BorderLayout.SOUTH);
        jScrollPaneResp.getViewport().add(jTableResponsavel);
        jPanel5.add(jPanel34, null);
        jPanel5.add(jPanel37, null);
        jPanel37.add(jPanel38, java.awt.BorderLayout.WEST);
        jPanel37.add(jPanel39, java.awt.BorderLayout.EAST);
        jPanel37.add(jPanel40, java.awt.BorderLayout.NORTH);
        jPanel40.add(jPanel43, java.awt.BorderLayout.SOUTH);
        jPanel43.add(jButtonAdiciobarDepen);
        jPanel43.add(jButtonRemoverDepend);
        jPanel40.add(jPanel44, java.awt.BorderLayout.WEST);
        jPanel40.add(jPanel45, java.awt.BorderLayout.EAST);
        jPanel40.add(jPanel46, java.awt.BorderLayout.NORTH);
        jPanel46.add(jLabel15);
        jPanel40.add(jScrollPaneDepen, java.awt.BorderLayout.CENTER);
        jScrollPaneDepen.getViewport().add(jTableDepen);
        jPanel37.add(jPanel41, java.awt.BorderLayout.SOUTH);
        jPanel41.add(jPanel47, java.awt.BorderLayout.WEST);
        jPanel41.add(jPanel48, java.awt.BorderLayout.NORTH);
        jPanel48.add(jLabel17);
        jPanel41.add(jPanel49, java.awt.BorderLayout.EAST);
        jPanel41.add(jPanel50, java.awt.BorderLayout.SOUTH);
        jPanel41.add(jScrollPaneNota, java.awt.BorderLayout.CENTER);
        jScrollPaneNota.getViewport().add(jTextAreaNota);
        jPanel37.add(jPanel42, java.awt.BorderLayout.CENTER);
        jPanel42.add(jPanel51, java.awt.BorderLayout.NORTH);
        jPanel51.add(jLabel16);
        jPanel42.add(jScrollPaneDesc, java.awt.BorderLayout.CENTER);
        jScrollPaneDesc.getViewport().add(jTextAreaDescCad);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JTabbedPane jTabbedPane = new JTabbedPane();
    JPanel jPanelLista = new JPanel();
    JPanel jPanelCadastro = new JPanel();
    JPanelAnexos jPanelAnexo ;
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    JPanel jPanel3 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JButton jButtonAdicionar = new JButton();
    JButton jButtonEditar = new JButton();
    JButton jButtonExcluir = new JButton();
    JScrollPane jScrollPaneMuitoAltoList = new JScrollPane();
    JScrollPane jScrollPaneAltoList = new JScrollPane();
    JScrollPane jScrollPaneMedio = new JScrollPane();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JTable jTableMuitAltoList = new JTable();
    JTable jTableAltoList = new JTable();
    JScrollPane jScrollPaneDescList = new JScrollPane();
    JTextArea jTextAreaDescList = new JTextArea();
    JTable jTableMedia = new JTable();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();
    JButton jButtonSalvar = new JButton();
    JButton jButtonCancelar = new JButton();
    JTextField jTextFieldNome = new JTextField();
    JSpinner jSpinnerCiclo = new JSpinner();
    JSpinner jSpinnerOrdem = new JSpinner();
    JTextField jTextFieldInicioPrevisto = new JTextField();
    JNumberTextField jNumberTextField = new JNumberTextField();
    Icon iconDate = new ImageIcon("imagens/date.gif");
    JButton jButtonInicioPrevisto = new JButton();
    JTextField jTextFieldFimPrevisto = new JTextField();
    JButton jButtonFimPrevisto = new JButton();
    JTextField jTextFieldInicioEfetivo = new JTextField();
    JButton jButtonFimEfetivo = new JButton();
    JTextField jTextFieldFimEfetivo = new JTextField();
    JButton jButtonInicioEfetivo = new JButton();
    JLabel jLabel5 = new JLabel();
    JLabel jLabel6 = new JLabel();
    JLabel jLabel7 = new JLabel();
    JLabel jLabel8 = new JLabel();
    JLabel jLabel9 = new JLabel();
    JLabel jLabel10 = new JLabel();
    JLabel jLabel12 = new JLabel();
    JLabel jLabel13 = new JLabel();
    JLabel jLabel14 = new JLabel();
    JPanel jPanel6 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel7 = new JPanel();
    JPanel jPanel8 = new JPanel();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    JPanel jPanel13 = new JPanel();
    JPanel jPanel15 = new JPanel();
    GridLayout gridLayout3 = new GridLayout();
    GridLayout gridLayout5 = new GridLayout();
    JPanel jPanel17 = new JPanel();
    JPanel jPanel18 = new JPanel();
    JPanel jPanel19 = new JPanel();
    FlowLayout flowLayout4 = new FlowLayout();
    FlowLayout flowLayout5 = new FlowLayout();
    FlowLayout flowLayout6 = new FlowLayout();
    FlowLayout flowLayout7 = new FlowLayout();
    JPanel jPanel20 = new JPanel();
    JPanel jPanel21 = new JPanel();
    JPanel jPanel22 = new JPanel();
    JPanel jPanel23 = new JPanel();
    FlowLayout flowLayout8 = new FlowLayout();
    FlowLayout flowLayout9 = new FlowLayout();
    FlowLayout flowLayout10 = new FlowLayout();
    FlowLayout flowLayout11 = new FlowLayout();
    GridLayout gridLayout6 = new GridLayout();
    JPanel jPanel14 = new JPanel();
    JPanel jPanel24 = new JPanel();
    FlowLayout flowLayout3 = new FlowLayout();
    FlowLayout flowLayout12 = new FlowLayout();
    GridLayout gridLayout7 = new GridLayout();
    JPanel jPanel25 = new JPanel();
    JPanel jPanel26 = new JPanel();
    JPanel jPanel27 = new JPanel();
    JPanel jPanel28 = new JPanel();
    FlowLayout flowLayout13 = new FlowLayout();
    FlowLayout flowLayout14 = new FlowLayout();
    FlowLayout flowLayout15 = new FlowLayout();
    FlowLayout flowLayout16 = new FlowLayout();
    GridLayout gridLayout8 = new GridLayout();
    JPanel jPanel32 = new JPanel();
    GridLayout gridLayout4 = new GridLayout();
    JPanel jPanel9 = new JPanel();
    JPanel jPanel29 = new JPanel();
    JPanel jPanel30 = new JPanel();
    JPanel jPanel31 = new JPanel();
    FlowLayout flowLayout17 = new FlowLayout();
    FlowLayout flowLayout18 = new FlowLayout();
    FlowLayout flowLayout19 = new FlowLayout();
    FlowLayout flowLayout20 = new FlowLayout();
    BorderLayout borderLayout4 = new BorderLayout();
    JLabel jLabel11 = new JLabel();
    JPanel jPanel16 = new JPanel();
    FlowLayout flowLayout21 = new FlowLayout();
    JButton jButtonAdicionarResp = new JButton();
    JButton jButtonRemoveResp = new JButton();
    JScrollPane jScrollPaneResp = new JScrollPane();
    JTable jTableresp = new JTable();
    JComboBox jComboBoxPrioridade = new JComboBox();
    FlowLayout flowLayout22 = new FlowLayout();
    JTextArea jTextAreaDescricao = new JTextArea();
    JPanel jPanel34 = new JPanel();
    BorderLayout borderLayout7 = new BorderLayout();
    JPanel jPanel35 = new JPanel();
    BorderLayout borderLayout8 = new BorderLayout();
    JTable jTableResponsavel = new JTable();
    JPanel jPanel36 = new JPanel();
    JPanel jPanel12 = new JPanel();
    FlowLayout flowLayout23 = new FlowLayout();
    JPanel jPanel33 = new JPanel();
    FlowLayout flowLayout24 = new FlowLayout();
    JPanel jPanel37 = new JPanel();
    GridLayout gridLayout2 = new GridLayout();
    BorderLayout borderLayout5 = new BorderLayout();
    JPanel jPanel38 = new JPanel();
    JPanel jPanel39 = new JPanel();
    JPanel jPanel40 = new JPanel();
    JPanel jPanel41 = new JPanel();
    BorderLayout borderLayout6 = new BorderLayout();
    BorderLayout borderLayout9 = new BorderLayout();
    JPanel jPanel42 = new JPanel();
    JPanel jPanel43 = new JPanel();
    JPanel jPanel44 = new JPanel();
    JPanel jPanel45 = new JPanel();
    JPanel jPanel46 = new JPanel();
    JPanel jPanel47 = new JPanel();
    JPanel jPanel48 = new JPanel();
    JPanel jPanel49 = new JPanel();
    JPanel jPanel50 = new JPanel();
    BorderLayout borderLayout10 = new BorderLayout();
    JPanel jPanel51 = new JPanel();
    FlowLayout flowLayout25 = new FlowLayout();
    JLabel jLabel15 = new JLabel();
    JButton jButtonAdiciobarDepen = new JButton();
    JButton jButtonRemoverDepend = new JButton();
    JScrollPane jScrollPaneDepen = new JScrollPane();
    JTable jTableDepen = new JTable();
    JLabel jLabel16 = new JLabel();
    FlowLayout flowLayout26 = new FlowLayout();
    JScrollPane jScrollPaneDesc = new JScrollPane();
    JTextArea jTextAreaDescCad = new JTextArea();
    FlowLayout flowLayout27 = new FlowLayout();
    JLabel jLabel17 = new JLabel();
    JScrollPane jScrollPaneNota = new JScrollPane();
    JTextArea jTextAreaNota = new JTextArea();

}


class JPanelUserStory_jButtonCancelar_actionAdapter implements ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonCancelar_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancelar_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonSalvar_actionAdapter implements ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonSalvar_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonSalvar_actionPerformed(e);
    }
}


class JPanelUserStory_jTableDepen_mouseAdapter extends MouseAdapter {
    private JPanelUserStories adaptee;
    JPanelUserStory_jTableDepen_mouseAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableDepen_mouseClicked(e);
    }
}


class JPanelUserStory_jButtonRemoverDepend_actionAdapter implements
        ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonRemoverDepend_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonRemoverDepend_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonAdiciobarDepen_actionAdapter implements
        ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonAdiciobarDepen_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAdiciobarDepen_actionPerformed(e);
    }
}


class JPanelUserStory_jButton2_actionAdapter implements ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButton2_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton2_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonAdicionarResp_actionAdapter implements
        ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonAdicionarResp_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAdicionarResp_actionPerformed(e);
    }
}


class JPanelUserStory_jTableResponsavel_mouseAdapter extends MouseAdapter {
    private JPanelUserStories adaptee;
    JPanelUserStory_jTableResponsavel_mouseAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableResponsavel_mouseClicked(e);
    }
}


class JPanelUserStory_jButtonFimEfetivo_actionAdapter implements ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonFimEfetivo_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonFimEfetivo_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonInicioEfetivo_actionAdapter implements
        ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonInicioEfetivo_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonInicioEfetivo_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonFimPrevisto_actionAdapter implements
        ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonFimPrevisto_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonFimPrevisto_actionPerformed(e);
    }
}


class JPanelUserStory_jTableMedia_mouseAdapter extends MouseAdapter {
    private JPanelUserStories adaptee;
    JPanelUserStory_jTableMedia_mouseAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableMedia_mouseClicked(e);
    }
}


class JPanelUserStory_jTableAltoList_mouseAdapter extends MouseAdapter {
    private JPanelUserStories adaptee;
    JPanelUserStory_jTableAltoList_mouseAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableAltoList_mouseClicked(e);
    }
}


class JPanelUserStory_jTableMuitAltoList_mouseAdapter extends MouseAdapter {
    private JPanelUserStories adaptee;
    JPanelUserStory_jTableMuitAltoList_mouseAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTableMuitAltoList_mouseClicked(e);
    }
}


class JPanelUserStory_jButtonEditar_actionAdapter implements ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonEditar_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonEditar_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonExcluir_actionAdapter implements ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonExcluir_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonExcluir_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonAdicionar_actionAdapter implements ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonAdicionar_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAdicionar_actionPerformed(e);
    }
}


class JPanelUserStory_jButtonInicioPrevisto_actionAdapter implements
        ActionListener {
    private JPanelUserStories adaptee;
    JPanelUserStory_jButtonInicioPrevisto_actionAdapter(JPanelUserStories adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonInicioPrevisto_actionPerformed(e);
    }
}
