package br.ufsc.fcama.ig.objAux;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class JDialogSelecao extends JDialog {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
	private boolean selecionou = false;

    public JDialogSelecao(JFrame frame, String titulo,AbstractTableModel model ) {
    	super(frame, titulo);
    	try {
        	this.jTable = new JTable(model);
        	jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
    	this.getContentPane().setLayout(borderLayout1);
        this.setModal(true);
        jPanel4.setBackground(Color.white);
        jPanel2.setBackground(Color.white);
        jPanel3.setBackground(Color.white);
        jPanel1.setBackground(Color.white);
        jPanel1.setLayout(flowLayout1);
        flowLayout1.setHgap(0);
        flowLayout1.setVgap(5);
        jButtonCancela.setPreferredSize(new Dimension(83, 23));
        jButtonCancela.setToolTipText("");
        jButtonCancela.setText(this.rb.getString("jDialogSelecao.jButton.cancelar"));
        jButtonCancela.addActionListener(new
                JDialogSelecao_jButtonCancela_actionAdapter(this));
        jButtonSeleciona.setToolTipText("");
        jButtonSeleciona.setText(this.rb.getString("jDialogSelecao.jButton.selecionar"));
        jButtonSeleciona.addActionListener(new
                JDialogSelecao_jButtonSeleciona_actionAdapter(this));
        this.getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jTable);
        this.getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);
        jPanel1.add(jButtonSeleciona);
        jPanel1.add(jButtonCancela);
        this.getContentPane().add(jPanel3, java.awt.BorderLayout.EAST);
        this.getContentPane().add(jPanel4, java.awt.BorderLayout.NORTH);
        this.getContentPane().add(jPanel2, java.awt.BorderLayout.WEST);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable jTable = new JTable();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JButton jButtonCancela = new JButton();
    JButton jButtonSeleciona = new JButton();
    public void jButtonSeleciona_actionPerformed(ActionEvent e) {
    	if (this.jTable.getSelectedRow() != -1){
    		this.selecionou = true;
    		this.setVisible(false);
    	}else{
    		JOptionPane.showConfirmDialog(this, this.rb.getString("jDialogSelecao.erro.msn.selecao") ,this.rb.getString("jDialogSelecao.erro.msn.selecao.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	}
    }

    public void jButtonCancela_actionPerformed(ActionEvent e) {
    	this.selecionou = false;
    	this.setVisible(false);
    }

    public int selecionar(){
    	this.setVisible(true);
    	if (this.selecionou){
    		return this.jTable.getSelectedRow();
    	}else{
    		return -1;
    	}
    }
}


class JDialogSelecao_jButtonSeleciona_actionAdapter implements ActionListener {
    private JDialogSelecao adaptee;
    JDialogSelecao_jButtonSeleciona_actionAdapter(JDialogSelecao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonSeleciona_actionPerformed(e);
    }
}


class JDialogSelecao_jButtonCancela_actionAdapter implements ActionListener {
    private JDialogSelecao adaptee;
    JDialogSelecao_jButtonCancela_actionAdapter(JDialogSelecao adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancela_actionPerformed(e);
    }
}
