package br.ufsc.fcama.ig.objAux;

import javax.swing.JTextField;
import java.awt.Toolkit;

public class JNumberTextField extends JTextField {
	private boolean beep_on_error = false;
	  
	  public JNumberTextField()
	  {
	    super();
	    initializeForNumbers();
	  }
	  
	  private void initializeForNumbers()
	  {
	    setDocument(new javax.swing.text.PlainDocument()
	    {
	      public void insertString(int offs, String str, javax.swing.text.AttributeSet a) throws    javax.swing.text.BadLocationException 
	      {
	        StringBuffer buf = new StringBuffer(str);
	        int size = buf.length();
	        char c;
	        for (int i = 0; i < size; i++)
	        {
	          c = buf.charAt(i);
	          
	          // allow digits and '.' as well as ',' for delimiting
	          if (!Character.isDigit(c) && c != '.' && c != ',')
	          {
	              // beep on error
	              
	              if (beep_on_error){
	                 Toolkit.getDefaultToolkit().beep(); 
	              }
	                 buf.deleteCharAt(i);
	          }
	        }
	        super.insertString(offs, buf.toString(), a);
	      }

	    });
	  }
	  
	  public void setBeepOnError(boolean beep)
	  {
	    beep_on_error = beep;
	  }
	}

