package br.ufsc.fcama.ig.objAux;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.tableModel.TableModelAnexo;
import br.ufsc.fcama.ig.tableModel.TableModelStakeholder;
import br.ufsc.fcama.logica.objAux.Anexo;
import br.ufsc.fcama.logica.objAux.RequisitoAnexo;
import br.ufsc.fcama.logica.pratica.PraticaDocumentacaoDetalhada;

public class RequisitoAnexoVisualizar extends JPanel {
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private FramePrincipal frame;
    private TableModelStakeholder tableModelStakeholder;
    private TableModelAnexo tableModelAnexo;
    private RequisitoAnexo requisito;
    //para saber se est sendo editado ou se  incluso
    private SpinnerNumberModel spinnerNumberCiclos;
    private SpinnerNumberModel spinnerNumberOrdem;
    private SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy" );
    //os anexos novos do requisito so colocados no anexosNovos e as files de origem
    //em filesOrigem para depois serem salvos
    
    public RequisitoAnexoVisualizar(FramePrincipal frame, RequisitoAnexo requisito) {
        try {
            this.frame = frame;
            this.requisito = requisito;
            this.setDados();
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    

    

    public void jButtonVisualizar_actionPerformed(ActionEvent e) {
    	if (this.jTableReqAnexos.getSelectedRow() != -1){
    		  this.visualizarAnexo(this.tableModelAnexo.getAnexo(this.jTableReqAnexos.getSelectedRow()));
    	}else{
    		  JOptionPane.showConfirmDialog(this.frame,this.rb.getString("jPanelDocumentacaoDetalhada.erro.msn.abrirAnexo") ,this.rb.getString("jPanelDocumentacaoDetalhada.erro.msn.abrirAnexo.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
    	 }
    }
    

    private void visualizarAnexo(Anexo anexo){
    	  try {
  			this.frame.getControlador().visualizarAnexo(anexo);
  		} catch (IOException e) {
  			JOptionPane.showConfirmDialog(this.frame, this.rb.getString("jPanelDocumentacaoDetalhada.erro.msn.visualizar") ,this.rb.getString("jPanelDocumentacaoDetalhada.erro.msn.visualizar.titulo"), JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE);
  		}
      }

    




    private void setDados(){
    	this.jTextFieldNome.setText(this.requisito.getNome());
    	this.jTextFieldNome.setEditable(false);
    	this.jNumberTextField.setText(String.valueOf(this.requisito.getTempoEstimado()));
    	this.jNumberTextField.setEditable(false);
    	if (this.requisito.getDtInicioPrevisto() != null){
    		this.jTextFieldInicioPrevisto.setText(this.format.format(this.requisito.getDtInicioPrevisto()));
    		
    	}
    	if (this.requisito.getDtFimPrevisto() != null){
    		this.jTextFieldFimPrevisto.setText(this.format.format(this.requisito.getDtFimPrevisto()));
    	}
    	if (this.requisito.getDtInicio() != null){
    		this.jTextFieldInicioEfetivo.setText(this.format.format(this.requisito.getDtInicio()));
    		
    	}
    	if (this.requisito.getDtFim() != null){
    		this.jTextFieldFimEfetivo.setText(this.format.format(this.requisito.getDtFim()));
    	}
    	
    	
    	
    	this.tableModelStakeholder = new TableModelStakeholder(new ArrayList(this.requisito.getResponsaveis()));
        this.jTableResponsavel = new JTable(this.tableModelStakeholder);

        this.tableModelAnexo = new TableModelAnexo(new ArrayList(this.requisito.getAnexos()));
        this.jTableReqAnexos = new JTable(this.tableModelAnexo );

        
        this.spinnerNumberCiclos = new SpinnerNumberModel(0,0,this.frame.getControlador().getProjeto().getIteracoes().size(), 1);
        this.jSpinnerCiclo = new JSpinner(this.spinnerNumberCiclos);
        this.spinnerNumberCiclos.setValue(new Integer(this.requisito.getNuCincloDeDesenvolvimento()));
        this.jSpinnerCiclo.setEnabled(false);
        
        this.spinnerNumberOrdem = new SpinnerNumberModel(0,0,10000,1);
        this.jSpinnerOrdem = new JSpinner(this.spinnerNumberOrdem);
        this.spinnerNumberOrdem.setValue(new Integer(this.requisito.getOrdem()));
        this.jSpinnerOrdem.setEnabled(false);
        
    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.alta"));
    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.media"));
    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.muitoAlta"));
    	if(this.requisito.getPrioridade().equals("Alta")){
    		this.jComboBoxPrioridade.setSelectedIndex(0);
    	}else if(this.requisito.getPrioridade().equals("Mdia")){
    		this.jComboBoxPrioridade.setSelectedIndex(1);
    	}else{
    		this.jComboBoxPrioridade.setSelectedIndex(2);
    	}
    	this.jComboBoxPrioridade.setEnabled(false);

    	this.jButtonFimPrevisto.setEnabled(false);
    	this.jButtonInicioPrevisto.setEnabled(false);
    	this.jButtonFimEfetivo.setEnabled(false);
    	this.jButtonInicioEfetivo.setEnabled(false);

    	

    
    }


    private void jbInit() throws Exception {

        this.setLayout(borderLayout1);
        jPanelCadastro.setLayout(borderLayout4);
        jPanel4.setBackground(SystemColor.control);
        jPanel4.setLayout(flowLayout2);
        jPanel5.setBackground(new Color(236, 233, 90));
        jPanel5.setLayout(gridLayout2);
        jTextFieldNome.setPreferredSize(new Dimension(250, 20));
        jTextFieldInicioPrevisto.setEnabled(false);
        jTextFieldInicioPrevisto.setPreferredSize(new Dimension(94, 20));
        jTextFieldInicioPrevisto.setRequestFocusEnabled(false);
        jNumberTextField.setPreferredSize(new Dimension(70, 20));
        jButtonInicioPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setIcon(iconDate);
        jTextFieldFimPrevisto.setEnabled(false);
        jTextFieldFimPrevisto.setPreferredSize(new Dimension(94, 20));
        jTextFieldFimPrevisto.setRequestFocusEnabled(false);
        jButtonFimPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonFimPrevisto.setIcon(iconDate);
        jTextFieldInicioEfetivo.setEnabled(false);
        jTextFieldInicioEfetivo.setPreferredSize(new Dimension(94, 20));
        jTextFieldInicioEfetivo.setRequestFocusEnabled(false);
        jButtonFimEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonFimEfetivo.setIcon(iconDate);
        jTextFieldFimEfetivo.setEnabled(false);
        jTextFieldFimEfetivo.setPreferredSize(new Dimension(94, 20));
        jTextFieldFimEfetivo.setRequestFocusEnabled(false);
        jButtonInicioEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setIcon(iconDate);
        jButtonInicioEfetivo.setMnemonic('0');
        jSpinnerCiclo.setMaximumSize(new Dimension(50, 20));
        jSpinnerCiclo.setPreferredSize(new Dimension(50, 20));
        jSpinnerOrdem.setMaximumSize(new Dimension(50, 20));
        jSpinnerOrdem.setPreferredSize(new Dimension(50, 20));
        jLabel5.setToolTipText("");
        jLabel5.setText(this.rb.getString("jPanelRequisitos.jLabel.nome"));
        jLabel6.setToolTipText("");
        jLabel6.setText(this.rb.getString("jPanelRequisitos.jLabel.prioridade"));
        jLabel7.setToolTipText("");
        jLabel7.setText(this.rb.getString("jPanelRequisitos.jLabel.ordem"));
        jLabel8.setToolTipText("");
        jLabel8.setText(this.rb.getString("jPanelRequisitos.jLabel.iteracao"));
        jLabel9.setToolTipText("");
        jLabel9.setText(this.rb.getString("jPanelRequisitos.jLabel.inicioEfetivo"));
        jLabel10.setToolTipText("");
        jLabel10.setText(this.rb.getString("jPanelRequisitos.jlabel.fimEfetivo"));
        jLabel12.setToolTipText("");
        jLabel12.setText(this.rb.getString("jPanelRequisitos.jLabel.inicioPrevisto"));
        jLabel13.setToolTipText("");
        jLabel13.setText(this.rb.getString("jPanelRequisitos.jlabel.fimPrevisto"));
        jLabel14.setToolTipText("");
        jLabel14.setText(this.rb.getString("jPanelRequisitos.jLabel.duracao"));
        jPanel6.setBackground(SystemColor.control);
        jPanel6.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(5);
        jPanel7.setBackground(SystemColor.control);
        jPanel7.setLayout(gridLayout6);
        jPanel8.setBackground(SystemColor.control);
        jPanel8.setLayout(gridLayout5);
        jPanel11.setBackground(SystemColor.control);
        jPanel11.setLayout(gridLayout8);
        jPanel13.setBackground(SystemColor.control);
        jPanel13.setLayout(gridLayout4);
        jPanel10.setLayout(gridLayout7);
        jPanel15.setLayout(flowLayout4);
        gridLayout5.setColumns(2);
        gridLayout5.setRows(2);
        jPanel18.setLayout(flowLayout5);
        jPanel19.setLayout(flowLayout6);
        jPanel17.setLayout(flowLayout7);
        flowLayout4.setAlignment(FlowLayout.LEFT);
        flowLayout4.setHgap(0);
        flowLayout6.setAlignment(FlowLayout.LEFT);
        flowLayout6.setHgap(0);
        flowLayout5.setAlignment(FlowLayout.LEFT);
        flowLayout5.setHgap(0);
        flowLayout7.setAlignment(FlowLayout.LEFT);
        flowLayout7.setHgap(0);
        jPanel20.setLayout(flowLayout8);
        jPanel23.setLayout(flowLayout9);
        jPanel22.setLayout(flowLayout10);
        jPanel21.setLayout(flowLayout11);
        flowLayout8.setAlignment(FlowLayout.LEFT);
        flowLayout8.setHgap(0);
        flowLayout9.setAlignment(FlowLayout.LEFT);
        flowLayout9.setHgap(0);
        flowLayout10.setAlignment(FlowLayout.LEFT);
        flowLayout10.setHgap(0);
        flowLayout11.setAlignment(FlowLayout.LEFT);
        flowLayout11.setHgap(0);
        gridLayout6.setColumns(1);
        gridLayout6.setRows(2);
        jPanel14.setLayout(flowLayout3);
        jPanel24.setLayout(flowLayout12);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        flowLayout3.setHgap(0);
        flowLayout12.setAlignment(FlowLayout.LEFT);
        flowLayout12.setHgap(0);
        gridLayout7.setColumns(2);
        gridLayout7.setRows(2);
        jPanel25.setLayout(flowLayout13);
        jPanel28.setLayout(flowLayout14);
        jPanel27.setLayout(flowLayout15);
        jPanel26.setLayout(flowLayout16);
        flowLayout13.setAlignment(FlowLayout.LEFT);
        flowLayout13.setHgap(0);
        flowLayout14.setAlignment(FlowLayout.LEFT);
        flowLayout14.setHgap(0);
        flowLayout15.setAlignment(FlowLayout.LEFT);
        flowLayout15.setHgap(0);
        flowLayout16.setAlignment(FlowLayout.LEFT);
        flowLayout16.setHgap(0);
        gridLayout8.setColumns(2);
        gridLayout8.setRows(2);
        gridLayout4.setColumns(2);
        gridLayout4.setRows(2);
        jPanel9.setLayout(flowLayout17);
        jPanel30.setLayout(flowLayout18);
        jPanel31.setLayout(flowLayout19);
        jPanel29.setLayout(flowLayout20);
        flowLayout17.setAlignment(FlowLayout.LEFT);
        flowLayout17.setHgap(0);
        flowLayout19.setAlignment(FlowLayout.LEFT);
        flowLayout19.setHgap(0);
        flowLayout18.setAlignment(FlowLayout.LEFT);
        flowLayout18.setHgap(0);
        flowLayout20.setAlignment(FlowLayout.LEFT);
        flowLayout20.setHgap(0);
        jPanel10.setBackground(SystemColor.control);
        jLabel11.setToolTipText("");
        jLabel11.setText(this.rb.getString("jPanelRequisitos.jLabel.responsaveis"));
        jPanel16.setLayout(flowLayout21);
        jComboBoxPrioridade.setPreferredSize(new Dimension(100, 20));
        jPanel32.setLayout(flowLayout22);
        flowLayout22.setAlignment(FlowLayout.LEFT);
        flowLayout22.setHgap(0);
        jTextAreaDescricao.setText("");
        jTextAreaDescricao.setLineWrap(true);
        jPanel34.setLayout(borderLayout7);
        jPanel35.setLayout(borderLayout8);
        jPanel35.setPreferredSize(new Dimension(200, 175));
        jPanel35.setToolTipText("");
        jScrollPaneResp.setPreferredSize(new Dimension(100, 100));
        jPanel12.setLayout(flowLayout23);
        jPanel33.setLayout(flowLayout24);
        flowLayout24.setAlignment(FlowLayout.LEFT);
        flowLayout24.setHgap(13);
        jPanel37.setBackground(Color.pink);
        jPanel37.setLayout(borderLayout5);
        jPanel40.setLayout(flowLayout25);
        flowLayout25.setAlignment(FlowLayout.LEFT);
        flowLayout25.setHgap(13);
        flowLayout25.setVgap(10);
        jLabel15.setToolTipText("");
        jLabel15.setText(this.rb.getString("jPanelDocumentacaoDetalhada.jLabel.anexarRequisito"));
        jPanel41.setLayout(flowLayout26);
        jButtonVisualizar.setText(this.rb.getString("jPanelDocumentacaoDetalhada.jButton.visualizar"));
        jButtonVisualizar.addActionListener(new
                RequisitoAnexoVisualizar_jButtonVisualizar_actionAdapter(this));
        jPanel7.add(jPanel14);
        jPanel14.add(jLabel5);
        jPanel7.add(jPanel24);
        jPanel24.add(jTextFieldNome);
        jPanel6.add(jPanel7);

        jPanel10.add(jPanel25);
        jPanel25.add(jLabel9);
        jPanel10.add(jPanel28);
        jPanel28.add(jLabel10);
        jPanel10.add(jPanel27);
        jPanel27.add(jTextFieldInicioEfetivo);
        jPanel27.add(jButtonInicioEfetivo);
        jPanel10.add(jPanel26);
        jPanel26.add(jTextFieldFimEfetivo);
        jPanel26.add(jButtonFimEfetivo);
        jPanel34.add(jPanel35, java.awt.BorderLayout.SOUTH);
        jPanel6.add(jPanel8);
        jPanel13.add(jPanel9);
        jPanel9.add(jLabel12);
        jPanel13.add(jPanel31);
        jPanel31.add(jLabel13);
        jPanel13.add(jPanel29);
        jPanel29.add(jTextFieldInicioPrevisto);
        jPanel29.add(jButtonInicioPrevisto);
        jPanel13.add(jPanel30);
        jPanel30.add(jTextFieldFimPrevisto);
        jPanel30.add(jButtonFimPrevisto);
        jPanel6.add(jPanel11);

        jPanel8.add(jPanel15, null);
        jPanel15.add(jLabel6);
        jPanel8.add(jPanel19);
        jPanel19.add(jLabel8);
        jPanel8.add(jPanel18);
        jPanel18.add(jComboBoxPrioridade);
        jPanel8.add(jPanel17);
        jPanel17.add(jSpinnerCiclo);
        jPanel6.add(jPanel13);

        jPanelCadastro.add(jPanel5, java.awt.BorderLayout.CENTER);
        jPanel5.add(jPanel34, null);
        jPanel35.add(jPanel12, java.awt.BorderLayout.WEST);
        jPanel35.add(jPanel33, java.awt.BorderLayout.NORTH);
        jPanel33.add(jLabel11);
        jPanel35.add(jScrollPaneResp, java.awt.BorderLayout.CENTER);
        jPanel35.add(jPanel16, java.awt.BorderLayout.SOUTH);
        jScrollPaneResp.getViewport().add(jTableResponsavel);
        jPanel34.add(jPanel36, java.awt.BorderLayout.WEST);
        jPanel34.add(jPanel6, java.awt.BorderLayout.CENTER);
        jPanel20.add(jPanel23);
        jPanel20.add(jSpinnerOrdem);
        jPanel6.add(jPanel10);

        jPanel11.add(jPanel22);
        jPanel22.add(jLabel14);
        jPanel11.add(jPanel32);
        jPanel32.add(jLabel7);
        jPanel11.add(jPanel21);
        jPanel21.add(jNumberTextField);
        jPanel11.add(jPanel20);

        jPanel5.add(jPanel37, null);
        jPanel37.add(jPanel38, java.awt.BorderLayout.WEST);
        jPanel37.add(jPanel39, java.awt.BorderLayout.EAST);
        jPanel37.add(jScrollPaneDesc, java.awt.BorderLayout.CENTER);
        jPanel37.add(jPanel40, java.awt.BorderLayout.NORTH);
        jPanel40.add(jLabel15);
        jPanel37.add(jPanel41, java.awt.BorderLayout.SOUTH);
        jScrollPaneDesc.getViewport().add(jTableReqAnexos);

        jPanel41.add(jButtonVisualizar);
        jPanelCadastro.add(jPanel4, java.awt.BorderLayout.SOUTH);
        this.add(jPanelCadastro, java.awt.BorderLayout.CENTER);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelCadastro = new JPanel();
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();
    JTextField jTextFieldNome = new JTextField();
    JSpinner jSpinnerCiclo = new JSpinner();
    JSpinner jSpinnerOrdem = new JSpinner();
    JTextField jTextFieldInicioPrevisto = new JTextField();
    JNumberTextField jNumberTextField = new JNumberTextField();
    Icon iconDate = new ImageIcon("imagens/date.gif");
    JButton jButtonInicioPrevisto = new JButton();
    JTextField jTextFieldFimPrevisto = new JTextField();
    JButton jButtonFimPrevisto = new JButton();
    JTextField jTextFieldInicioEfetivo = new JTextField();
    JButton jButtonFimEfetivo = new JButton();
    JTextField jTextFieldFimEfetivo = new JTextField();
    JButton jButtonInicioEfetivo = new JButton();
    JLabel jLabel5 = new JLabel();
    JLabel jLabel6 = new JLabel();
    JLabel jLabel7 = new JLabel();
    JLabel jLabel8 = new JLabel();
    JLabel jLabel9 = new JLabel();
    JLabel jLabel10 = new JLabel();
    JLabel jLabel12 = new JLabel();
    JLabel jLabel13 = new JLabel();
    JLabel jLabel14 = new JLabel();
    JPanel jPanel6 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel7 = new JPanel();
    JPanel jPanel8 = new JPanel();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    JPanel jPanel13 = new JPanel();
    JPanel jPanel15 = new JPanel();
    GridLayout gridLayout3 = new GridLayout();
    GridLayout gridLayout5 = new GridLayout();
    JPanel jPanel17 = new JPanel();
    JPanel jPanel18 = new JPanel();
    JPanel jPanel19 = new JPanel();
    FlowLayout flowLayout4 = new FlowLayout();
    FlowLayout flowLayout5 = new FlowLayout();
    FlowLayout flowLayout6 = new FlowLayout();
    FlowLayout flowLayout7 = new FlowLayout();
    JPanel jPanel20 = new JPanel();
    JPanel jPanel21 = new JPanel();
    JPanel jPanel22 = new JPanel();
    JPanel jPanel23 = new JPanel();
    FlowLayout flowLayout8 = new FlowLayout();
    FlowLayout flowLayout9 = new FlowLayout();
    FlowLayout flowLayout10 = new FlowLayout();
    FlowLayout flowLayout11 = new FlowLayout();
    GridLayout gridLayout6 = new GridLayout();
    JPanel jPanel14 = new JPanel();
    JPanel jPanel24 = new JPanel();
    FlowLayout flowLayout3 = new FlowLayout();
    FlowLayout flowLayout12 = new FlowLayout();
    GridLayout gridLayout7 = new GridLayout();
    JPanel jPanel25 = new JPanel();
    JPanel jPanel26 = new JPanel();
    JPanel jPanel27 = new JPanel();
    JPanel jPanel28 = new JPanel();
    FlowLayout flowLayout13 = new FlowLayout();
    FlowLayout flowLayout14 = new FlowLayout();
    FlowLayout flowLayout15 = new FlowLayout();
    FlowLayout flowLayout16 = new FlowLayout();
    GridLayout gridLayout8 = new GridLayout();
    JPanel jPanel32 = new JPanel();
    GridLayout gridLayout4 = new GridLayout();
    JPanel jPanel9 = new JPanel();
    JPanel jPanel29 = new JPanel();
    JPanel jPanel30 = new JPanel();
    JPanel jPanel31 = new JPanel();
    FlowLayout flowLayout17 = new FlowLayout();
    FlowLayout flowLayout18 = new FlowLayout();
    FlowLayout flowLayout19 = new FlowLayout();
    FlowLayout flowLayout20 = new FlowLayout();
    BorderLayout borderLayout4 = new BorderLayout();
    JLabel jLabel11 = new JLabel();
    JPanel jPanel16 = new JPanel();
    FlowLayout flowLayout21 = new FlowLayout();
    JScrollPane jScrollPaneResp = new JScrollPane();
    JTable jTableresp = new JTable();
    JComboBox jComboBoxPrioridade = new JComboBox();
    FlowLayout flowLayout22 = new FlowLayout();
    JTextArea jTextAreaDescricao = new JTextArea();
    JPanel jPanel34 = new JPanel();
    BorderLayout borderLayout7 = new BorderLayout();
    JPanel jPanel35 = new JPanel();
    BorderLayout borderLayout8 = new BorderLayout();
    JTable jTableResponsavel = new JTable();
    JPanel jPanel36 = new JPanel();
    JPanel jPanel12 = new JPanel();
    FlowLayout flowLayout23 = new FlowLayout();
    JPanel jPanel33 = new JPanel();
    FlowLayout flowLayout24 = new FlowLayout();
    JPanel jPanel37 = new JPanel();
    GridLayout gridLayout2 = new GridLayout();
    BorderLayout borderLayout5 = new BorderLayout();
    JPanel jPanel38 = new JPanel();
    JPanel jPanel39 = new JPanel();
    JPanel jPanel40 = new JPanel();
    FlowLayout flowLayout25 = new FlowLayout();
    JLabel jLabel15 = new JLabel();
    JScrollPane jScrollPaneDesc = new JScrollPane();
    JPanel jPanel41 = new JPanel();

    JTable jTableReqAnexos = new JTable();
    FlowLayout flowLayout26 = new FlowLayout();
    JButton jButtonVisualizar = new JButton();
   

}



class RequisitoAnexoVisualizar_jButtonVisualizar_actionAdapter implements
        ActionListener {
    private RequisitoAnexoVisualizar adaptee;
    RequisitoAnexoVisualizar_jButtonVisualizar_actionAdapter(
            RequisitoAnexoVisualizar adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonVisualizar_actionPerformed(e);
    }
}


