package br.ufsc.fcama.ig.objAux;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.SystemColor;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.text.MaskFormatter;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.tableModel.TableModelStakeholder;
import br.ufsc.fcama.logica.objAux.Requisito;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class RequisitosVisualizar extends JPanel {
    private FramePrincipal frame;
    private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    
    
    public RequisitosVisualizar(FramePrincipal frame, Requisito requisito) {
        try {
            this.frame = frame;
            this.setDados(requisito);
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private void setDados(Requisito requisito) throws ParseException{
        formatoData = new MaskFormatter("**/**/****");
        
        this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.alta"));
    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.media"));
    	this.jComboBoxPrioridade.addItem(this.rb.getString("jPanelRequisitos.prioridade.muitoAlta"));

        TableModelStakeholder tableModelStakeholder = new TableModelStakeholder(new ArrayList());
        this.jTableResponsavel = new JTable(tableModelStakeholder);
    	
    	SpinnerNumberModel spinnerNumberCiclos;
        SpinnerNumberModel spinnerNumberOrdem;
    	spinnerNumberCiclos = new SpinnerNumberModel(0,0,this.frame.getControlador().getProjeto().getIteracoes().size(), 1);
        this.jSpinnerCiclo = new JSpinner(spinnerNumberCiclos);
        
        spinnerNumberOrdem = new SpinnerNumberModel(0,0,10000,1);
        this.jSpinnerOrdem = new JSpinner(spinnerNumberOrdem);
        
    	SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy" );
    	
    	this.jTextAreaDesc.setText(requisito.getDescricao());
    	this.jTextFieldNome.setText(requisito.getNome());
    	this.jNumberTextField.setText(String.valueOf(requisito.getTempoEstimado()));
    	if (requisito.getDtInicioPrevisto() != null){
    		this.jTextFieldInicioPrevisto.setText(format.format(requisito.getDtInicioPrevisto()));
    	}
    	if (requisito.getDtFimPrevisto() != null){
    		this.jTextFieldFimPrevisto.setText(format.format(requisito.getDtFimPrevisto()));
    	}
    	if (requisito.getDtInicio() != null){
    		this.jTextFieldInicioEfetivo.setText(format.format(requisito.getDtInicio()));
    	}
    	if (requisito.getDtFim() != null){
    		this.jTextFieldFimEfetivo.setText(format.format(requisito.getDtFim()));
    	}
    	spinnerNumberCiclos.setValue(new Integer(requisito.getNuCincloDeDesenvolvimento()));
    	spinnerNumberOrdem.setValue(new Integer(requisito.getOrdem()));
    	if(requisito.getPrioridade().equals("Alta")){
    		this.jComboBoxPrioridade.setSelectedIndex(0);
    	}else if(requisito.getPrioridade().equals("Mdia")){
    		this.jComboBoxPrioridade.setSelectedIndex(1);
    	}else{
    		this.jComboBoxPrioridade.setSelectedIndex(2);
    	}
    	tableModelStakeholder.setStakeholders(new ArrayList(requisito.getResponsaveis()));
    	this.jTableResponsavel.addNotify();
    	
    }
    
    

    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        jPanelCadastro.setLayout(borderLayout4);
        jPanel5.setBackground(new Color(236, 233, 90));
        jPanel5.setLayout(gridLayout2);
        jTextFieldNome.setPreferredSize(new Dimension(250, 20));
        jTextFieldNome.setEditable(false);
        jTextFieldInicioPrevisto.setEnabled(false);
        jTextFieldInicioPrevisto.setPreferredSize(new Dimension(94, 20));
        jTextFieldInicioPrevisto.setRequestFocusEnabled(false);
        jNumberTextField.setEditable(false);
        jNumberTextField.setPreferredSize(new Dimension(70, 20));
        jButtonInicioPrevisto.setEnabled(false);
        jButtonInicioPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonInicioPrevisto.setIcon(iconDate);
        jTextFieldFimPrevisto.setEnabled(false);
        jTextFieldFimPrevisto.setPreferredSize(new Dimension(94, 20));
        jTextFieldFimPrevisto.setRequestFocusEnabled(false);
        jButtonFimPrevisto.setEnabled(false);
        jButtonFimPrevisto.setMaximumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setMinimumSize(new Dimension(20, 20));
        jButtonFimPrevisto.setPreferredSize(new Dimension(20, 20));
        jButtonFimPrevisto.setIcon(iconDate);
        jTextFieldInicioEfetivo.setEnabled(false);
        jTextFieldInicioEfetivo.setPreferredSize(new Dimension(94, 20));
        jTextFieldInicioEfetivo.setRequestFocusEnabled(false);
        jButtonFimEfetivo.setEnabled(false);
        jButtonFimEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonFimEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonFimEfetivo.setIcon(iconDate);
        jTextFieldFimEfetivo.setEnabled(false);
        jTextFieldFimEfetivo.setPreferredSize(new Dimension(94, 20));
        jTextFieldFimEfetivo.setRequestFocusEnabled(false);
        jButtonInicioEfetivo.setEnabled(false);
        jButtonInicioEfetivo.setMaximumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setMinimumSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setPreferredSize(new Dimension(20, 20));
        jButtonInicioEfetivo.setIcon(iconDate);
        jButtonInicioEfetivo.setMnemonic('0');
        jSpinnerCiclo.setEnabled(false);
        jSpinnerCiclo.setMaximumSize(new Dimension(50, 20));
        jSpinnerCiclo.setPreferredSize(new Dimension(50, 20));
        jSpinnerOrdem.setEnabled(false);
        jSpinnerOrdem.setMaximumSize(new Dimension(50, 20));
        jSpinnerOrdem.setPreferredSize(new Dimension(50, 20));
        jLabel5.setText(this.rb.getString("jPanelRequisitos.jLabel.nome"));
        jLabel6.setText(this.rb.getString("jPanelRequisitos.jLabel.prioridade"));
        jLabel7.setText(this.rb.getString("jPanelRequisitos.jLabel.duracao"));
        jLabel8.setText(this.rb.getString("jPanelRequisitos.jLabel.ordem"));
        jLabel9.setText(this.rb.getString("jPanelRequisitos.jLabel.inicioEfetivo"));
        jLabel10.setText(this.rb.getString("jPanelRequisitos.jlabel.fimEfetivo"));
        jLabel12.setText(this.rb.getString("jPanelRequisitos.jLabel.inicioPrevisto"));
        jLabel13.setText(this.rb.getString("jPanelRequisitos.jlabel.fimPrevisto"));
        jLabel14.setText(this.rb.getString("jPanelRequisitos.jLabel.iteracao"));
        jPanel6.setBackground(SystemColor.control);
        jPanel6.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(5);
        jPanel7.setBackground(SystemColor.control);
        jPanel7.setLayout(gridLayout6);
        jPanel8.setBackground(SystemColor.control);
        jPanel8.setLayout(gridLayout5);
        jPanel11.setBackground(SystemColor.control);
        jPanel11.setLayout(gridLayout8);
        jPanel13.setBackground(SystemColor.control);
        jPanel13.setLayout(gridLayout4);
        jPanel10.setLayout(gridLayout7);
        jPanel15.setLayout(flowLayout4);
        gridLayout5.setColumns(2);
        gridLayout5.setRows(2);
        jPanel18.setLayout(flowLayout5);
        jPanel19.setLayout(flowLayout6);
        jPanel17.setLayout(flowLayout7);
        flowLayout4.setAlignment(FlowLayout.LEFT);
        flowLayout4.setHgap(0);
        flowLayout6.setAlignment(FlowLayout.LEFT);
        flowLayout6.setHgap(0);
        flowLayout5.setAlignment(FlowLayout.LEFT);
        flowLayout5.setHgap(0);
        flowLayout7.setAlignment(FlowLayout.LEFT);
        flowLayout7.setHgap(0);
        jPanel20.setLayout(flowLayout8);
        jPanel23.setLayout(flowLayout9);
        jPanel22.setLayout(flowLayout10);
        jPanel21.setLayout(flowLayout11);
        flowLayout8.setAlignment(FlowLayout.LEFT);
        flowLayout8.setHgap(0);
        flowLayout9.setAlignment(FlowLayout.LEFT);
        flowLayout9.setHgap(0);
        flowLayout10.setAlignment(FlowLayout.LEFT);
        flowLayout10.setHgap(0);
        flowLayout11.setAlignment(FlowLayout.LEFT);
        flowLayout11.setHgap(0);
        gridLayout6.setColumns(1);
        gridLayout6.setRows(2);
        jPanel14.setLayout(flowLayout3);
        jPanel24.setLayout(flowLayout12);
        flowLayout3.setAlignment(FlowLayout.LEFT);
        flowLayout3.setHgap(0);
        flowLayout12.setAlignment(FlowLayout.LEFT);
        flowLayout12.setHgap(0);
        gridLayout7.setColumns(2);
        gridLayout7.setRows(2);
        jPanel25.setLayout(flowLayout13);
        jPanel28.setLayout(flowLayout14);
        jPanel27.setLayout(flowLayout15);
        jPanel26.setLayout(flowLayout16);
        flowLayout13.setAlignment(FlowLayout.LEFT);
        flowLayout13.setHgap(0);
        flowLayout14.setAlignment(FlowLayout.LEFT);
        flowLayout14.setHgap(0);
        flowLayout15.setAlignment(FlowLayout.LEFT);
        flowLayout15.setHgap(0);
        flowLayout16.setAlignment(FlowLayout.LEFT);
        flowLayout16.setHgap(0);
        gridLayout8.setColumns(2);
        gridLayout8.setRows(2);
        gridLayout4.setColumns(2);
        gridLayout4.setRows(2);
        jPanel9.setLayout(flowLayout17);
        jPanel30.setLayout(flowLayout18);
        jPanel31.setLayout(flowLayout19);
        jPanel29.setLayout(flowLayout20);
        flowLayout17.setAlignment(FlowLayout.LEFT);
        flowLayout17.setHgap(0);
        flowLayout19.setAlignment(FlowLayout.LEFT);
        flowLayout19.setHgap(0);
        flowLayout18.setAlignment(FlowLayout.LEFT);
        flowLayout18.setHgap(0);
        flowLayout20.setAlignment(FlowLayout.LEFT);
        flowLayout20.setHgap(0);
        jPanel10.setBackground(SystemColor.control);
        jLabel11.setToolTipText("");
        jLabel11.setText(this.rb.getString("jPanelRequisitos.jLabel.responsaveis"));
        jPanel16.setLayout(flowLayout21);
        jComboBoxPrioridade.setEnabled(true);
        jComboBoxPrioridade.setPreferredSize(new Dimension(100, 20));
        jPanel32.setLayout(flowLayout22);
        flowLayout22.setAlignment(FlowLayout.LEFT);
        flowLayout22.setHgap(0);
        jTextAreaDescricao.setLineWrap(true);
        jPanel34.setLayout(borderLayout7);
        jPanel35.setLayout(borderLayout8);
        jPanel35.setPreferredSize(new Dimension(200, 175));
        jScrollPaneResp.setPreferredSize(new Dimension(100, 100));
        jPanel12.setLayout(flowLayout23);
        jPanel33.setLayout(flowLayout24);
        flowLayout24.setAlignment(FlowLayout.LEFT);
        flowLayout24.setHgap(13);
        jPanel37.setBackground(Color.pink);
        jPanel37.setLayout(borderLayout5);
        jPanel40.setLayout(flowLayout25);
        flowLayout25.setAlignment(FlowLayout.LEFT);
        flowLayout25.setHgap(13);
        flowLayout25.setVgap(10);
        jLabel15.setToolTipText("");
        jLabel15.setText(this.rb.getString("jPanelRequisitos.jLabel.descricao"));
        jTextAreaDesc.setEditable(false);
        jTextAreaDesc.setLineWrap(true);
        jPanel7.add(jPanel14);
        jPanel14.add(jLabel5);
        jPanel7.add(jPanel24);
        jPanel24.add(jTextFieldNome);
        jPanel6.add(jPanel7);

        jPanel10.add(jPanel25);
        jPanel25.add(jLabel9);
        jPanel10.add(jPanel28);
        jPanel28.add(jLabel10);
        jPanel10.add(jPanel27);
        jPanel27.add(jTextFieldInicioEfetivo);
        jPanel27.add(jButtonInicioEfetivo);
        jPanel10.add(jPanel26);
        jPanel26.add(jTextFieldFimEfetivo);
        jPanel26.add(jButtonFimEfetivo);
        jPanel34.add(jPanel35, java.awt.BorderLayout.SOUTH);
        jPanel6.add(jPanel8);
        jPanel13.add(jPanel9);
        jPanel9.add(jLabel12);
        jPanel13.add(jPanel31);
        jPanel31.add(jLabel13);
        jPanel13.add(jPanel29);
        jPanel29.add(jTextFieldInicioPrevisto);
        jPanel29.add(jButtonInicioPrevisto);
        jPanel13.add(jPanel30);
        jPanel30.add(jTextFieldFimPrevisto);
        jPanel30.add(jButtonFimPrevisto);
        jPanel5.add(jPanel34);
        jPanel6.add(jPanel11);

        jPanel8.add(jPanel15, null);
        jPanel15.add(jLabel6);
        jPanel8.add(jPanel19);
        jPanel19.add(jLabel8);
        jPanel8.add(jPanel18);
        jPanel18.add(jComboBoxPrioridade);
        jPanel8.add(jPanel17);
        jPanel17.add(jSpinnerCiclo);
        jPanel6.add(jPanel13);

        jPanelCadastro.add(jPanel5, java.awt.BorderLayout.CENTER);
        jPanel35.add(jPanel12, java.awt.BorderLayout.WEST);
        jPanel35.add(jPanel33, java.awt.BorderLayout.NORTH);
        jPanel33.add(jLabel11);
        jPanel35.add(jScrollPaneResp, java.awt.BorderLayout.CENTER);
        jPanel35.add(jPanel16, java.awt.BorderLayout.SOUTH);
        jScrollPaneResp.getViewport().add(jTableResponsavel);
        jPanel34.add(jPanel36, java.awt.BorderLayout.WEST);
        jPanel34.add(jPanel6, java.awt.BorderLayout.CENTER);
        jPanel20.add(jPanel23);
        jPanel20.add(jSpinnerOrdem);
        jPanel6.add(jPanel10);

        jPanel11.add(jPanel22);
        jPanel22.add(jLabel14);
        jPanel11.add(jPanel32);
        jPanel32.add(jLabel7);
        jPanel11.add(jPanel21);
        jPanel21.add(jNumberTextField);
        jPanel11.add(jPanel20);
        jPanel5.add(jPanel37, null);
        jPanel37.add(jPanel38, java.awt.BorderLayout.WEST);
        jPanel37.add(jPanel39, java.awt.BorderLayout.EAST);
        jPanel37.add(jScrollPaneDesc, java.awt.BorderLayout.CENTER);
        jPanel37.add(jPanel40, java.awt.BorderLayout.NORTH);
        jPanel40.add(jLabel15);
        jPanel37.add(jPanel41, java.awt.BorderLayout.SOUTH);
        jScrollPaneDesc.getViewport().add(jTextAreaDesc);

        this.add(jPanelCadastro, java.awt.BorderLayout.CENTER);
    }

    MaskFormatter formatoData ;
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelCadastro = new JPanel();
    JPanel jPanel5 = new JPanel();
    JTextField jTextFieldNome = new JTextField();
    JSpinner jSpinnerCiclo = new JSpinner();
    JSpinner jSpinnerOrdem = new JSpinner();
    JTextField jTextFieldInicioPrevisto = new JTextField();
    JNumberTextField jNumberTextField = new JNumberTextField();
    Icon iconDate = new ImageIcon("imagens/date.gif");
    JButton jButtonInicioPrevisto = new JButton();
    JTextField jTextFieldFimPrevisto = new JTextField();
    JButton jButtonFimPrevisto = new JButton();
    JTextField jTextFieldInicioEfetivo = new JTextField();
    JButton jButtonFimEfetivo = new JButton();
    JTextField jTextFieldFimEfetivo = new JTextField();
    JButton jButtonInicioEfetivo = new JButton();
    JLabel jLabel5 = new JLabel();
    JLabel jLabel6 = new JLabel();
    JLabel jLabel7 = new JLabel();
    JLabel jLabel8 = new JLabel();
    JLabel jLabel9 = new JLabel();
    JLabel jLabel10 = new JLabel();
    JLabel jLabel12 = new JLabel();
    JLabel jLabel13 = new JLabel();
    JLabel jLabel14 = new JLabel();
    JPanel jPanel6 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel7 = new JPanel();
    JPanel jPanel8 = new JPanel();
    JPanel jPanel10 = new JPanel();
    JPanel jPanel11 = new JPanel();
    JPanel jPanel13 = new JPanel();
    JPanel jPanel15 = new JPanel();
    GridLayout gridLayout3 = new GridLayout();
    GridLayout gridLayout5 = new GridLayout();
    JPanel jPanel17 = new JPanel();
    JPanel jPanel18 = new JPanel();
    JPanel jPanel19 = new JPanel();
    FlowLayout flowLayout4 = new FlowLayout();
    FlowLayout flowLayout5 = new FlowLayout();
    FlowLayout flowLayout6 = new FlowLayout();
    FlowLayout flowLayout7 = new FlowLayout();
    JPanel jPanel20 = new JPanel();
    JPanel jPanel21 = new JPanel();
    JPanel jPanel22 = new JPanel();
    JPanel jPanel23 = new JPanel();
    FlowLayout flowLayout8 = new FlowLayout();
    FlowLayout flowLayout9 = new FlowLayout();
    FlowLayout flowLayout10 = new FlowLayout();
    FlowLayout flowLayout11 = new FlowLayout();
    GridLayout gridLayout6 = new GridLayout();
    JPanel jPanel14 = new JPanel();
    JPanel jPanel24 = new JPanel();
    FlowLayout flowLayout3 = new FlowLayout();
    FlowLayout flowLayout12 = new FlowLayout();
    GridLayout gridLayout7 = new GridLayout();
    JPanel jPanel25 = new JPanel();
    JPanel jPanel26 = new JPanel();
    JPanel jPanel27 = new JPanel();
    JPanel jPanel28 = new JPanel();
    FlowLayout flowLayout13 = new FlowLayout();
    FlowLayout flowLayout14 = new FlowLayout();
    FlowLayout flowLayout15 = new FlowLayout();
    FlowLayout flowLayout16 = new FlowLayout();
    GridLayout gridLayout8 = new GridLayout();
    JPanel jPanel32 = new JPanel();
    GridLayout gridLayout4 = new GridLayout();
    JPanel jPanel9 = new JPanel();
    JPanel jPanel29 = new JPanel();
    JPanel jPanel30 = new JPanel();
    JPanel jPanel31 = new JPanel();
    FlowLayout flowLayout17 = new FlowLayout();
    FlowLayout flowLayout18 = new FlowLayout();
    FlowLayout flowLayout19 = new FlowLayout();
    FlowLayout flowLayout20 = new FlowLayout();
    BorderLayout borderLayout4 = new BorderLayout();
    JLabel jLabel11 = new JLabel();
    JPanel jPanel16 = new JPanel();
    FlowLayout flowLayout21 = new FlowLayout();
    JScrollPane jScrollPaneResp = new JScrollPane();
    JTable jTableresp = new JTable();
    JComboBox jComboBoxPrioridade = new JComboBox();
    FlowLayout flowLayout22 = new FlowLayout();
    JTextArea jTextAreaDescricao = new JTextArea();
    JPanel jPanel34 = new JPanel();
    BorderLayout borderLayout7 = new BorderLayout();
    JPanel jPanel35 = new JPanel();
    BorderLayout borderLayout8 = new BorderLayout();
    JTable jTableResponsavel = new JTable();
    JPanel jPanel36 = new JPanel();
    JPanel jPanel12 = new JPanel();
    FlowLayout flowLayout23 = new FlowLayout();
    JPanel jPanel33 = new JPanel();
    FlowLayout flowLayout24 = new FlowLayout();
    JPanel jPanel37 = new JPanel();
    GridLayout gridLayout2 = new GridLayout();
    BorderLayout borderLayout5 = new BorderLayout();
    JPanel jPanel38 = new JPanel();
    JPanel jPanel39 = new JPanel();
    JPanel jPanel40 = new JPanel();
    FlowLayout flowLayout25 = new FlowLayout();
    JLabel jLabel15 = new JLabel();
    JScrollPane jScrollPaneDesc = new JScrollPane();
    JTextArea jTextAreaDesc = new JTextArea();
    JPanel jPanel41 = new JPanel();

}






