package br.ufsc.fcama.ig.tableModel;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.table.AbstractTableModel;

import br.ufsc.fcama.logica.objAux.Anexo;
import br.ufsc.fcama.logica.objAux.Requisito;

public class TableModelRequisitos extends AbstractTableModel {

	private ArrayList requisitos;
	private String prioridade;	
	private int colunas;
	private SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy" ); 
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
	
	public TableModelRequisitos(int colunas, int ciclo,ArrayList reqs, ArrayList userStories){
		this.colunas = colunas;
	    this.requisitos = new ArrayList();
	    Requisito requisito;
	    Iterator itReq = reqs.iterator();
	    while(itReq.hasNext()){
	        requisito = (Requisito)itReq.next();
	        if (requisito.getNuCincloDeDesenvolvimento() == ciclo){
	            this.requisitos.add(requisito);
	        }
	    }
	    Iterator itUS = userStories.iterator();
	    while (itUS.hasNext()){
	        requisito = (Requisito) itUS.next();
	        if (requisito.getNuCincloDeDesenvolvimento() == ciclo){
	        	this.requisitos.add(requisito);
	        }
	    }
	}
	
	public TableModelRequisitos(int colunas,ArrayList reqs, ArrayList remover){
		this.requisitos = reqs;
		this.colunas = colunas;
		Iterator it = requisitos.iterator();
		Requisito requisito;
		while(it.hasNext()){
			requisito = (Requisito) it.next();
			Iterator itr = remover.iterator();
			while (itr.hasNext()){
				if (requisito.getNome().equals(((Requisito)itr.next()).getNome())){
					it.remove();
				}
			}
		}
	}
	
	public TableModelRequisitos(ArrayList req, String prioridade, int colunas){
		super();
		this.colunas = colunas;
		this.requisitos = new ArrayList();
		this.prioridade = prioridade;
		//v na lista  os requisitos de mesma prioridade
		if (prioridade != null){
			Iterator it = req.iterator();
			while (it.hasNext()){
				Requisito requisito = (Requisito) it.next();
				if (prioridade.equalsIgnoreCase(requisito.getPrioridade())){
					this.requisitos.add(requisito);
				}
			}
		}else{
			this.requisitos = req;
		}
	}
	
	public int getRowCount() {
		return this.requisitos.size();
	}

	public int getColumnCount() {
		return this.colunas;
	}

	public Object getValueAt(int row, int column) {
		Requisito req = (Requisito) this.requisitos.get(row);
		switch(column){
			case 0:	return req.getNome();
			case 1:	return new Integer(req.getOrdem());
			case 2: return new Float(req.getTempoEstimado());
			case 3:	return req.getNuCincloDeDesenvolvimento() == 0 ? this.rb.getObject("tableModelRequisitos.naoAtribuido") : String.valueOf(req.getNuCincloDeDesenvolvimento());
			case 4:	return req.getDtInicio() == null ? this.rb.getString("tableModelRequisitos.naoIniciado") : this.format.format(req.getDtInicio());
			case 5:	return req.getDtFim() == null ? this.rb.getString("tableModelRequisitos.naoConcluido") : this.format.format(req.getDtFim());
			case 6:	return req.getDescricao();
		}
		
		return null;
	}
	
	public String getColumnName(int c){
        switch(c){
          case 0 : return this.rb.getString("tableModelRequisitos.nome");
          case 1 : return this.rb.getString("tableModelRequisitos.ordem");
          case 2 : return this.rb.getString("tableModelRequisitos.tempo");
          case 3 : return this.rb.getString("tableModelRequisitos.iteracao");
          case 4 : return this.rb.getString("tableModelRequisitos.inicio");
          case 5 : return this.rb.getString("tableModelRequisitos.fim");
        }
        return "";
    }

    public void addRequisito(Requisito req){
    	this.requisitos.add(req);
    }
    
    public Requisito removeRequisito(int row){
    	return (Requisito) this.requisitos.remove(row);
    }
    
    public Requisito getRequisito(int row){
    	return (Requisito) this.requisitos.get(row);
    }
    
    public ArrayList getRequisitos(){
    	return this.requisitos;
    }
    
    public void setRequisitos(ArrayList req){
		if (this.prioridade != null){
			this.requisitos = new ArrayList();
			//v na lista  os requisitos de mesma prioridade
			Iterator it = req.iterator();
			while (it.hasNext()){
				Requisito requisito = (Requisito) it.next();
				if (prioridade.equalsIgnoreCase(requisito.getPrioridade())){
					this.requisitos.add(requisito);
				}
			}
		}else{
			this.requisitos = req;
		}
	}
    
    public void clean(){
    	this.requisitos = new ArrayList();
    }

    
    

}
