package br.ufsc.fcama.ig.tableModel;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.table.AbstractTableModel;

import br.ufsc.fcama.logica.objAux.Stakeholder;

public class TableModelStakeholder extends AbstractTableModel {

	private ArrayList stakeholders;
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
	
	public TableModelStakeholder(ArrayList stakeholders, ArrayList remover){
		super();
		this.stakeholders = stakeholders;
		Iterator it =  remover.iterator();
		while(it.hasNext()){
			this.stakeholders.remove(it.next());
		}
	}
	
	public TableModelStakeholder(ArrayList stakeholders){
		super();
		this.stakeholders = stakeholders;
	}
	
	public int getRowCount() {
		return this.stakeholders.size();
	}

	public int getColumnCount() {
		return 2;
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		switch(columnIndex){
		case 0: return ((Stakeholder)this.stakeholders.get(rowIndex)).getNome();
		case 1: return ((Stakeholder)this.stakeholders.get(rowIndex)).getFuncao();
		}
		return null;
	}
	
	public String getColumnName(int c){
        switch(c){
          case 0 : return this.rb.getString("tableModelStakeholder.nome");
          case 1 : return this.rb.getString("tableModelStakeholder.funcao");
        }
        return null;
    }
	
	public void addStakeholder(Stakeholder stakeholder){
    	this.stakeholders.add(stakeholder);
    }
    
    public Stakeholder removeStakeholder(int row){
    	return (Stakeholder) this.stakeholders.remove(row);
    }
    
    public Stakeholder getStakeholder(int row){
    	return (Stakeholder) this.stakeholders.get(row);
    }
    
    public void clean(){
    	this.stakeholders = new ArrayList();
    }
    
    public void setStakeholders(ArrayList stakeholders){
    	this.stakeholders = stakeholders;
    }
    
    public ArrayList getStakeholders(){
    	return this.stakeholders;
    }

}
