package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.Border;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Projeto;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo01 extends JPanel implements Passo {
	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 0;
    private int proximo = 3;
    private FramePrincipal frame;
    private WizardProjeto wizard;

    public Passo01() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){

    }

    public Passo01(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        //caso o nome do projeto ou o caminho no tenha sido informado deixa desabilitado o jButtonProximo
        if(this.jTextCaminho.getText().trim().equals("")
           || this.jTextFieldNomeProjeto.getText().trim().equals("")){
            this.wizard.jButtonProximo.setEnabled(false);
        }else{
            this.wizard.jButtonProximo.setEnabled(true);
        }

        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }


    private void jbInit() throws Exception {
        this.setBackground(SystemColor.control);
        this.setBorder(null);
        this.setMinimumSize(new Dimension(500, 400));
        this.setPreferredSize(new Dimension(500, 400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("passo01.titulo"));

        jTextFieldNomeProjeto.setText("");
        jTextFieldNomeProjeto.addFocusListener(new
                Passo01_jTextFieldNomeProjeto_focusAdapter(this));
        jTextFieldNomeProjeto.addKeyListener(new
                Passo01_jTextFieldNomeProjeto_keyAdapter(this)); ;

        jLabelNome.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabelNome.setToolTipText("");
        jLabelNome.setText(this.rb.getString("passo01.localProjeto"));
        jLabelCaminho.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabelCaminho.setToolTipText("");
        jLabelCaminho.setText(this.rb.getString("passo01.nomeProjeto"));
        jButtonCaminho.setHorizontalTextPosition(SwingConstants.CENTER);
        jButtonCaminho.setText("...");
        jButtonCaminho.addActionListener(new
                                         Passo01_jButtonCaminho_actionAdapter(this));
        jButtonCaminho.addMouseListener(new Passo01_jButtonCaminho_mouseAdapter(this));
        jPanel1.setLayout(gridBagLayout1);
        jTextCaminho.setEditable(false);
        jCheckBoxModelo.setToolTipText("");
        jCheckBoxModelo.setText(this.rb.getString("passo01.modelo"));
        jCheckBoxModelo.addActionListener(new
                                          Passo01_jCheckBoxModelo_actionAdapter(this));
        jPanel1.setBorder(border2);
        jPanel1.setToolTipText("");
        jLabel3.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel3.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanelTitulo.add(jLabel1);
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanel1.add(jCheckBoxModelo,
                    new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(34, 73, 0, 91), 39, 0));
        jPanel1.add(jTextCaminho, new GridBagConstraints(0, 3, 1, 1, 1.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
                new Insets(9, 70, 0, 0), 319, 0));
        jPanel1.add(jButtonCaminho, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(7, 6, 0, 49), 0, 0));
        jPanel1.add(jLabelNome, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(35, 70, 0, 56), 51, 0));
        jPanel1.add(jTextFieldNomeProjeto,
                    new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.HORIZONTAL,
                                           new Insets(9, 70, 0, 0), 319, 0));
        jPanel1.add(jLabelCaminho, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(69, 70, 0, 136), 10, 0));
        jPanel1.add(jLabel2,
                    new GridBagConstraints(0, 0, GridBagConstraints.REMAINDER,
                                           GridBagConstraints.REMAINDER, 0.0,
                                           0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 0, 0, 0), 0, 0));
        jPanel1.add(jLabel3, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(77, 75, 11, 0), 111, 5));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }

    BorderLayout borderLayout1 = new BorderLayout();
     JPanel jPanelTitulo = new JPanel();
     JLabel jLabel1 = new JLabel();
     JPanel jPanel1 = new JPanel();
     JTextField jTextFieldNomeProjeto = new JTextField();
     JLabel jLabelNome = new JLabel();
     JLabel jLabelCaminho = new JLabel();
     JTextField jTextCaminho = new JTextField();
     JButton jButtonCaminho = new JButton();
     JCheckBox jCheckBoxModelo = new JCheckBox();
    JLabel jLabel2 = new JLabel();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    Border border2 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel3 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

    public void jCheckBoxModelo_actionPerformed(ActionEvent e) {
        if (this.jCheckBoxModelo.isSelected()){
            this.setProximo(2);
            ((Passo02)this.wizard.passos[2]).jTable1.clearSelection();
            this.wizard.passos[3].setAnterior(2);
            Projeto pj = new Projeto();
            pj.setNomeProjeto(this.wizard.getProjeto().getNomeProjeto());
            pj.setDiretorioPorjeto(this.wizard.getProjeto().getDiretorioPorjeto());
            this.wizard.setProjeto(pj);
        }else{
        	((Passo02)this.wizard.passos[2]).jTable1.clearSelection();
            this.setProximo(3);
            this.wizard.passos[3].setAnterior(1);
            Projeto pj = new Projeto();
            pj.setNomeProjeto(this.wizard.getProjeto().getNomeProjeto());
            pj.setDiretorioPorjeto(this.wizard.getProjeto().getDiretorioPorjeto());
            this.wizard.setProjeto(pj);
        }
    }

    public void jButtonCaminho_mouseClicked(MouseEvent e) {
        //abrir a janela para pesquisar o local do projeto
        JFileChooser jFileChooser = new JFileChooser();
        jFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        jFileChooser.setDialogTitle(this.rb.getString("passo01.informarDiretorio"));
        int result = jFileChooser.showOpenDialog(this.frame);
        if(result == JFileChooser.APPROVE_OPTION){
            try {
               this.jTextCaminho.setText(jFileChooser.getSelectedFile().getCanonicalPath());
               this.wizard.getProjeto().setDiretorioPorjeto(jFileChooser.getSelectedFile());
            } catch (IOException ex) {
            }
            this.desabilitaHabilitaBotoesWizard();

        }

    }

    public void jTextFieldNomeProjeto_keyTyped(KeyEvent e) {
        this.desabilitaHabilitaBotoesWizard();
    }

    public void jTextFieldNomeProjeto_focusLost(FocusEvent e) {
        if ( ! this.jTextFieldNomeProjeto.getText().trim().equals("")){
            this.wizard.getProjeto().setNomeProjeto(this.jTextFieldNomeProjeto.getText().trim());
        }
    }

    public void jButtonCaminho_actionPerformed(ActionEvent e) {

    }


}


class Passo01_jTextFieldNomeProjeto_keyAdapter extends KeyAdapter {
    private Passo01 adaptee;
    Passo01_jTextFieldNomeProjeto_keyAdapter(Passo01 adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.jTextFieldNomeProjeto_keyTyped(e);
    }
}


class Passo01_jTextFieldNomeProjeto_focusAdapter extends FocusAdapter {
    private Passo01 adaptee;
    Passo01_jTextFieldNomeProjeto_focusAdapter(Passo01 adaptee) {
        this.adaptee = adaptee;
    }

    public void focusLost(FocusEvent e) {
        adaptee.jTextFieldNomeProjeto_focusLost(e);
    }
}


class Passo01_jButtonCaminho_mouseAdapter extends MouseAdapter {
    private Passo01 adaptee;
    Passo01_jButtonCaminho_mouseAdapter(Passo01 adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jButtonCaminho_mouseClicked(e);
    }
}


class Passo01_jButtonCaminho_actionAdapter implements ActionListener {
    private Passo01 adaptee;
    Passo01_jButtonCaminho_actionAdapter(Passo01 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCaminho_actionPerformed(e);
    }
}


class Passo01_jCheckBoxModelo_actionAdapter implements ActionListener {
    private Passo01 adaptee;
    Passo01_jCheckBoxModelo_actionAdapter(Passo01 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxModelo_actionPerformed(e);
    }
}

