package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

import br.ufsc.fcama.ig.FramePrincipal;

public class Passo01M extends JPanel implements Passo {
    private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 0;
    private int proximo = 3;
    private FramePrincipal frame;
    private WizardProjeto wizard;

    public Passo01M() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){

    }

    public Passo01M(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        //caso o nome do projeto ou o caminho no tenha sido informado deixa desabilitado o jButtonProximo
        if( this.jTextFieldNomeProjeto.getText().trim().equals("")){
            this.wizard.jButtonProximo.setEnabled(false);
        }else{
            this.wizard.jButtonProximo.setEnabled(true);
        }

        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
                this.wizard.Concluir.setEnabled(true);
        }else{
                this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }


    private void jbInit() throws Exception {
        this.setBackground(SystemColor.control);
        this.setBorder(null);
        this.setMinimumSize(new Dimension(500, 400));
        this.setPreferredSize(new Dimension(500, 400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("passo01M.titulo"));

        jTextFieldNomeProjeto.setText("");
        jTextFieldNomeProjeto.addFocusListener(new
                Passo01M_jTextFieldNomeProjeto_focusAdapter(this));
        jTextFieldNomeProjeto.addKeyListener(new
                Passo01M_jTextFieldNomeProjeto_keyAdapter(this)); ;

        jLabelCaminho.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabelCaminho.setToolTipText("");
        jLabelCaminho.setText(this.rb.getString("passo01M.nomeModelo"));
        jPanel1.setLayout(gridBagLayout1);
        jPanel1.setBorder(border2);
        jPanel1.setToolTipText("");
        jLabel3.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel3.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanelTitulo.add(jLabel1);
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanel1.add(jTextFieldNomeProjeto,
                    new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.HORIZONTAL,
                                           new Insets(9, 70, 0, 100), 315, 0));
        jPanel1.add(jLabelCaminho, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(69, 70, 0, 302), 10, 0));
        jPanel1.add(jLabel2,
                    new GridBagConstraints(0, 0, GridBagConstraints.REMAINDER,
                                           GridBagConstraints.REMAINDER, 0.0,
                                           0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 0, 0, 0), 0, 0));
        jPanel1.add(jLabel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(215, 75, 17, 129), 74, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }

    BorderLayout borderLayout1 = new BorderLayout();
     JPanel jPanelTitulo = new JPanel();
     JLabel jLabel1 = new JLabel();
     JPanel jPanel1 = new JPanel();
     JTextField jTextFieldNomeProjeto = new JTextField();
    JLabel jLabelCaminho = new JLabel();
    JLabel jLabel2 = new JLabel();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    Border border2 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel3 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();


    public void jTextFieldNomeProjeto_keyTyped(KeyEvent e) {
        this.desabilitaHabilitaBotoesWizard();
    }

    public void jTextFieldNomeProjeto_focusLost(FocusEvent e) {
        if ( ! this.jTextFieldNomeProjeto.getText().trim().equals("")){
            this.wizard.getProjeto().setNomeProjeto(this.jTextFieldNomeProjeto.getText().trim());
        }
    }
}


class Passo01M_jTextFieldNomeProjeto_keyAdapter extends KeyAdapter {
    private Passo01M adaptee;
    Passo01M_jTextFieldNomeProjeto_keyAdapter(Passo01M adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.jTextFieldNomeProjeto_keyTyped(e);
    }
}


class Passo01M_jTextFieldNomeProjeto_focusAdapter extends FocusAdapter {
    private Passo01M adaptee;
    Passo01M_jTextFieldNomeProjeto_focusAdapter(Passo01M adaptee) {
        this.adaptee = adaptee;
    }

    public void focusLost(FocusEvent e) {
        adaptee.jTextFieldNomeProjeto_focusLost(e);
    }
}

