package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.border.Border;

import org.jdom.JDOMException;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.tableModel.TableModelArquivos;
import br.ufsc.fcama.logica.Projeto;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo02 extends JPanel implements Passo {

     	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
        private int anterior = 1;
        private int proximo = 3;
        private FramePrincipal frame;
        private WizardProjeto wizard;
        private TableModelArquivos tableModelArquivos;
        private String modelo;

        public Passo02() {
            try {
            	jbInit();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }

        public void setValores(){

        }

        public Passo02(FramePrincipal frame, WizardProjeto wizard) {
            try {
                this.frame = frame;
                this.wizard = wizard;
                this.tableModelArquivos = new TableModelArquivos(this.frame.persistencia.getModelosDeProjeto());
            	this.jTable1 = new JTable(this.tableModelArquivos);
            	jbInit();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }

        public void desabilitaHabilitaBotoesWizard() {
            this.wizard.jButtonAntorior.setEnabled(true);
            if(this.jTable1.getSelectedRow() != -1){
                this.wizard.jButtonProximo.setEnabled(true);
            }else{
                this.wizard.jButtonProximo.setEnabled(false);
            }

            if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
            	this.wizard.Concluir.setEnabled(true);
            }else{
            	this.wizard.Concluir.setEnabled(false);
            }
            this.wizard.jButtonCancelar.setEnabled(true);
        }

        public void setAnterior(int anterior) {
            this.anterior = anterior;
        }

        public int getAnterior() {
            return this.anterior;
        }

        public void setProximo(int proximo) {
            this.proximo = proximo;
        }

        public int getProximo() {
            return this.proximo;
        }

        public void jTable1_mouseClicked(MouseEvent e) {
        	if (this.jTable1.getSelectedRow() != -1 && this.modelo != this.tableModelArquivos.getModelo(this.jTable1.getSelectedRow())){
        		this.modelo = this.tableModelArquivos.getModelo(this.jTable1.getSelectedRow());
        		try {
					Projeto pj = this.frame.persistencia.getProjetoDoModelo(modelo);
					pj.setNomeProjeto(this.wizard.getProjeto().getNomeProjeto());
					pj.setDiretorioPorjeto(this.wizard.getProjeto().getDiretorioPorjeto());
					this.wizard.setProjeto(pj);
				} catch (ExceptionPraticaNaoLiberada e1) {
					JOptionPane.showConfirmDialog(this, this.rb.getString("passo02.erro.msn.modeloInconsistente"), this.rb.getString("passo02.erro.msn.tituloModelo") ,JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
				} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
					JOptionPane.showConfirmDialog(this,  this.rb.getString("passo02.erro.msn.modeloInconsistente"),this.rb.getString("passo02.erro.msn.tituloModelo") ,JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
				} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
					JOptionPane.showConfirmDialog(this,  this.rb.getString("passo02.erro.msn.modeloInconsistente"),this.rb.getString("passo02.erro.msn.tituloModelo") ,JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
				} catch (JDOMException e1) {
					JOptionPane.showConfirmDialog(this,  this.rb.getString("passo02.erro.msn.problemaLerArquivo"),this.rb.getString("passo02.erro.msn.tituloModelo") ,JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
				} catch (IOException e1) {
					JOptionPane.showConfirmDialog(this,  this.rb.getString("passo02.erro.msn.problemaLerArquivo"),this.rb.getString("passo02.erro.msn.tituloModelo") ,JOptionPane.CLOSED_OPTION, JOptionPane.ERROR_MESSAGE );
				}


        		this.desabilitaHabilitaBotoesWizard();
        	}
        }


        private void jbInit() throws Exception {
        	this.jTable1.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        	this.setBackground(SystemColor.control);
            this.setBorder(null);
            this.setMinimumSize(new Dimension(500, 400));
            this.setPreferredSize(new Dimension(500, 400));
            this.setLayout(borderLayout1);
            jPanelTitulo.setBackground(Color.white);
            jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
            jLabel1.setToolTipText("");
            jLabel1.setText(this.rb.getString("passo01.titulo"));
            jLabelCaminho.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
            jLabelCaminho.setToolTipText("");
            jLabelCaminho.setText(this.rb.getString("passo02.selecione"));
            jPanel1.setLayout(gridBagLayout1);
            jPanel1.setBorder(border2);
            jPanel1.setToolTipText("");
    jScrollPane1.setPreferredSize(new Dimension(426, 241));
    jTable1.addMouseListener(new Passo02_jTable1_mouseAdapter(this));
        jLabel3.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel3.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
            jPanelTitulo.add(jLabel1);
            this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
    jScrollPane1.getViewport().add(jTable1);
        jPanel1.add(jScrollPane1, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(20, 35, 0, 35), -24, -159));
        jPanel1.add(jLabelCaminho, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(23, 35, 0, 35), 141, 0));
        jPanel1.add(jLabel2,
                    new GridBagConstraints(0, 0, GridBagConstraints.REMAINDER,
                                           GridBagConstraints.REMAINDER, 0.0,
                                           0.0
                                           , GridBagConstraints.WEST,
                                           GridBagConstraints.NONE,
                                           new Insets(0, 0, 0, 0), 0, 0));
        jPanel1.add(jLabel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(30, 46, 16, 227), 0, 0));
    }



        BorderLayout borderLayout1 = new BorderLayout();
        JPanel jPanelTitulo = new JPanel();
        JLabel jLabel1 = new JLabel();
        JPanel jPanel1 = new JPanel();
        JLabel jLabelCaminho = new JLabel();
        JLabel jLabel2 = new JLabel();
        Border border1 = BorderFactory.createLineBorder(Color.white, 2);
        Border border2 = BorderFactory.createLineBorder(Color.white, 2);
        JScrollPane jScrollPane1 = new JScrollPane();
        JTable jTable1 = new JTable();
    JLabel jLabel3 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();


}


class Passo02_jTable1_mouseAdapter extends MouseAdapter {
    private Passo02 adaptee;
    Passo02_jTable1_mouseAdapter(Passo02 adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jTable1_mouseClicked(e);
    }
}

