package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.Border;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.pratica.PraticaDocumentacaoDetalhada;
import br.ufsc.fcama.logica.pratica.PraticaListaDeRequisitos;
import br.ufsc.fcama.logica.pratica.PraticaOrganizacaoDaDocumentacao;
import br.ufsc.fcama.logica.pratica.PraticaUserStories;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo03 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 1;
    private int proximo = 4;
    private FramePrincipal frame;
    private WizardProjeto wizard;

    public Passo03(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	if(pj.getAtividadeDefinicaoDosRequisitos().getPraticaUserStories().isSelecionada()){
    		jCheckBoxUserStories.setSelected(true);
    	}else{
    		jCheckBoxUserStories.setSelected(false);
    	}
    	if(pj.getAtividadeDefinicaoDosRequisitos().getPraticaListaDeRequisitos().isSelecionada()){
    		jCheckBoxListaDeRequisitos.setSelected(true);
    	}else{
    		jCheckBoxListaDeRequisitos.setSelected(false);
    	}
    	if(pj.getAtividadeDefinicaoDosRequisitos().getPraticaDocumentacaoDetalhada().isSelecionada()){
    		jCheckBoxDocumentacaoDetalhada.setSelected(true);
    	}else{
    		jCheckBoxDocumentacaoDetalhada.setSelected(false);
    	}
    	if(pj.getAtividadeDefinicaoDosRequisitos().getPraticaOrganizacaoDaDocumentacao().isSelecionada()){
    		jCheckBoxOrganizacaoDocumentacao.setSelected(true);
    	}else{
    		jCheckBoxOrganizacaoDocumentacao.setSelected(false);
    	}
    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        if (this.wizard.getProjeto().getAtividadeDefinicaoDosRequisitos().isRequisitosCompletos()){
        	this.wizard.jButtonProximo.setEnabled(true);
        }else{
        	this.wizard.jButtonProximo.setEnabled(false);
        }
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }

    public void jCheckBoxUserStories_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaUserStories.class,
					this.jCheckBoxUserStories.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxUserStories.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxUserStories.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
			this.jCheckBoxUserStories.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();

    }

    public void jCheckBoxListaDeRequisitos_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaListaDeRequisitos.class,
					this.jCheckBoxListaDeRequisitos.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxListaDeRequisitos.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxListaDeRequisitos.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica"),JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxListaDeRequisitos.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDocumentacaoDetalhada_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDocumentacaoDetalhada.class,
					this.jCheckBoxDocumentacaoDetalhada.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoLiberada"), this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDocumentacaoDetalhada.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDocumentacaoDetalhada.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDocumentacaoDetalhada.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxOrganizacaoDocumentacao_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaOrganizacaoDaDocumentacao.class,
					this.jCheckBoxOrganizacaoDocumentacao.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxOrganizacaoDocumentacao.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxOrganizacaoDocumentacao.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxOrganizacaoDocumentacao.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }


    private void jbInit() throws Exception {
        this.setPreferredSize(new Dimension(500, 400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jPanelTitulo.setLayout(flowLayout1);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setToolTipText("");
        jLabelTitulo.setText(this.rb.getString("passo03.titulo"));
        jPanel1.setLayout(gridBagLayout1);
        jCheckBoxUserStories.setMaximumSize(new Dimension(149, 23));
        jCheckBoxUserStories.setMinimumSize(new Dimension(149, 23));
        jCheckBoxUserStories.setPreferredSize(new Dimension(149, 23));
        jCheckBoxUserStories.setToolTipText("");
        jCheckBoxUserStories.setText(this.rb.getString("passo03.userStories"));
        jCheckBoxUserStories.addActionListener(new
                Passo03_jCheckBoxUserStories_actionAdapter(this));
        jCheckBoxListaDeRequisitos.setMaximumSize(new Dimension(149, 23));
        jCheckBoxListaDeRequisitos.setMinimumSize(new Dimension(149, 23));
        jCheckBoxListaDeRequisitos.setPreferredSize(new Dimension(149, 23));
        jCheckBoxListaDeRequisitos.setToolTipText("");
        jCheckBoxListaDeRequisitos.setText(this.rb.getString("passo03.listaRequisitos"));
        jCheckBoxListaDeRequisitos.addActionListener(new
                Passo03_jCheckBoxListaDeRequisitos_actionAdapter(this));
        jCheckBoxDocumentacaoDetalhada.setToolTipText("");
        jCheckBoxDocumentacaoDetalhada.setText(this.rb.getString("passo03.documentacaoDetalhada"));
        jCheckBoxDocumentacaoDetalhada.addActionListener(new
                Passo03_jCheckBoxDocumentacaoDetalhada_actionAdapter(this));
        jCheckBoxOrganizacaoDocumentacao.setMaximumSize(new Dimension(149, 23));
        jCheckBoxOrganizacaoDocumentacao.setMinimumSize(new Dimension(149, 23));
        jCheckBoxOrganizacaoDocumentacao.setPreferredSize(new Dimension(149, 23));
        jCheckBoxOrganizacaoDocumentacao.setToolTipText("");
        jCheckBoxOrganizacaoDocumentacao.setText(this.rb.getString("passo03.organizacaoDocumentacao"));
        jCheckBoxOrganizacaoDocumentacao.addActionListener(new
                Passo03_jCheckBoxOrganizacaoDocumentacao_actionAdapter(this));
        jLabelSelecao.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabelSelecao.setToolTipText("");
        jLabelSelecao.setText(this.rb.getString("passo03.texto"));
        jPanel1.setBorder(border2);
        jLabel1.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel1.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo);
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(jCheckBoxOrganizacaoDocumentacao,
                    new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(12, 90, 0, 222), 34, 0));
        jPanel1.add(jCheckBoxDocumentacaoDetalhada,
                    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 252), 4, 0));
        jPanel1.add(jCheckBoxListaDeRequisitos,
                    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 281), -25, 0));
        jPanel1.add(jCheckBoxUserStories,
                    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(21, 90, 0, 319), -63, 0));
        jPanel1.add(jLabelSelecao, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(40, 10, 0, 11), 2, 0));
        jPanel1.add(jLabel1, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(129, 91, 10, 186), 0, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelTitulo = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JLabel jLabelTitulo = new JLabel();
    JPanel jPanel1 = new JPanel();
    JCheckBox jCheckBoxUserStories = new JCheckBox();
    JCheckBox jCheckBoxListaDeRequisitos = new JCheckBox();
    JCheckBox jCheckBoxDocumentacaoDetalhada = new JCheckBox();
    JCheckBox jCheckBoxOrganizacaoDocumentacao = new JCheckBox();
    JLabel jLabelSelecao = new JLabel();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    Border border2 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel1 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

}

class Passo03_jCheckBoxOrganizacaoDocumentacao_actionAdapter implements
        ActionListener {
    private Passo03 adaptee;
    Passo03_jCheckBoxOrganizacaoDocumentacao_actionAdapter(Passo03 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxOrganizacaoDocumentacao_actionPerformed(e);
    }
}

class Passo03_jCheckBoxDocumentacaoDetalhada_actionAdapter implements
        ActionListener {
    private Passo03 adaptee;
    Passo03_jCheckBoxDocumentacaoDetalhada_actionAdapter(Passo03 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDocumentacaoDetalhada_actionPerformed(e);
    }
}

class Passo03_jCheckBoxListaDeRequisitos_actionAdapter implements
        ActionListener {
    private Passo03 adaptee;
    Passo03_jCheckBoxListaDeRequisitos_actionAdapter(Passo03 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxListaDeRequisitos_actionPerformed(e);
    }
}

class Passo03_jCheckBoxUserStories_actionAdapter implements ActionListener {
    private Passo03 adaptee;
    Passo03_jCheckBoxUserStories_actionAdapter(Passo03 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxUserStories_actionPerformed(e);
    }
}
