package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.Border;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.pratica.PraticaAtualizacaoDaDocumentacao;
import br.ufsc.fcama.logica.pratica.PraticaDistribuicaoDosRequisitos;
import br.ufsc.fcama.logica.pratica.PraticaDuracaoDasIteracoes;
import br.ufsc.fcama.logica.pratica.PraticaPlanejamentoDasIteracoes;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo04 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 3;
    private int proximo = 5;
    private FramePrincipal frame;
    private WizardProjeto wizard;
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelTitulo = new JPanel();
    JLabel jLabelTitulo = new JLabel();
    JPanel jPanel1 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JLabel jLabel1 = new JLabel();
    JCheckBox jCheckBoxPlanejamentoDasIteracoes = new JCheckBox();
    JCheckBox jCheckBoxDuracaoDasIteracoes = new JCheckBox();
    JCheckBox jCheckBoxDistribuicaoDosRequisitos = new JCheckBox();
    JCheckBox jCheckBoxAtualizacaoDaDocumentacao = new JCheckBox();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel2 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

    public Passo04(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	if(pj.getAtividadeAtribuicaoDosRequisitos().getPraticaPlanejamentoDasIteracoes().isSelecionada()){
    		jCheckBoxPlanejamentoDasIteracoes.setSelected(true);
    	}else{
    		jCheckBoxPlanejamentoDasIteracoes.setSelected(false);
    	}
    	if(pj.getAtividadeAtribuicaoDosRequisitos().getPraticaDuracaoDasIteracoes().isSelecionada()){
    		jCheckBoxDuracaoDasIteracoes.setSelected(true);
    	}else{
    		jCheckBoxDuracaoDasIteracoes.setSelected(false);
    	}
    	if(pj.getAtividadeAtribuicaoDosRequisitos().getPraticaDistribuicaoDosRequisitos().isSelecionada()){
    		jCheckBoxDistribuicaoDosRequisitos.setSelected(true);
    	}else{
    		jCheckBoxDistribuicaoDosRequisitos.setSelected(false);
    	}
    	if(pj.getAtividadeAtribuicaoDosRequisitos().getPraticaAtualizacaoDaDocumentacao().isSelecionada()){
    		jCheckBoxAtualizacaoDaDocumentacao.setSelected(true);
    	}else{
    		jCheckBoxAtualizacaoDaDocumentacao.setSelected(false);
    	}

    	/*JCheckBox  = new JCheckBox();
    JCheckBox  = new JCheckBox();
    JCheckBox  = new JCheckBox();
    JCheckBox  = new JCheckBox();*/
    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        if(this.wizard.getProjeto().getAtividadeAtribuicaoDosRequisitos().isRequisitosCompletos()){
        	this.wizard.jButtonProximo.setEnabled(true);
        }else{
        	this.wizard.jButtonProximo.setEnabled(false);
        }
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }

    public void jCheckBoxPlanejamentoDasIteracoes_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaPlanejamentoDasIteracoes.class,
					this.jCheckBoxPlanejamentoDasIteracoes.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxPlanejamentoDasIteracoes.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxPlanejamentoDasIteracoes.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxPlanejamentoDasIteracoes.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDuracaoDasIteracoes_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDuracaoDasIteracoes.class,
					this.jCheckBoxDuracaoDasIteracoes.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDuracaoDasIteracoes.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDuracaoDasIteracoes.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDuracaoDasIteracoes.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDistribuicaoDosRequisitos_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDistribuicaoDosRequisitos.class,
					this.jCheckBoxDistribuicaoDosRequisitos.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDistribuicaoDosRequisitos.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDistribuicaoDosRequisitos.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDistribuicaoDosRequisitos.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxAtualizacaoDaDocumentacao_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaAtualizacaoDaDocumentacao.class,
					this.jCheckBoxAtualizacaoDaDocumentacao.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxAtualizacaoDaDocumentacao.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxAtualizacaoDaDocumentacao.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxAtualizacaoDaDocumentacao.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }


    private void jbInit() throws Exception {
        this.setBackground(UIManager.getColor(
                "InternalFrame.inactiveTitleGradient"));
        this.setMinimumSize(new Dimension(500, 400));
        this.setPreferredSize(new Dimension(500, 400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jPanelTitulo.setToolTipText("");
        jPanelTitulo.setLayout(flowLayout1);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setToolTipText("");
        jLabelTitulo.setText(this.rb.getString("passo04.titulo"));
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setText(this.rb.getString("passo04.texto"));
        jPanel1.setLayout(gridBagLayout1);
        jCheckBoxPlanejamentoDasIteracoes.setText(this.rb.getString("passo04.planejametaDasIteracoes"));
        jCheckBoxPlanejamentoDasIteracoes.addActionListener(new
                Passo04_jCheckBoxPlanejamentoDasIteracoes_actionAdapter(this));
        jCheckBoxDuracaoDasIteracoes.setToolTipText("");
        jCheckBoxDuracaoDasIteracoes.setText(this.rb.getString("passo04.duracaoDasIteracoes"));
        jCheckBoxDuracaoDasIteracoes.addActionListener(new
                Passo04_jCheckBoxDuracaoDasIteracoes_actionAdapter(this));
        jCheckBoxDistribuicaoDosRequisitos.setText(this.rb.getString("passo04.distribuicaoDosRequisitos"));
        jCheckBoxDistribuicaoDosRequisitos.addActionListener(new
                Passo04_jCheckBoxDistribuicaoDosRequisitos_actionAdapter(this));
        jCheckBoxAtualizacaoDaDocumentacao.setToolTipText("");
        jCheckBoxAtualizacaoDaDocumentacao.setText(this.rb.getString("passo04.atualizacaoDaDocumentacao"));
        jCheckBoxAtualizacaoDaDocumentacao.addActionListener(new
                Passo04_jCheckBoxAtualizacaoDaDocumentacao_actionAdapter(this));
        jPanel1.setBorder(border1);
        jLabel2.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel2.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo);
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(40, 9, 0, 4), 6, 0));
        jPanel1.add(jCheckBoxPlanejamentoDasIteracoes,
                    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(26, 90, 0, 245), 0, 0));
        jPanel1.add(jCheckBoxDuracaoDasIteracoes,
                    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 267), 0, 0));
        jPanel1.add(jCheckBoxDistribuicaoDosRequisitos,
                    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 251), 0, 0));
        jPanel1.add(jCheckBoxAtualizacaoDaDocumentacao,
                    new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 229), 0, 0));
        jPanel1.add(jLabel2, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(117, 89, 16, 189), 0, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }




}


class Passo04_jCheckBoxAtualizacaoDaDocumentacao_actionAdapter implements
        ActionListener {
    private Passo04 adaptee;
    Passo04_jCheckBoxAtualizacaoDaDocumentacao_actionAdapter(Passo04 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxAtualizacaoDaDocumentacao_actionPerformed(e);
    }
}


class Passo04_jCheckBoxDistribuicaoDosRequisitos_actionAdapter implements
        ActionListener {
    private Passo04 adaptee;
    Passo04_jCheckBoxDistribuicaoDosRequisitos_actionAdapter(Passo04 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDistribuicaoDosRequisitos_actionPerformed(e);
    }
}


class Passo04_jCheckBoxDuracaoDasIteracoes_actionAdapter implements
        ActionListener {
    private Passo04 adaptee;
    Passo04_jCheckBoxDuracaoDasIteracoes_actionAdapter(Passo04 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDuracaoDasIteracoes_actionPerformed(e);
    }
}


class Passo04_jCheckBoxPlanejamentoDasIteracoes_actionAdapter implements
        ActionListener {
    private Passo04 adaptee;
    Passo04_jCheckBoxPlanejamentoDasIteracoes_actionAdapter(Passo04 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxPlanejamentoDasIteracoes_actionPerformed(e);
    }
}
