package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.Border;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.pratica.PraticaDocumentacaoDoProjeto;
import br.ufsc.fcama.logica.pratica.PraticaProjetoDetalhado;
import br.ufsc.fcama.logica.pratica.PraticaProjetoGeral;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo05 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 4;
    private int proximo = 6;
    private FramePrincipal frame;
    private WizardProjeto wizard;
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelTitulo = new JPanel();
    JLabel jLabelTitulo = new JLabel();
    JPanel jPanel1 = new JPanel();
    JLabel jLabel1 = new JLabel();
    JCheckBox jCheckBoxProjetoGeral = new JCheckBox();
    JCheckBox jCheckBoxProjetoDetalhado = new JCheckBox();
    JCheckBox jCheckBoxDocumentacaoDoProjeto = new JCheckBox();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel2 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    public Passo05(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	if(pj.getAtividadeProjetoDoSistema().getPraticaProjetoGeral().isSelecionada()){
    		jCheckBoxProjetoGeral.setSelected(true);
    	}else{
    		jCheckBoxProjetoGeral.setSelected(false);
    	}
    	if(pj.getAtividadeProjetoDoSistema().getPraticaProjetoDetalhado().isSelecionada()){
    		jCheckBoxProjetoDetalhado.setSelected(true);
    	}else{
    		jCheckBoxProjetoDetalhado.setSelected(false);
    	}
    	if(pj.getAtividadeProjetoDoSistema().getPraticaDocumentacaoDoProjeto().isSelecionada()){
    		jCheckBoxDocumentacaoDoProjeto.setSelected(true);
    	}else{
    		jCheckBoxDocumentacaoDoProjeto.setSelected(false);
    	}
    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        if (this.wizard.getProjeto().getAtividadeProjetoDoSistema().isRequisitosCompletos()){
        	this.wizard.jButtonProximo.setEnabled(true);
        }else{
        	this.wizard.jButtonProximo.setEnabled(false);
        }
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }

    public void jCheckBoxProjetoGeral_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaProjetoGeral.class,
					this.jCheckBoxProjetoGeral.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxProjetoGeral.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxProjetoGeral.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this,this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxProjetoGeral.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxProjetoDetalhado_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaProjetoDetalhado.class,
					this.jCheckBoxProjetoDetalhado.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxProjetoDetalhado.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxProjetoDetalhado.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxProjetoDetalhado.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDocumentacaoDoProjeto_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDocumentacaoDoProjeto.class,
					this.jCheckBoxDocumentacaoDoProjeto.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDocumentacaoDoProjeto.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDocumentacaoDoProjeto.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica"),JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDocumentacaoDoProjeto.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }


    private void jbInit() throws Exception {
        this.setBackground(UIManager.getColor(
                "InternalFrame.inactiveTitleGradient"));
        this.setMinimumSize(new Dimension(500, 400));
        this.setPreferredSize(new Dimension(500, 400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setToolTipText("");
        jLabelTitulo.setText(this.rb.getString("passo05.titulo"));
        jPanel1.setLayout(gridBagLayout1);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("passo05.texto"));
        jCheckBoxProjetoGeral.setText(this.rb.getString("passo05.projetoGeral"));
        jCheckBoxProjetoGeral.addActionListener(new
                Passo05_jCheckBoxProjetoGeral_actionAdapter(this));
        jCheckBoxProjetoDetalhado.setText(this.rb.getString("passo05.projetoDetalhado"));
        jCheckBoxProjetoDetalhado.addActionListener(new
                Passo05_jCheckBoxProjetoDetalhado_actionAdapter(this));
        jCheckBoxDocumentacaoDoProjeto.setText(this.rb.getString("passo05.documentacaoDoProjeto"));
        jCheckBoxDocumentacaoDoProjeto.addActionListener(new
                Passo05_jCheckBoxDocumentacaoDoProjeto_actionAdapter(this));
        jPanel1.setBorder(border1);
        jLabel2.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel2.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));

        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo);
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(jCheckBoxDocumentacaoDoProjeto,
                    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 257), 0, 0));
        jPanel1.add(jCheckBoxProjetoDetalhado,
                    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 297), 0, 0));
        jPanel1.add(jCheckBoxProjetoGeral,
                    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(27, 90, 0, 315), 0, 0));
        jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(40, 22, 0, 39), 0, 0));
        jPanel1.add(jLabel2, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(158, 91, 10, 187), 0, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }


}


class Passo05_jCheckBoxDocumentacaoDoProjeto_actionAdapter implements
        ActionListener {
    private Passo05 adaptee;
    Passo05_jCheckBoxDocumentacaoDoProjeto_actionAdapter(Passo05 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDocumentacaoDoProjeto_actionPerformed(e);
    }
}


class Passo05_jCheckBoxProjetoDetalhado_actionAdapter implements ActionListener {
    private Passo05 adaptee;
    Passo05_jCheckBoxProjetoDetalhado_actionAdapter(Passo05 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxProjetoDetalhado_actionPerformed(e);
    }
}


class Passo05_jCheckBoxProjetoGeral_actionAdapter implements ActionListener {
    private Passo05 adaptee;
    Passo05_jCheckBoxProjetoGeral_actionAdapter(Passo05 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxProjetoGeral_actionPerformed(e);
    }
}
