package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.SpinnerNumberModel;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Projeto;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo06 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 5;
    private int proximo = 7;
    private FramePrincipal frame;
    private WizardProjeto wizard;
    JPanel jPanelTitulo = new JPanel();
    JLabel jLabelTitulo = new JLabel();
    JPanel jPanel1 = new JPanel();
    SpinnerNumberModel spinnerNumberModel = new SpinnerNumberModel(1, 1, 50, 1);
    JSpinner jSpinner1 = new JSpinner(spinnerNumberModel);
    BorderLayout borderLayout1 = new BorderLayout();
    FlowLayout flowLayout1 = new FlowLayout();
    JLabel jLabel1 = new JLabel();
    JTextArea jTextAreaOBS = new JTextArea();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    public Passo06(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	this.spinnerNumberModel.setValue(new Integer(pj.getIteracoes().size()));
    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        this.wizard.jButtonProximo.setEnabled(true);
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }

    public void jSpinner1_stateChanged(ChangeEvent e) {
    	//Caso o numero do spinner seja maior que o de ciclo do projeto
    	//ento adiciona seno e menor remove
    	if(this.spinnerNumberModel.getNumber().intValue() != this.wizard.getProjeto().getIteracoes().size()){
	    	if (this.spinnerNumberModel.getNumber().intValue()
	    			> this.wizard.getProjeto().getIteracoes().size()){
	    		this.wizard.getProjeto().addIteracao();
	    	}else {
	    		this.wizard.getProjeto().removeUltimaIteracao();
	    	}
    	}
    }


    private void jbInit() throws Exception {
        this.setBackground(UIManager.getColor(
                "InternalFrame.inactiveTitleGradient"));
        this.setMinimumSize(new Dimension(500, 400));
        this.setPreferredSize(new Dimension(500, 400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jPanelTitulo.setLayout(flowLayout1);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setToolTipText("");
        jLabelTitulo.setText(this.rb.getString("passo06.titulo"));
        jPanel1.setLayout(gridBagLayout1);
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("passo06.texto1"));
        jTextAreaOBS.setBackground(SystemColor.control);
        jTextAreaOBS.setFont(new java.awt.Font("Arial", Font.PLAIN, 11));
        jTextAreaOBS.setRequestFocusEnabled(false);
        jTextAreaOBS.setToolTipText("");
        jTextAreaOBS.setEditable(false);
        jTextAreaOBS.setText(this.rb.getString("passo06.texto2"));
        jTextAreaOBS.setLineWrap(true);
        jPanel1.setBorder(border1);
        jSpinner1.addChangeListener(new Passo06_jSpinner1_changeAdapter(this));
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo, null);
        this.add(jPanel1, java.awt.BorderLayout.CENTER);

        jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(40, 6, 0, 1), 0, 0));
        jPanel1.add(jSpinner1, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(65, 224, 0, 224), -3, 0));
        jPanel1.add(jTextAreaOBS, new GridBagConstraints(0, 2, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(95, 28, 86, 27), 0, 13));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }





}


class Passo06_jSpinner1_changeAdapter implements ChangeListener {
    private Passo06 adaptee;
    Passo06_jSpinner1_changeAdapter(Passo06 adaptee) {
        this.adaptee = adaptee;
    }

    public void stateChanged(ChangeEvent e) {

        adaptee.jSpinner1_stateChanged(e);
    }
}
