package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.border.Border;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Iteracao;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.pratica.PraticaControleDeVersoes;
import br.ufsc.fcama.logica.pratica.PraticaDesenvolvimentoColetivo;
import br.ufsc.fcama.logica.pratica.PraticaDesenvolvimentoEmDuplas;
import br.ufsc.fcama.logica.pratica.PraticaDesenvolvimentoLadoALado;
import br.ufsc.fcama.logica.pratica.PraticaDesenvolvimentoSimultaneo;
import br.ufsc.fcama.logica.pratica.PraticaDocumentacaoDoDesenvolvimento;
import br.ufsc.fcama.logica.pratica.PraticaEscritaDosTestesAntesDaImplementacao;
import br.ufsc.fcama.logica.pratica.PraticaImplementacao;
import br.ufsc.fcama.logica.pratica.PraticaIntegracaoParalela;
import br.ufsc.fcama.logica.pratica.PraticaRefactoring;
import br.ufsc.fcama.logica.pratica.PraticaReunioesDiarias;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo07 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 6;
    private int proximo = 8;
    private FramePrincipal frame;
    private WizardProjeto wizard;
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelTitulo = new JPanel();
    JPanel jPanel1 = new JPanel();
    JLabel jLabelTitulo = new JLabel();
    JTextArea jTextArea1 = new JTextArea();
    JCheckBox jCheckBoxImplementacao = new JCheckBox();
    JCheckBox jCheckBoxEscritaDeTestesAntes = new JCheckBox();
    JCheckBox jCheckBoxDesenvolvimentoColetivo = new JCheckBox();
    JCheckBox jCheckBoxDesenvolvimentoEmDuplas = new JCheckBox();
    JCheckBox jCheckBoxDesenvolvimentoLadoALado = new JCheckBox();
    JCheckBox jCheckBoxrefactoring = new JCheckBox();
    JCheckBox jCheckBoxReunioesDiarias = new JCheckBox();
    JCheckBox jCheckBoxDesenvolvimetnoSimultaneo = new JCheckBox();
    JCheckBox jCheckBoxIntegracaoParalela = new JCheckBox();
    JCheckBox jCheckBox1DocumentDesenvolvimento = new JCheckBox();
    JCheckBox jCheckBoxControleDeVerses = new JCheckBox();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel1 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    public Passo07(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	Iteracao it = ((Iteracao)pj.getIteracoes().get(0));
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaImplementacao().isSelecionada()){
    		jCheckBoxImplementacao.setSelected(true);
    	}else{
    		jCheckBoxImplementacao.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaEscritaDosTestesAntesDaImplementacao().isSelecionada()){
    		jCheckBoxEscritaDeTestesAntes.setSelected(true);
    	}else{
    		jCheckBoxEscritaDeTestesAntes.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoColetivo().isSelecionada()){
    		jCheckBoxDesenvolvimentoColetivo.setSelected(true);
    	}else{
    		jCheckBoxDesenvolvimentoColetivo.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoEmDuplas().isSelecionada()){
    		jCheckBoxDesenvolvimentoEmDuplas.setSelected(true);
    	}else{
    		jCheckBoxDesenvolvimentoEmDuplas.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoLadoALado().isSelecionada()){
    		jCheckBoxDesenvolvimentoLadoALado.setSelected(true);
    	}else{
    		jCheckBoxDesenvolvimentoLadoALado.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaRefactoring().isSelecionada()){
    		jCheckBoxrefactoring.setSelected(true);
    	}else{
    		jCheckBoxrefactoring.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaReunioesDiarias().isSelecionada()){
    		jCheckBoxReunioesDiarias.setSelected(true);
    	}else{
    		jCheckBoxReunioesDiarias.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDesenvolvimentoSimultaneo().isSelecionada()){
    		jCheckBoxDesenvolvimetnoSimultaneo.setSelected(true);
    	}else{
    		jCheckBoxDesenvolvimetnoSimultaneo.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaIntegracaoParalela().isSelecionada()){
    		jCheckBoxIntegracaoParalela.setSelected(true);
    	}else{
    		jCheckBoxIntegracaoParalela.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaDocumentacaoDoDesenvolvimento().isSelecionada()){
    		jCheckBox1DocumentDesenvolvimento.setSelected(true);
    	}else{
    		jCheckBox1DocumentDesenvolvimento.setSelected(false);
    	}
    	if(it.getAtividadeDesenvolverIncrementoDoSistema().getPraticaControleDeVersoes().isSelecionada()){
    		jCheckBoxControleDeVerses.setSelected(true);
    	}else{
    		jCheckBoxControleDeVerses.setSelected(false);
    	}

    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        if (((Iteracao)this.wizard.getProjeto().getIteracoes()
        		.iterator().next()).getAtividadeDesenvolverIncrementoDoSistema().isRequisitosCompletos()){
        	this.wizard.jButtonProximo.setEnabled(true);
        }else{
        	this.wizard.jButtonProximo.setEnabled(false);
        }
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }

    public void jCheckBoxImplementacao_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaImplementacao.class,
					this.jCheckBoxImplementacao.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxImplementacao.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxImplementacao.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxImplementacao.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxEscritaDeTestesAntes_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaEscritaDosTestesAntesDaImplementacao.class,
					this.jCheckBoxEscritaDeTestesAntes.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxEscritaDeTestesAntes.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxEscritaDeTestesAntes.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxEscritaDeTestesAntes.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDesenvolvimentoColetivo_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDesenvolvimentoColetivo.class,
					this.jCheckBoxDesenvolvimentoColetivo.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoColetivo.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoColetivo.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoColetivo.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDesenvolvimentoEmDuplas_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDesenvolvimentoEmDuplas.class,
					this.jCheckBoxDesenvolvimentoEmDuplas.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoEmDuplas.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoEmDuplas.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoEmDuplas.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDesenvolvimentoLadoALado_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDesenvolvimentoLadoALado.class,
					this.jCheckBoxDesenvolvimentoLadoALado.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoLadoALado.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica"),JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoLadoALado.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimentoLadoALado.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxrefactoring_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaRefactoring.class,
					this.jCheckBoxrefactoring.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxrefactoring.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxrefactoring.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica"),JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxrefactoring.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxReunioesDiarias_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaReunioesDiarias.class,
					this.jCheckBoxReunioesDiarias.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxReunioesDiarias.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxReunioesDiarias.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxReunioesDiarias.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxDesenvolvimetnoSimultaneo_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDesenvolvimentoSimultaneo.class,
					this.jCheckBoxDesenvolvimetnoSimultaneo.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimetnoSimultaneo.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimetnoSimultaneo.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxDesenvolvimetnoSimultaneo.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxIntegracaoParalela_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaIntegracaoParalela.class,
					this.jCheckBoxIntegracaoParalela.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica"),JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoParalela.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoParalela.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoParalela.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBox1DocumentDesenvolvimento_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaDocumentacaoDoDesenvolvimento.class,
					this.jCheckBox1DocumentDesenvolvimento.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBox1DocumentDesenvolvimento.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBox1DocumentDesenvolvimento.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBox1DocumentDesenvolvimento.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxControleDeVerses_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaControleDeVersoes.class,
					this.jCheckBoxControleDeVerses.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxControleDeVerses.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxControleDeVerses.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxControleDeVerses.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }



    private void jbInit() throws Exception {
        this.setBackground(UIManager.getColor("control"));
        this.setPreferredSize(new Dimension(500,400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setToolTipText("");
        jLabelTitulo.setText(this.rb.getString("passo07.titulo"));
        jPanel1.setLayout(gridBagLayout1);
        jTextArea1.setBackground(UIManager.getColor("control"));
        jTextArea1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jTextArea1.setRequestFocusEnabled(false);
        jTextArea1.setToolTipText("");
        jTextArea1.setEditable(false);
        jTextArea1.setText(this.rb.getString("passo07.texto"));
        jTextArea1.setLineWrap(true);
        jCheckBoxImplementacao.setToolTipText("");
        jCheckBoxImplementacao.setText(this.rb.getString("passo07.implementacao"));
        jCheckBoxImplementacao.addActionListener(new
                Passo07_jCheckBoxImplementacao_actionAdapter(this));
        jCheckBoxEscritaDeTestesAntes.setToolTipText("");
        jCheckBoxEscritaDeTestesAntes.setText(this.rb.getString("passo07.EscritaTestesAnIm"));
        jCheckBoxEscritaDeTestesAntes.addActionListener(new
                Passo07_jCheckBoxEscritaDeTestesAntes_actionAdapter(this));
        jCheckBoxDesenvolvimentoColetivo.setToolTipText("");
        jCheckBoxDesenvolvimentoColetivo.setText(this.rb.getString("passo07.desenvolvimentoColetivo"));
        jCheckBoxDesenvolvimentoColetivo.addActionListener(new
                Passo07_jCheckBoxDesenvolvimentoColetivo_actionAdapter(this));
        jCheckBoxDesenvolvimentoEmDuplas.setToolTipText("");
        jCheckBoxDesenvolvimentoEmDuplas.setText(this.rb.getString("passo07.desenvolvimentoEmDuplas"));
        jCheckBoxDesenvolvimentoEmDuplas.addActionListener(new
                Passo07_jCheckBoxDesenvolvimentoEmDuplas_actionAdapter(this));
        jCheckBoxDesenvolvimentoLadoALado.setToolTipText("");
        jCheckBoxDesenvolvimentoLadoALado.setText(this.rb.getString("passo07.desenvovolvimentoLadoALado"));
        jCheckBoxDesenvolvimentoLadoALado.addActionListener(new
                Passo07_jCheckBoxDesenvolvimentoLadoALado_actionAdapter(this));
        jCheckBoxrefactoring.setToolTipText("");
        jCheckBoxrefactoring.setText(this.rb.getString("passo07.refactoring"));
        jCheckBoxrefactoring.addActionListener(new
                Passo07_jCheckBoxrefactoring_actionAdapter(this));
        jCheckBoxReunioesDiarias.setText(this.rb.getString("passo07.reunioesDiarias"));
        jCheckBoxReunioesDiarias.addActionListener(new
                Passo07_jCheckBoxReunioesDiarias_actionAdapter(this));
        jCheckBoxDesenvolvimetnoSimultaneo.setToolTipText("");
        jCheckBoxDesenvolvimetnoSimultaneo.setText(this.rb.getString("passo07.desenvolvimentoSimultaneo"));
        jCheckBoxDesenvolvimetnoSimultaneo.addActionListener(new
                Passo07_jCheckBoxDesenvolvimetnoSimultaneo_actionAdapter(this));
        jCheckBoxIntegracaoParalela.setToolTipText("");
        jCheckBoxIntegracaoParalela.setText(this.rb.getString("passo07.integracaoParalela"));
        jCheckBoxIntegracaoParalela.addActionListener(new
                Passo07_jCheckBoxIntegracaoParalela_actionAdapter(this));
        jCheckBox1DocumentDesenvolvimento.setToolTipText("");
        jCheckBox1DocumentDesenvolvimento.setText(this.rb.getString("passo07.docDesenvolvimento"));
        jCheckBox1DocumentDesenvolvimento.addActionListener(new
                Passo07_jCheckBox1DocumentDesenvolvimento_actionAdapter(this));
        jCheckBoxControleDeVerses.setText(this.rb.getString("passo07.controleDeVersoes"));
        jCheckBoxControleDeVerses.addActionListener(new
                Passo07_jCheckBoxControleDeVerses_actionAdapter(this));
        jPanel1.setBorder(border1);
        jLabel1.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel1.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo);
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(jCheckBoxrefactoring,
                    new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(14, 10, 0, 154), 0, 0));
        jPanel1.add(jCheckBoxDesenvolvimentoLadoALado,
                    new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(15, 10, 0, 62), 0, 0));
        jPanel1.add(jCheckBoxControleDeVerses,
                    new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(14, 14, 0, 112), 0, 0));
        jPanel1.add(jCheckBox1DocumentDesenvolvimento,
                    new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(14, 11, 0, 41), 2, 0));
        jPanel1.add(jCheckBoxDesenvolvimentoEmDuplas,
                    new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(14, 10, 0, 74), 0, 0));
        jPanel1.add(jCheckBoxIntegracaoParalela,
                    new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(14, 15, 0, 113), 6, 0));
        jPanel1.add(jCheckBoxDesenvolvimentoColetivo,
                    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 10, 0, 86), 0, 0));
        jPanel1.add(jCheckBoxDesenvolvimetnoSimultaneo,
                    new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 15, 0, 73), 0, 0));
        jPanel1.add(jCheckBoxEscritaDeTestesAntes,
                    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 10, 0, 0), 4, 0));
        jPanel1.add(jCheckBoxReunioesDiarias,
                    new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(15, 12, 0, 104), 28, 0));
        jPanel1.add(jCheckBoxImplementacao,
                    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(15, 10, 0, 134), 0, 0));
        jPanel1.add(jTextArea1, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(40, 10, 0, 135), 0, -74));
        jPanel1.add(jLabel1, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(42, 16, 9, 11), 0, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }



}


class Passo07_jCheckBox1DocumentDesenvolvimento_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBox1DocumentDesenvolvimento_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBox1DocumentDesenvolvimento_actionPerformed(e);
    }
}


class Passo07_jCheckBoxControleDeVerses_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxControleDeVerses_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxControleDeVerses_actionPerformed(e);
    }
}


class Passo07_jCheckBoxIntegracaoParalela_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxIntegracaoParalela_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxIntegracaoParalela_actionPerformed(e);
    }
}


class Passo07_jCheckBoxDesenvolvimetnoSimultaneo_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxDesenvolvimetnoSimultaneo_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDesenvolvimetnoSimultaneo_actionPerformed(e);
    }
}


class Passo07_jCheckBoxReunioesDiarias_actionAdapter implements ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxReunioesDiarias_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxReunioesDiarias_actionPerformed(e);
    }
}


class Passo07_jCheckBoxrefactoring_actionAdapter implements ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxrefactoring_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxrefactoring_actionPerformed(e);
    }
}


class Passo07_jCheckBoxDesenvolvimentoLadoALado_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxDesenvolvimentoLadoALado_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDesenvolvimentoLadoALado_actionPerformed(e);
    }
}


class Passo07_jCheckBoxDesenvolvimentoEmDuplas_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxDesenvolvimentoEmDuplas_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDesenvolvimentoEmDuplas_actionPerformed(e);
    }
}


class Passo07_jCheckBoxDesenvolvimentoColetivo_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxDesenvolvimentoColetivo_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxDesenvolvimentoColetivo_actionPerformed(e);
    }
}


class Passo07_jCheckBoxEscritaDeTestesAntes_actionAdapter implements
        ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxEscritaDeTestesAntes_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxEscritaDeTestesAntes_actionPerformed(e);
    }
}


class Passo07_jCheckBoxImplementacao_actionAdapter implements ActionListener {
    private Passo07 adaptee;
    Passo07_jCheckBoxImplementacao_actionAdapter(Passo07 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxImplementacao_actionPerformed(e);
    }
}
