package br.ufsc.fcama.ig.wizard;

import javax.swing.JPanel;

import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Iteracao;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.pratica.PraticaExecucaoDosTestes;
import br.ufsc.fcama.logica.pratica.PraticaImplementacao;
import br.ufsc.fcama.logica.pratica.PraticaInspecaoDeCodigo;
import br.ufsc.fcama.logica.pratica.PraticaIntegracaoAntesDaValidacao;

import javax.swing.UIManager;
import java.awt.*;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import javax.swing.BorderFactory;
import javax.swing.JOptionPane;
import javax.swing.border.Border;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo08 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 7;
    private int proximo = 9;
    private FramePrincipal frame;
    private WizardProjeto wizard;
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelTitulo = new JPanel();
    JPanel jPanel2 = new JPanel();
    JLabel jLabelTitulo = new JLabel();
    JLabel jLabel1 = new JLabel();
    JCheckBox jCheckBoxIntegracaoAntesDaValidacao = new JCheckBox();
    JCheckBox jCheckBoxExecucaoDosTestes = new JCheckBox();
    JCheckBox jCheckBoxInspecaoDeCodigo = new JCheckBox();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabel2 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

    public Passo08(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	Iteracao it = ((Iteracao)pj.getIteracoes().get(0));
    	if(it.getAtividadeValidarIncremento().getPraticaIntegracaoAntesDaValidacao().isSelecionada()){
    		jCheckBoxIntegracaoAntesDaValidacao.setSelected(true);
    	}else{
    		jCheckBoxIntegracaoAntesDaValidacao.setSelected(false);
    	}
    	if(it.getAtividadeValidarIncremento().getPraticaExecucaoDosTestes().isSelecionada()){
    		jCheckBoxExecucaoDosTestes.setSelected(true);
    	}else{
    		jCheckBoxExecucaoDosTestes.setSelected(false);
    	}
    	if(it.getAtividadeValidarIncremento().getPraticaInspecaoDeCodigo().isSelecionada()){
    		jCheckBoxInspecaoDeCodigo.setSelected(true);
    	}else{
    		jCheckBoxInspecaoDeCodigo.setSelected(false);
    	}
    }

    public void desabilitaHabilitaBotoesWizard() {
    	this.wizard.jButtonAntorior.setEnabled(true);
        if (((Iteracao)this.wizard.getProjeto().getIteracoes()
        		.iterator().next()).getAtividadeValidarIncremento().isRequisitosCompletos()){
        	this.wizard.jButtonProximo.setEnabled(true);
        }else{
        	this.wizard.jButtonProximo.setEnabled(false);
        }
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }

    public void jCheckBoxIntegracaoAntesDaValidacao_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaIntegracaoAntesDaValidacao.class,
					this.jCheckBoxIntegracaoAntesDaValidacao.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoAntesDaValidacao.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoAntesDaValidacao.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoAntesDaValidacao.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxExecucaoDosTestes_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaExecucaoDosTestes.class,
					this.jCheckBoxExecucaoDosTestes.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxExecucaoDosTestes.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxExecucaoDosTestes.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxExecucaoDosTestes.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBox3_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaInspecaoDeCodigo.class,
					this.jCheckBoxInspecaoDeCodigo.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxInspecaoDeCodigo.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica"),JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxInspecaoDeCodigo.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxInspecaoDeCodigo.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }


    private void jbInit() throws Exception {
        this.setBackground(UIManager.getColor(
                "InternalFrame.inactiveTitleGradient"));
        this.setPreferredSize(new Dimension(500,400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jPanel2.setLayout(gridBagLayout1);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setToolTipText("");
        jLabelTitulo.setText(this.rb.getString("passo08.titulo"));
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("passo08.texto"));
        jCheckBoxIntegracaoAntesDaValidacao.setToolTipText("");
        jCheckBoxIntegracaoAntesDaValidacao.setText(this.rb.getString("passo08.integracaoAnVal"));
        jCheckBoxIntegracaoAntesDaValidacao.addActionListener(new
                Passo08_jCheckBoxIntegracaoAntesDaValidacao_actionAdapter(this));
        jCheckBoxExecucaoDosTestes.setToolTipText("");
        jCheckBoxExecucaoDosTestes.setText(this.rb.getString("passo08.execucaoTestes"));
        jCheckBoxExecucaoDosTestes.addActionListener(new
                Passo08_jCheckBoxExecucaoDosTestes_actionAdapter(this));
        jCheckBoxInspecaoDeCodigo.setToolTipText("");
        jCheckBoxInspecaoDeCodigo.setText(this.rb.getString("passo08.inspecaoCodigo"));
        jCheckBoxInspecaoDeCodigo.addActionListener(new Passo08_jCheckBox3_actionAdapter(this));
        jPanel2.setBorder(border1);
        jLabel2.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel2.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo);
        this.add(jPanel2, java.awt.BorderLayout.CENTER);
        jPanel2.add(jCheckBoxInspecaoDeCodigo,
                    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 285), 0, 0));
        jPanel2.add(jCheckBoxExecucaoDosTestes,
                    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(14, 88, 0, 273), 0, 0));
        jPanel2.add(jCheckBoxIntegracaoAntesDaValidacao,
                    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(22, 90, 0, 231), 0, 0));
        jPanel2.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(40, 33, 0, 27), 0, 0));
        jPanel2.add(jLabel2, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(162, 92, 10, 186), 0, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }




}


class Passo08_jCheckBox3_actionAdapter implements ActionListener {
    private Passo08 adaptee;
    Passo08_jCheckBox3_actionAdapter(Passo08 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {

        adaptee.jCheckBox3_actionPerformed(e);
    }
}


class Passo08_jCheckBoxExecucaoDosTestes_actionAdapter implements
        ActionListener {
    private Passo08 adaptee;
    Passo08_jCheckBoxExecucaoDosTestes_actionAdapter(Passo08 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxExecucaoDosTestes_actionPerformed(e);
    }
}


class Passo08_jCheckBoxIntegracaoAntesDaValidacao_actionAdapter implements
        ActionListener {
    private Passo08 adaptee;
    Passo08_jCheckBoxIntegracaoAntesDaValidacao_actionAdapter(Passo08 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxIntegracaoAntesDaValidacao_actionPerformed(e);
    }
}
