package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Iteracao;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.pratica.PraticaIntegracaoDepoisDaValidacao;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo09 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 8;
    private int proximo = 10;
    private FramePrincipal frame;
    private WizardProjeto wizard;
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelTitulo = new JPanel();
    JPanel jPanel1 = new JPanel();
    TitledBorder titledBorder1 = new TitledBorder("");
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabelTitulo = new JLabel();
    JLabel jLabel1 = new JLabel();
    JCheckBox jCheckBoxIntegracaoDepoisDaValidacao = new JCheckBox();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

    public Passo09(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	Iteracao it = ((Iteracao)pj.getIteracoes().get(0));
    	if(it.getAtividadeIntegracaoIncremento().getPraticaIntegracaoDepoisDaValidacao().isSelecionada()){
    		jCheckBoxIntegracaoDepoisDaValidacao.setSelected(true);
    	}else{
    		jCheckBoxIntegracaoDepoisDaValidacao.setSelected(false);
    	}
    }

    public void desabilitaHabilitaBotoesWizard() {
    	this.wizard.jButtonAntorior.setEnabled(true);
        if (((Iteracao)this.wizard.getProjeto().getIteracoes()
        		.iterator().next()).getAtividadeIntegracaoIncremento().isRequisitosCompletos()){
        	this.wizard.jButtonProximo.setEnabled(true);
        }else{
        	this.wizard.jButtonProximo.setEnabled(false);
        }
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }
        this.wizard.jButtonCancelar.setEnabled(true);
    }
    
    public void jCheckBoxIntegracaoDepoisDaValidacao_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaIntegracaoDepoisDaValidacao.class,
					this.jCheckBoxIntegracaoDepoisDaValidacao.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoDepoisDaValidacao.setSelected(false);
			
		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoDepoisDaValidacao.setSelected(false);
			
		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica"),JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxIntegracaoDepoisDaValidacao.setSelected(true);
			
		}
		this.desabilitaHabilitaBotoesWizard();
    }


    private void jbInit() throws Exception {
        this.setBackground(UIManager.getColor(
                "InternalFrame.inactiveTitleGradient"));
        this.setPreferredSize(new Dimension(500,600));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jPanel1.setBorder(border1);
        jPanel1.setLayout(gridBagLayout1);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setText(this.rb.getString("passo09.titulo"));
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("passo09.texto"));
        jCheckBoxIntegracaoDepoisDaValidacao.setText(this.rb.getString("passo09.integracaiDepVali"));
        jCheckBoxIntegracaoDepoisDaValidacao.addActionListener(new
                Passo09_jCheckBoxIntegracaoDepoisDaValidacao_actionAdapter(this));
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo);
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(40, 31, 0, 31), 0, 0));
        jPanel1.add(jCheckBoxIntegracaoDepoisDaValidacao,
                    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(22, 90, 260, 227), 0, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }

    


}


class Passo09_jCheckBoxIntegracaoDepoisDaValidacao_actionAdapter implements
        ActionListener {
    private Passo09 adaptee;
    Passo09_jCheckBoxIntegracaoDepoisDaValidacao_actionAdapter(Passo09 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxIntegracaoDepoisDaValidacao_actionPerformed(e);
    }
}
