package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.Border;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.logica.Projeto;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.pratica.PraticaBreveDocumentacao;
import br.ufsc.fcama.logica.pratica.PraticaElaboracaoDoManual;
import br.ufsc.fcama.logica.pratica.PraticaEntregaDoSistema;
import br.ufsc.fcama.logica.pratica.PraticaRefinamentoDaDocumentacao;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class Passo11 extends JPanel implements Passo {

	private ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");
    private int anterior = 10;
    private int proximo = -1;
    private FramePrincipal frame;
    private WizardProjeto wizard;
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelTitulo = new JPanel();
    JPanel jPanel1 = new JPanel();
    Border border1 = BorderFactory.createLineBorder(Color.white, 2);
    JLabel jLabelTitulo = new JLabel();
    JLabel jLabel1 = new JLabel();
    JCheckBox jCheckBoxEntregaDoSistema = new JCheckBox();
    JCheckBox jCheckBoxBreveDocumentacao = new JCheckBox();
    JCheckBox jCheckBoxRefinamentoDaDocumentacao = new JCheckBox();
    JCheckBox jCheckBoxElaboracaoDoManual = new JCheckBox();
    JLabel jLabel2 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

    public Passo11(FramePrincipal frame, WizardProjeto wizard) {
        try {
            this.frame = frame;
            this.wizard = wizard;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setValores(){
    	Projeto pj = this.wizard.getProjeto();
    	if(pj.getAtividadeEntregaFinal().getPraticaEntregaDoSistema().isSelecionada()){
    		jCheckBoxEntregaDoSistema.setSelected(true);
    	}else{
    		jCheckBoxEntregaDoSistema.setSelected(false);
    	}
    	if(pj.getAtividadeEntregaFinal().getPraticaBreveDocumentacao().isSelecionada()){
    		jCheckBoxBreveDocumentacao.setSelected(true);
    	}else{
    		jCheckBoxBreveDocumentacao.setSelected(false);
    	}
    	if(pj.getAtividadeEntregaFinal().getPraticaRefinamentoDaDocumentacao().isSelecionada()){
    		jCheckBoxRefinamentoDaDocumentacao.setSelected(true);
    	}else{
    		jCheckBoxRefinamentoDaDocumentacao.setSelected(false);
    	}
    	if(pj.getAtividadeEntregaFinal().getPraticaElaboracaoDoManual().isSelecionada()){
    		jCheckBoxElaboracaoDoManual.setSelected(true);
    	}else{
    		jCheckBoxElaboracaoDoManual.setSelected(false);
    	}
    }

    public void desabilitaHabilitaBotoesWizard() {
        this.wizard.jButtonAntorior.setEnabled(true);
        this.wizard.jButtonProximo.setEnabled(false);
        if (this.wizard.getProjeto().isRequisitosProjetoCompleto()){
        	this.wizard.Concluir.setEnabled(true);
        }else{
        	this.wizard.Concluir.setEnabled(false);
        }

        this.wizard.jButtonCancelar.setEnabled(true);
    }

    public void jCheckBoxEntregaDoSistema_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaEntregaDoSistema.class,
					this.jCheckBoxEntregaDoSistema.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxEntregaDoSistema.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxEntregaDoSistema.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxEntregaDoSistema.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxBreveDocumentacao_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaBreveDocumentacao.class,
					this.jCheckBoxBreveDocumentacao.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxBreveDocumentacao.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxBreveDocumentacao.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxBreveDocumentacao.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxRefinamentoDaDocumentacao_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaRefinamentoDaDocumentacao.class,
					this.jCheckBoxRefinamentoDaDocumentacao.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxRefinamentoDaDocumentacao.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxRefinamentoDaDocumentacao.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxRefinamentoDaDocumentacao.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }

    public void jCheckBoxElaboracaoDoManual_actionPerformed(ActionEvent e) {
    	try {
    		// se estiver selecionado inclui se no exclui
			this.wizard.getProjeto().incluindoExcluindoPratica(PraticaElaboracaoDoManual.class,
					this.jCheckBoxElaboracaoDoManual.isSelected() ? Constantes.INCLUSAO : Constantes.EXCLUSAO);
		} catch (ExceptionPraticaNaoLiberada e1) {
			JOptionPane.showConfirmDialog(this,  this.rb.getString("wizardProjeto.erro.msn.naoLiberada"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxElaboracaoDoManual.setSelected(false);

		} catch (ExceptionInclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoPermitida"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxElaboracaoDoManual.setSelected(false);

		} catch (ExceptionExclusaoPraticaNaoPermitida e1) {
			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.naoExcluir"),this.rb.getString("wizardProjeto.erro.msn.tituloPratica") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			this.jCheckBoxElaboracaoDoManual.setSelected(true);

		}
		this.desabilitaHabilitaBotoesWizard();
    }


    private void jbInit() throws Exception {
        this.setBackground(UIManager.getColor(
                "InternalFrame.inactiveTitleGradient"));
        this.setPreferredSize(new Dimension(500,400));
        this.setLayout(borderLayout1);
        jPanelTitulo.setBackground(Color.white);
        jPanel1.setLayout(gridBagLayout1);
        jPanel1.setBorder(border1);
        jLabelTitulo.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 16));
        jLabelTitulo.setToolTipText("");
        jLabelTitulo.setText(this.rb.getString("passo11.titulo"));
        jLabel1.setFont(new java.awt.Font("Arial Black", Font.PLAIN, 12));
        jLabel1.setToolTipText("");
        jLabel1.setText(this.rb.getString("passo11.texto"));
        jCheckBoxEntregaDoSistema.setText(this.rb.getString("passo11.entregaDoSistema"));
        jCheckBoxEntregaDoSistema.addActionListener(new
                Passo11_jCheckBoxEntregaDoSistema_actionAdapter(this));
        jCheckBoxBreveDocumentacao.setText(this.rb.getString("passo11.breveDocumentacao"));
        jCheckBoxBreveDocumentacao.addActionListener(new
                Passo11_jCheckBoxBreveDocumentacao_actionAdapter(this));
        jCheckBoxRefinamentoDaDocumentacao.setToolTipText("");
        jCheckBoxRefinamentoDaDocumentacao.setText(this.rb.getString("passo11.refinamentoDoc"));
        jCheckBoxRefinamentoDaDocumentacao.addActionListener(new
                Passo11_jCheckBoxRefinamentoDaDocumentacao_actionAdapter(this));
        jCheckBoxElaboracaoDoManual.setToolTipText("");
        jCheckBoxElaboracaoDoManual.setText(this.rb.getString("passo11.elaboracaoManual"));
        jCheckBoxElaboracaoDoManual.addActionListener(new
                Passo11_jCheckBoxElaboracaoDoManual_actionAdapter(this));
        jLabel2.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
        jLabel2.setText(this.rb.getString("wizardProjeto.campoObrigatorio"));
        this.add(jPanelTitulo, java.awt.BorderLayout.NORTH);
        jPanelTitulo.add(jLabelTitulo);
        this.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(jCheckBoxEntregaDoSistema,
                    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(23, 90, 0, 283), 0, 0));
        jPanel1.add(jCheckBoxElaboracaoDoManual,
                    new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(12, 90, 0, 275), 0, 0));
        jPanel1.add(jCheckBoxRefinamentoDaDocumentacao,
                    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(14, 90, 0, 231), 0, 0));
        jPanel1.add(jCheckBoxBreveDocumentacao,
                    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                           , GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(13, 90, 0, 277), 0, 0));
        jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(41, 50, 0, 48), 0, 0));
        jPanel1.add(jLabel2, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(121, 93, 14, 185), 0, 0));
    }

    public void setAnterior(int anterior) {
        this.anterior = anterior;
    }

    public int getAnterior() {
        return this.anterior;
    }

    public void setProximo(int proximo) {
        this.proximo = proximo;
    }

    public int getProximo() {
        return this.proximo;
    }




}


class Passo11_jCheckBoxElaboracaoDoManual_actionAdapter implements
        ActionListener {
    private Passo11 adaptee;
    Passo11_jCheckBoxElaboracaoDoManual_actionAdapter(Passo11 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxElaboracaoDoManual_actionPerformed(e);
    }
}


class Passo11_jCheckBoxRefinamentoDaDocumentacao_actionAdapter implements
        ActionListener {
    private Passo11 adaptee;
    Passo11_jCheckBoxRefinamentoDaDocumentacao_actionAdapter(Passo11 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxRefinamentoDaDocumentacao_actionPerformed(e);
    }
}


class Passo11_jCheckBoxBreveDocumentacao_actionAdapter implements
        ActionListener {
    private Passo11 adaptee;
    Passo11_jCheckBoxBreveDocumentacao_actionAdapter(Passo11 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxBreveDocumentacao_actionPerformed(e);
    }
}


class Passo11_jCheckBoxEntregaDoSistema_actionAdapter implements ActionListener {
    private Passo11 adaptee;
    Passo11_jCheckBoxEntregaDoSistema_actionAdapter(Passo11 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxEntregaDoSistema_actionPerformed(e);
    }
}
