package br.ufsc.fcama.ig.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import br.ufsc.fcama.exception.ExceptionArquivoJaExiste;
import br.ufsc.fcama.ig.FramePrincipal;
import br.ufsc.fcama.ig.jPanel.JPanelProjeto;
import br.ufsc.fcama.logica.Projeto;

/**
 * <p>Title: FCAMA</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Thiago Leo Machado
 * @version 1.0
 */
public class WizardProjeto extends JDialog  {
  
  private int tipo;
  protected Passo[] passos;
  private int passoAtual = -1;
  private Projeto projeto;
  ResourceBundle rb = PropertyResourceBundle.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties");

    public WizardProjeto(FramePrincipal framePrincipal, int tipo) {
        try {
        	this.tipo = tipo;
            this.framePrincipal = framePrincipal;
            this.projeto = new Projeto();
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
   
    public Projeto getProjeto(){
        return this.projeto;
    }
    
    protected void setProjeto(Projeto projeto){
    	this.projeto = projeto;
    }
    
    
    public void jButtonAntorior_actionPerformed(ActionEvent e) {
        int passoVelho = this.passoAtual;
        this.passoAtual = this.passos[passoAtual].getAnterior();
        this.getContentPane().remove((JPanel)this.passos[passoVelho]);
        this.getContentPane().add((JPanel)this.passos[passoAtual],
                                  java.awt.BorderLayout.CENTER);
        this.passos[passoAtual].desabilitaHabilitaBotoesWizard();
        this.passos[passoAtual].setValores();
        this.setVisible(false);
        this.setVisible(true);
    }

    public void jButtonProximo_actionPerformed(ActionEvent e) {
        int passoVelho = this.passoAtual;
        this.passoAtual = this.passos[passoAtual].getProximo();
        this.getContentPane().remove((JPanel)this.passos[passoVelho]);
        this.getContentPane().add((JPanel)this.passos[passoAtual],
                                  java.awt.BorderLayout.CENTER);
        this.passos[passoAtual].desabilitaHabilitaBotoesWizard();
        this.passos[passoAtual].setValores();
        this.setVisible(false);
        this.setVisible(true);
        
    }

    public void Concluir_actionPerformed(ActionEvent e) {
    	
    	
        //mandar criar o projeto fisicamente e construir a arvore
    	if (this.tipo == WizardProjeto.WIZARD_PROJETO){
	        this.framePrincipal.setProjeto(this.projeto);
	        this.framePrincipal.setAreaDeTrabalho(this.rb.getString("wizardProjeto.projeto")+ this.projeto.getNomeProjeto(), new JPanelProjeto(this.framePrincipal));
	        this.dispose();
	    }else{
    		try {
				this.framePrincipal.persistencia.criarModelo(this.projeto,this.projeto.getNomeProjeto());
				this.dispose();
				JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.modelo.criado") ,this.rb.getString("wizardProjeto.erro.msn.modelo.titulo") ,JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE );
    		} catch (IOException e1) {
    			JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.modelo.naoCriado") ,this.rb.getString("wizardProjeto.erro.msn.modelo.titulo") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			} catch (ExceptionArquivoJaExiste e1) {
				JOptionPane.showConfirmDialog(this, this.rb.getString("wizardProjeto.erro.msn.modelo.jaExiste") ,this.rb.getString("wizardProjeto.erro.msn.modelo.titulo") ,JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE );
			}
    	}
	        
    }

    public void jButtonCancelar_actionPerformed(ActionEvent e) {
        this.dispose();
    }
    
    
    

    private void jbInit() throws Exception {
        this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        this.setModal(true);
        //  setSize(new Dimension(800, 600));
       // this.setIconImage(this.getToolkit().getImage("imagens/logo.gif"));
        this.setResizable(false);
        this.setTitle(this.rb.getString("wizardProjeto.titulo"));
        this.getContentPane().setLayout(borderLayout1);
        jButtonAntorior.setToolTipText("");
        jButtonAntorior.setIcon(iconAnterior);
        jButtonAntorior.setText(this.rb.getString("wizardProjeto.button.anterior"));
        jButtonAntorior.addActionListener(new
                WizardProjeto_jButtonAntorior_actionAdapter(this));
        jButtonProximo.setIcon(iconProximo);
        jButtonProximo.setText(this.rb.getString("wizardProjeto.button.proximo"));
        jButtonProximo.addActionListener(new
                WizardProjeto_jButtonProximo_actionAdapter(this));
        Concluir.setEnabled(false);
        Concluir.setIcon(iconeTranparente);
        Concluir.setText(this.rb.getString("wizardProjeto.button.concluir"));
        Concluir.addActionListener(new WizardProjeto_Concluir_actionAdapter(this));
        jButtonCancelar.setIcon(iconeTranparente);
        jButtonCancelar.setText(this.rb.getString("wizardProjeto.button.cancelar"));
        jButtonCancelar.addActionListener(new
                WizardProjeto_jButtonCancelar_actionAdapter(this));
        jPanel1.setMinimumSize(new Dimension(10, 10));
        jPanel1.setPreferredSize(new Dimension(400, 400));
        jPanelBotoes.setBackground(Color.white);
        this.getContentPane().add(jPanelBotoes, java.awt.BorderLayout.SOUTH);
        jPanelBotoes.add(jButtonAntorior);
        jPanelBotoes.add(jButtonProximo);
        jPanelBotoes.add(Concluir);
        jPanelBotoes.add(jButtonCancelar);

        //criar os passos
        this.passos = new Passo[12];
        
        passos[0] = new Passo00(this.framePrincipal, this);
        this.passoAtual = 0;
        if (this.tipo == WizardProjeto.WIZARD_PROJETO){
        	passos[1] = new Passo01(this.framePrincipal, this);
        }else{
        	passos[1] = new Passo01M(this.framePrincipal, this);
        }
        passos[2] = new Passo02(this.framePrincipal, this);
        passos[3] = new Passo03(this.framePrincipal, this);
        passos[4] = new Passo04(this.framePrincipal, this);
        passos[5] = new Passo05(this.framePrincipal, this);
        passos[6] = new Passo06(this.framePrincipal, this);
        passos[7] = new Passo07(this.framePrincipal, this);
        passos[8] = new Passo08(this.framePrincipal, this);
        passos[9] = new Passo09(this.framePrincipal, this);
        passos[10] = new Passo10(this.framePrincipal, this);
        passos[11] = new Passo11(this.framePrincipal, this);

        this.getContentPane().add((JPanel)passos[0], java.awt.BorderLayout.CENTER);
        passos[0].desabilitaHabilitaBotoesWizard();
        // Center the window
        Point  pointFramePrincipal = framePrincipal.getXY();
        Point point = new Point();
        point.setLocation(pointFramePrincipal.getX()+(pointFramePrincipal.getX() /2)   ,
                          pointFramePrincipal.getY()+(pointFramePrincipal.getY() /  2)   );
        this.setLocation(point);

        pack();
        this.setVisible(true);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanelBotoes = new JPanel();
    JButton jButtonAntorior = new JButton();
    JButton jButtonProximo = new JButton();
    JButton Concluir = new JButton();
    JButton jButtonCancelar = new JButton();
    Icon iconLogo = new ImageIcon("imagens/logo.gif");
    Icon iconProximo = new ImageIcon("imagens/proximo.gif");
    Icon iconAnterior = new ImageIcon("imagens/anterior.gif");
    Icon iconeTranparente = new ImageIcon("imagens/iconeTranparente.gif");
    FramePrincipal framePrincipal ;
    JPanel jPanel1 = new JPanel();
    
    public static final int WIZARD_MODELO = 0;
    public static final int WIZARD_PROJETO = 1;

   
}











class WizardProjeto_jButtonProximo_actionAdapter implements ActionListener {
    private WizardProjeto adaptee;
    WizardProjeto_jButtonProximo_actionAdapter(WizardProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonProximo_actionPerformed(e);
    }
}


class WizardProjeto_Concluir_actionAdapter implements ActionListener {
    private WizardProjeto adaptee;
    WizardProjeto_Concluir_actionAdapter(WizardProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.Concluir_actionPerformed(e);
    }
}


class WizardProjeto_jButtonCancelar_actionAdapter implements ActionListener {
    private WizardProjeto adaptee;
    WizardProjeto_jButtonCancelar_actionAdapter(WizardProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancelar_actionPerformed(e);
    }
}





class WizardProjeto_jButtonAntorior_actionAdapter implements ActionListener {
    private WizardProjeto adaptee;
    WizardProjeto_jButtonAntorior_actionAdapter(WizardProjeto adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAntorior_actionPerformed(e);
    }
}
