/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.atividade;

import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.exception.ExceptionPraticaNaoPertenceAEtapa;
import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.pratica.Pratica;
import br.ufsc.fcama.persistencia.ObjectFCAMA;

/**
 * @author Thiago Leo Machado
 */
public abstract class Atividade  extends ObjectFCAMA{
    
    public Atividade(){
    }
    
    /**
     * Confere se as atividades obrigatrias da etapa foram selecionadas
     * @return
     */
    public abstract boolean isRequisitosCompletos();
    
    /**
     * Confere se a atividade pode ser incluida ou excluida lana uma exceo quando no.
     * Quando a atividade que est sendo incluida faz parte da etapa j realiza a incluso ou excluso.
     * Quando lana uma exceo j arruma os estados das atividades, realizando a operao contraria.
     * @param classPratica
     * @param operacao
     * @throws ExceptionInclusaoPraticaNaoPermitida
     * @throws ExceptionExclusaoPraticaNaoPermitida
     */
    public abstract void incluindoExcluindoPratica(Class classPratica, String operacao)throws ExceptionPraticaNaoLiberada, ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida;;
    
    /**
     * Retorna a atividade selecionada.
     * Caso a atividade no faa parte da etapa por no ter sido selecionada lana uma exceo
     * @param classPratica
     * @return
     * @throws ExceptionPraticaNaoPertenceAEtapa
     */
    public abstract Pratica getPratica(Class classPratica)throws ExceptionPraticaNaoPertenceAEtapa;
}
