/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.atividade;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionPraticaNaoLiberada;
import br.ufsc.fcama.exception.ExceptionPraticaNaoPertenceAEtapa;
import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.pratica.Pratica;
import br.ufsc.fcama.logica.pratica.PraticaIntegracaoDepoisDaValidacao;

/**
 * @author Thiago Leo Machado
 */
public class AtividadeIntegracaoIncremento extends Atividade {

	//Atividade optativa
	private PraticaIntegracaoDepoisDaValidacao praticaIntegracaoDepoisDaValidacao;

	public AtividadeIntegracaoIncremento(){
		super();
		this.praticaIntegracaoDepoisDaValidacao = new PraticaIntegracaoDepoisDaValidacao();
	}

	/* (non-Javadoc)
	 * @see br.ufsc.fcama.etapa.Etapa#isRequisitosCompletos()
	 */
	public boolean isRequisitosCompletos() {
		return true;
	}

	/* (non-Javadoc)
	 * @see br.ufsc.fcama.etapa.Etapa#incluindaExcluindoAtividade(java.lang.Class, java.lang.String)
	 */
	public void incluindoExcluindoPratica(Class classPratica, String operacao) throws ExceptionPraticaNaoLiberada,  ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		this.praticaIntegracaoDepoisDaValidacao.confereDependencia(classPratica, operacao);
		//Confere se  uma das atividade da etapa, caso sim manda selecionara ou tirar a seleo
		if (classPratica == PraticaIntegracaoDepoisDaValidacao.class){
			this.praticaIntegracaoDepoisDaValidacao.selecionar();
		}
	}

	/* (non-Javadoc)
	 * @see br.ufsc.fcama.etapa.Etapa#getAtividade(java.lang.Class)
	 */
	public Pratica getPratica(Class classPratica) throws ExceptionPraticaNaoPertenceAEtapa {
		if (classPratica == PraticaIntegracaoDepoisDaValidacao.class ){
			return this.praticaIntegracaoDepoisDaValidacao;
		}else {
			throw new ExceptionPraticaNaoPertenceAEtapa(classPratica, AtividadeIntegracaoIncremento.class);
		}
	}

	/**
	 * @return Returns the atividadeIntegracaoDepoisDaValidacao.
	 */
	public PraticaIntegracaoDepoisDaValidacao getPraticaIntegracaoDepoisDaValidacao() {
		return praticaIntegracaoDepoisDaValidacao;
	}

	/**
	 * @param atividadeIntegracaoDepoisDaValidacao The atividadeIntegracaoDepoisDaValidacao to set.
	 */
	protected void setPraticaIntegracaoDepoisDaValidacao(
			PraticaIntegracaoDepoisDaValidacao atividadeIntegracaoDepoisDaValidacao) {
		this.praticaIntegracaoDepoisDaValidacao = atividadeIntegracaoDepoisDaValidacao;
	}

	public AtividadeIntegracaoIncremento copiaAtividade(){
		AtividadeIntegracaoIncremento atividadeIntegracaoIncremento = new AtividadeIntegracaoIncremento();
		atividadeIntegracaoIncremento.setPraticaIntegracaoDepoisDaValidacao((PraticaIntegracaoDepoisDaValidacao)
				this.praticaIntegracaoDepoisDaValidacao.copiaAtividade(new PraticaIntegracaoDepoisDaValidacao()));
		return atividadeIntegracaoIncremento;
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.atividade.IntegracaoIncremento");
       }

}
