package br.ufsc.fcama.logica.objAux;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;

public class Requisito {

	//pode ser "Alta", "Muito Alta" e "Mdia"
	protected String prioridade;
	protected String nome;
	protected int ordem;
	protected String descricao;
	protected float tempoEstimado;
	protected Date dtInicio;
	protected Date dtFim;
	protected Date dtInicioPrevisto;
	protected Date dtFimPrevisto;
	//Lista de stakeholders responsveis pelo desenvolvimento do requisito
	protected ArrayList responsaveis;
	protected String estado;
	//O ciclo de desenvolvimento que a atividade faz parte
	//quando no foi atribuida a nenhum ciclo o valor  0
	protected int nuCincloDeDesenvolvimento;
	
	public Requisito(){
		this.estado = Constantes.PENDENTE;
		this.nuCincloDeDesenvolvimento = 0;
		this.responsaveis = new ArrayList();
	}
	
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getDescricao() {
		return descricao;
	}
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public Date getDtFim() {
		return dtFim;
	}
	public void setDtFim(Date dtFim) {
		this.dtFim = dtFim;
	}
	public Date getDtInicio() {
		return dtInicio;
	}
	public void setDtInicio(Date dtInicio) {
		this.dtInicio = dtInicio;
	}
	
	public String getPrioridade() {
		return prioridade;
	}
	public void setPrioridade(String prioridade) {
		this.prioridade = prioridade;
	}
	public float getTempoEstimado() {
		return tempoEstimado;
	}
	public void setTempoEstimado(float tempoEstimado) {
		this.tempoEstimado = tempoEstimado;
	}
	public String getEstado() {
		return estado;
	}

	public void setEstado(String estado) {
		this.estado = estado;
	}

	public int getOrdem() {
		return ordem;
	}

	public void setOrdem(int ordem) {
		this.ordem = ordem;
	}

	public ArrayList getResponsaveis() {
		return responsaveis;
	}

	public void setResponsaveis(ArrayList responsaveis) {
		this.responsaveis = responsaveis;
	}
	
	public void addResponsavel(Stakeholder stakeholder){
		this.responsaveis.add(stakeholder);
	}
	
	public void removeResponsavel(Stakeholder stakeholder){
		Iterator it = this.responsaveis.iterator();
		Stakeholder s = null;
		while (it.hasNext()){
			s = (Stakeholder) it.next();
			if ((stakeholder.getNome() + " " + stakeholder.getFuncao()).equals(s.getNome() + " " + s.getFuncao())){
				it.remove();
				return;
			}
		}
	}

	public int getNuCincloDeDesenvolvimento() {
		return nuCincloDeDesenvolvimento;
	}

	public void setNuCincloDeDesenvolvimento(int nuCincloDeDesenvolvimento) {
		this.nuCincloDeDesenvolvimento = nuCincloDeDesenvolvimento;
	}

	public Date getDtFimPrevisto() {
		return this.dtFimPrevisto;
	}

	public void setDtFimPrevisto(Date dtFimPrevisto) {
		this.dtFimPrevisto = dtFimPrevisto;
	}

	public Date getDtInicioPrevisto() {
		return this.dtInicioPrevisto;
	}

	public void setDtInicioPrevisto(Date dtInicioPrevisto) {
		this.dtInicioPrevisto = dtInicioPrevisto;
	}
	
	
	

}
