/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaAtualizacaoDaDocumentacao extends Pratica {


    public PraticaAtualizacaoDaDocumentacao(){
        super();
        //Como a atividade durao das iteraes tem dependncias mas no tem esse critrio
		//ser colocado no outras a class da atividade
		//assim quando for selecionada no ter problema este criterio estar ok
		super.outras.put(PraticaDuracaoDasIteracoes.class,PraticaDuracaoDasIteracoes.class);
		//Como a atividade  dependente da atividade planejamento, duracao das iteraes e
		// distribuio dos requisitos das iteraes
		//sero colocadas em obricatorios as Atividades com Boolean(false)
		super.obrigatorias.put(PraticaPlanejamentoDasIteracoes.class, new Boolean(false));
		super.obrigatorias.put(PraticaDuracaoDasIteracoes.class, new Boolean(false));
    }

    /* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
	    //entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaPlanejamentoDasIteracoes.class
	            || classAtividade == PraticaDuracaoDasIteracoes.class){
	        //se estiver selecionada lana uma exception
	        if (super.isSelecionada() ){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaAtualizacaoDaDocumentacao.class);
	        }else{
	            //caso contrario apenas remove a atividade de obrigatorias que est com true
	            //e cloloca uma class AtividadePlanejamentoDasIteracoes com false
	            super.obrigatorias.remove(classAtividade);
		        super.obrigatorias.put(classAtividade, new Boolean(false));
	        }
	    }else if (classAtividade == PraticaBreveDocumentacao.class/*Excludente na vertical*/){
	    	super.excludentes.remove(classAtividade);
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaPlanejamentoDasIteracoes.class
	            || classAtividade == PraticaDuracaoDasIteracoes.class){
	        //remove a class atividade que est com false
	        //e coloca uma class Atividade com true
	        super.obrigatorias.remove(classAtividade);
	        super.obrigatorias.put(classAtividade, new Boolean(true));
	    }else if (classAtividade == PraticaBreveDocumentacao.class/*Excludente na vertical*/){
	    	if (super.isSelecionada()){
	    		throw new ExceptionInclusaoPraticaNaoPermitida(PraticaAtualizacaoDaDocumentacao.class);
	    	}else{
	    		super.excludentes.put(classAtividade, classAtividade);
	    	}
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.AtualizacaoDaDocumentacao");
       }

}
