/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaBreveDocumentacao extends Pratica {


	public PraticaBreveDocumentacao(){
		super();
		//como no tem dependncia do tipo obrigatrias
		super.obrigatorias.put(PraticaBreveDocumentacao.class, new Boolean(true));
		//como no tem dependncia do tipo outras
		super.outras.put(PraticaBreveDocumentacao.class, PraticaBreveDocumentacao.class);
	}

	/* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		//entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaDocumentacaoDetalhada.class
	    		|| classAtividade == PraticaAtualizacaoDaDocumentacao.class
				|| classAtividade == PraticaDocumentacaoDoProjeto.class
				|| classAtividade == PraticaDocumentacaoDoDesenvolvimento.class
				|| classAtividade == PraticaRefinamentoDaDocumentacao.class){
	        super.excludentes.remove(classAtividade);
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaDocumentacaoDetalhada.class
	    		|| classAtividade == PraticaAtualizacaoDaDocumentacao.class
				|| classAtividade == PraticaDocumentacaoDoProjeto.class
				|| classAtividade == PraticaDocumentacaoDoDesenvolvimento.class
				|| classAtividade == PraticaRefinamentoDaDocumentacao.class){
	    	if (super.isSelecionada()){
	    		throw new ExceptionInclusaoPraticaNaoPermitida(PraticaBreveDocumentacao.class);
	    	}else{
	    		super.excludentes.put(classAtividade, classAtividade);
	    	}
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.BreveDocumentacao");
       }

}
