/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaDesenvolvimentoColetivo extends Pratica {


    public PraticaDesenvolvimentoColetivo(){
        super();
        //pq no tem dependncias do tipo obrigatria
        super.obrigatorias.put(PraticaDesenvolvimentoColetivo.class, new Boolean (true));
        //pq no tem dependncia do tipo outras
        super.outras.put(PraticaDesenvolvimentoColetivo.class, PraticaDesenvolvimentoColetivo.class);
    }


    /* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
	    //entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaDistribuicaoDosRequisitos.class ){
	            super.excludentes.remove(classAtividade);
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaDistribuicaoDosRequisitos.class ){
	        if (super.isSelecionada()){
	            throw new ExceptionInclusaoPraticaNaoPermitida(PraticaDesenvolvimentoColetivo.class);
	        }else {
	            super.excludentes.put(classAtividade, classAtividade);
	        }
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.DesenvolvimentoColetivo");
       }

}
