/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.objAux.DuplaDesenvolvimento;

/**
 * @author Thiago Leo Machado
 */
public class PraticaDesenvolvimentoLadoALado extends Pratica {

	private ArrayList duplas;

	public PraticaDesenvolvimentoLadoALado(){
		super();
		//Essa atividade tem dependncia do tipo obrigatria, mas essa dependncia 
		//da execuo da atividade Distribuio dos Requisitos ou da atividade Desenvolvimento Coletivo
		//ento vai ser colocada as duas atividades no hash obrigatrias mas vai ser dado um tratamento
		//especial no mtodo confereDependencia
		super.obrigatorias.put(PraticaDistribuicaoDosRequisitos.class, new Boolean(false));
		super.obrigatorias.put(PraticaDesenvolvimentoColetivo.class, new Boolean(false));
		//como no tem dependencia do tipo outras
		super.outras.put(PraticaDesenvolvimentoLadoALado.class, PraticaDesenvolvimentoLadoALado.class);
		this.duplas = new ArrayList();
	}


	/* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
//		entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaDistribuicaoDosRequisitos.class
	    		|| classAtividade == PraticaDesenvolvimentoColetivo.class){
	        //caso esteja selecionada lana um exceo
	    	if (super.isSelecionada()){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaDesenvolvimentoLadoALado.class);
	        }else{
	         //caso contrario remove a atividade  e adiciona as duas atividade como no construtor
	            super.obrigatorias.remove(classAtividade);
	            super.obrigatorias.put(PraticaDistribuicaoDosRequisitos.class, new Boolean(false));
	    		super.obrigatorias.put(PraticaDesenvolvimentoColetivo.class, new Boolean(false));
	        }
	    }else if (classAtividade == PraticaDesenvolvimentoEmDuplas.class) {
	       super.excludentes.remove(classAtividade);
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaDistribuicaoDosRequisitos.class
	    		|| classAtividade == PraticaDesenvolvimentoColetivo.class){
	        //para fazer o controle ou AtividadeDistribuicaoDosRequisitos ou AtividadeDesenvolvimentoColetivo
	    	//remove as duas que esto com Boolean(false)
	    	//e adiciona a que est sendo selecionada com Boolean(true)
	    	super.obrigatorias.remove(PraticaDistribuicaoDosRequisitos.class);
	        super.obrigatorias.remove(PraticaDesenvolvimentoColetivo.class);
	        super.obrigatorias.put(classAtividade, new Boolean(true));
	    }else if (classAtividade == PraticaDesenvolvimentoEmDuplas.class) {
	    	if (super.isSelecionada()){
	            throw new ExceptionInclusaoPraticaNaoPermitida(PraticaDesenvolvimentoLadoALado.class);
	        }else {
	            super.excludentes.put(classAtividade, classAtividade);
	        }
	    }
	}


	public ArrayList getDuplas() {
		return this.duplas;
	}

	public void setDuplas(ArrayList duplas) {
		this.duplas = duplas;
	}

	public void addDupla(DuplaDesenvolvimento dupla){
		this.duplas.add(dupla);
	}

	public void removeDupla(DuplaDesenvolvimento dupla){
		Iterator it = this.duplas.iterator();
		DuplaDesenvolvimento dd = null;
		while(it.hasNext()){
			dd = (DuplaDesenvolvimento)it.next();
			if ((dupla.getStakeholder1().getNome() + " " + dupla.getStakeholder1().getFuncao()).equals(dd.getStakeholder1().getNome()+" "+ dd.getStakeholder1().getFuncao()) &&
			        (dupla.getStakeholder2().getNome() + " " + dupla.getStakeholder2().getFuncao()).equals(dd.getStakeholder2().getNome()+" "+ dd.getStakeholder2().getFuncao())){
				it.remove();
				return;
			}
		}
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.DesenvolvimentoLadoALado");
       }


}
