/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaDistribuicaoDosRequisitos extends Pratica {


    public PraticaDistribuicaoDosRequisitos(){
        super();
		//Como a atividade distribuio dos requisitos no tem dependncias desse tipo ento
		//ser colocado no outras a class da atividade
		//assim quando for selecionada no ter problema este criterio estar ok
		super.outras.put(PraticaDistribuicaoDosRequisitos.class,PraticaDistribuicaoDosRequisitos.class);
		//Como a atividade distribuicao dos requisitos no tem dependncias desse tipo ento
		//ser colocado no obrigatrias a class da atividade com Boolean true
		//assim quando for selecionada no ter problema este critrio estar ok
		super.obrigatorias.put(PraticaDistribuicaoDosRequisitos.class, new Boolean(true));
    }


    /* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
	    // entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaDesenvolvimentoColetivo.class ){
	        //remove a atividade de excludentes
	        super.excludentes.remove(classAtividade);
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaDesenvolvimentoColetivo.class ){
	        //caso esteja selecionada lana uma exception pq elas so excludentes
	        if (super.isSelecionada()){
	            throw new ExceptionInclusaoPraticaNaoPermitida(PraticaDistribuicaoDosRequisitos.class);
	        }else{//seta a classAtividade no exscludentes
	            super.excludentes.put(classAtividade, classAtividade);
	        }
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.DistribuicaoDosRequisitos");
       }

}
