/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;
import br.ufsc.fcama.logica.objAux.RequisitoAnexo;
import br.ufsc.fcama.logica.objAux.UserStory;

/**
 * @author Thiago Leo Machado
 */
public class PraticaDocumentacaoDetalhada extends Pratica {
	
	private ArrayList requisitosAnexos;

	public PraticaDocumentacaoDetalhada(){
		super();
		this.requisitosAnexos = new ArrayList();
		//Como a atividade Documentao Detalhada no tem dependncias
		//ser colocado no outras a class da atividade
		//assim quando for selecionada no ter problema pois estar liberada
		super.outras.put(PraticaDocumentacaoDetalhada.class, PraticaDocumentacaoDetalhada.class);
		//Como a atividade documentao detalhada no tem dependncias
		//ser colocado no obrigatrias a class da atividade com Boolean true
		//assim quando for selecionada no ter problema este critrio estar ok
		super.obrigatorias.put(PraticaDocumentacaoDetalhada.class, new Boolean(true));
	}

	/* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		//entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaBreveDocumentacao.class /*Excludente na vertical*/){
	    	super.excludentes.remove(classAtividade);
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaBreveDocumentacao.class  /*Excludente na vertical*/){
	    	if (super.isSelecionada()){
	    		throw new ExceptionInclusaoPraticaNaoPermitida(PraticaDocumentacaoDetalhada.class);
	    	}else{
	    		super.excludentes.put(classAtividade, classAtividade);
	    	}

	    }
	}
	
	public ArrayList getRequisitosAnexos() {
		return this.requisitosAnexos;
	}

	public void setRequisitosAnexos(ArrayList requisitosAnexos) {
		this.requisitosAnexos = requisitosAnexos;
	}

	public void addRequisitosAnexos(RequisitoAnexo requisitoAnexo){
		this.requisitosAnexos.add(requisitoAnexo);
	}

	public void removeRequisitoAnexo(RequisitoAnexo requisitoAnexo){
		Iterator it = this.requisitosAnexos.iterator();
		RequisitoAnexo req = null;
		while(it.hasNext()){
			req = (RequisitoAnexo)it.next();
			if (requisitoAnexo.getNome().equals(req.getNome())){
				it.remove();
				return;
			}
		}
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.DocumentacaoDetalhada");
       }

}
