/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaDocumentacaoDoProjeto extends Pratica {


    public PraticaDocumentacaoDoProjeto(){
        super();
        //pq no tem dependncia do tipo obrigatorias
        super.obrigatorias.put(PraticaDocumentacaoDoProjeto.class, new Boolean(true));
    }

    /* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
	    //entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaProjetoGeral.class
	            || classAtividade == PraticaProjetoDetalhado.class){
	        //caso seja dependente e o hash outras esteja com tamanho 1 e a atividade est selecionada
	        //lana uma exception
	        if (super.isSelecionada() && super.outras.size() == 1){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaDocumentacaoDoProjeto.class);
	        }else{
	         //caso contrario apenas remove a atividade da lista das liberaes
	            super.outras.remove(classAtividade);
	        }
	    }else if(classAtividade == PraticaBreveDocumentacao.class/*Excludente na vertical*/){
	    	super.excludentes.remove(classAtividade);
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaProjetoGeral.class
	            || classAtividade == PraticaProjetoDetalhado.class){
	        super.outras.put(classAtividade, classAtividade);
	    }else if(classAtividade == PraticaBreveDocumentacao.class/*Excludente na vertical*/){
	    	if(super.isSelecionada()){
	    		throw new ExceptionInclusaoPraticaNaoPermitida(PraticaDocumentacaoDoProjeto.class);
	    	}else{
	    		super.excludentes.put(classAtividade,classAtividade);
	    	}
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.DocumentacaoDoProjeto");
       }

}
