/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaDuracaoDasIteracoes extends Pratica {


    public PraticaDuracaoDasIteracoes(){
        super();
        //Como a atividade durao das iteraes tem dependncias mas no tem esse critrio
		//ser colocado no outras a class da atividade
		//assim quando for selecionada no ter problema este criterio estar ok
		super.outras.put(PraticaDuracaoDasIteracoes.class,PraticaDuracaoDasIteracoes.class);
		//Como a atividade  dependente da atividade planejamento das iteraes
		//ser colocado em obricatorios a AtividadePlanejamentoDasIteracoes e Boolean(false)
		super.obrigatorias.put(PraticaPlanejamentoDasIteracoes.class, new Boolean(false));
    }



    /* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
	    // entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaPlanejamentoDasIteracoes.class ){
	        //caso seja dependente e o hash outras esteja com tamanho 1 e a atividade est selecionada
	        //lana uma exception
	        if (super.isSelecionada() ){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaDuracaoDasIteracoes.class);
	        }else{
	            //caso contrario apenas remove a atividade de obrigatorias que est com true
	            //e cloloca uma class AtividadePlanejamentoDasIteracoes com false
	            super.obrigatorias.remove(classAtividade);
		        super.obrigatorias.put(classAtividade, new Boolean(false));
	        }
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaPlanejamentoDasIteracoes.class ){
	        //remove a class AtividadePlanejamentoDasIteracoes que est com false
	        //e colocas uma class AtividadePlanejamentoDasIteracoes com true
	        super.obrigatorias.remove(classAtividade);
	        super.obrigatorias.put(classAtividade, new Boolean(true));
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.DuracaoDasIteracoes");
       }

}
