/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaElaboracaoDoManual extends Pratica{

	public PraticaElaboracaoDoManual(){
		super();
		//como no tem dependncia do tipo outras
		super.outras.put(PraticaElaboracaoDoManual.class, PraticaElaboracaoDoManual.class);
	}

	/* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		//entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaImplementacao.class ){
	        //caso esteja selecionada lana um exceo
	    	if (super.isSelecionada()){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaElaboracaoDoManual.class);
	        }else{
	            super.obrigatorias.remove(classAtividade);
	            super.obrigatorias.put(PraticaImplementacao.class, new Boolean(false));
	        }
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaImplementacao.class){
	    	super.obrigatorias.remove(classAtividade);
	    	super.obrigatorias.put(classAtividade, new Boolean(true));
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.ElaboracaoDoManual");
       }

}
