/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaEscritaDosTestesAntesDaImplementacao extends Pratica {

	public PraticaEscritaDosTestesAntesDaImplementacao(){
	    super();
	    //pq tem dependncias do tipo obrigatorias
	    super.obrigatorias.put(PraticaProjetoGeral.class, new Boolean(false));
	}

    /* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
	    //entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaUserStories.class || classAtividade == PraticaListaDeRequisitos.class
	            || classAtividade == PraticaDocumentacaoDetalhada.class ){
	        //caso seja dependente e o hash outras esteja com tamanho 1 e a atividade est selecionada
	        //lana uma exception
	        if (super.isSelecionada() && super.outras.size() == 1){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaEscritaDosTestesAntesDaImplementacao.class);
	        }else{
	         //caso contrario apenas remove a atividade da lista das liberaes
	            super.outras.remove(classAtividade);
	        }
	    }else if (classAtividade == PraticaProjetoGeral.class) {
	        //caso esteja selecionada lana uma exception
	        if (super.isSelecionada()){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaEscritaDosTestesAntesDaImplementacao.class);
	        }else{
	            //caso contrario remove a atividade do obrigatorias e coloca novamento com new Boolean(false)
	            super.obrigatorias.remove(classAtividade);
	            super.obrigatorias.put(classAtividade, new Boolean(false));
	        }
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaUserStories.class || classAtividade == PraticaListaDeRequisitos.class
	            || classAtividade == PraticaDocumentacaoDetalhada.class ){
	        super.outras.put(classAtividade, classAtividade);
	    }else if (classAtividade == PraticaProjetoGeral.class){
	        super.obrigatorias.remove(classAtividade);
	        super.obrigatorias.put(classAtividade, new Boolean(true));
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.EscritaDosTestesAntesDaImplementacao");
       }

}
