/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaExecucaoDosTestes extends Pratica {

	public PraticaExecucaoDosTestes(){
		super();
	}

	/* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		//entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaImplementacao.class
	    		|| classAtividade == PraticaEscritaDosTestesAntesDaImplementacao.class){
	        //caso esteja selecionada lana um exceo
	    	if (super.isSelecionada()){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaExecucaoDosTestes.class);
	        }else{
	            super.obrigatorias.remove(classAtividade);
	            super.obrigatorias.put(classAtividade, new Boolean(false));
	        }
	    }else if (classAtividade == PraticaUserStories.class
	    		|| classAtividade == PraticaListaDeRequisitos.class
				|| classAtividade == PraticaDocumentacaoDetalhada.class
				|| classAtividade == PraticaIntegracaoParalela.class
				|| classAtividade == PraticaIntegracaoAntesDaValidacao.class){
	    	if (super.isSelecionada() && super.outras.size() == 1){
	    		throw new ExceptionExclusaoPraticaNaoPermitida(PraticaExecucaoDosTestes.class);
	    	}else{
	    		super.outras.remove(classAtividade);
	    	}

	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaImplementacao.class
	    		|| classAtividade == PraticaEscritaDosTestesAntesDaImplementacao.class){
	    	super.obrigatorias.remove(classAtividade);
	    	super.obrigatorias.put(classAtividade, new Boolean(true));
	    }else if (classAtividade == PraticaUserStories.class
	    		|| classAtividade == PraticaListaDeRequisitos.class
				|| classAtividade == PraticaDocumentacaoDetalhada.class
				|| classAtividade == PraticaIntegracaoParalela.class
				|| classAtividade == PraticaIntegracaoAntesDaValidacao.class){
	    	super.outras.put(classAtividade, classAtividade);
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.ExecicaoDosTestes");
       }

}
