/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Requisito;

/**
 * @author Thiago Leo Machado
 */
public class PraticaListaDeRequisitos extends Pratica {

	//lista de requisitos da atividade
	private ArrayList requisitos;

	public PraticaListaDeRequisitos(){
		super();
		//Como a atividade Lista de Requisitos no tem dependncias
		//ser colocado no outras a class da atividade
		//assim quando for selecionada no ter problema pois estar liberada
		super.outras.put(PraticaListaDeRequisitos.class, PraticaListaDeRequisitos.class);
		//Como a atividade lista de requisitos no tem dependncias
		//ser colocado no obrigatrias a class da atividade com Boolean true
		//assim quando for selecionada no ter problema este critrio estar ok
		super.obrigatorias.put(PraticaListaDeRequisitos.class, new Boolean(true));
		this.requisitos = new ArrayList();
	}

	public ArrayList getRequisitos() {
		return this.requisitos;
	}

	public void setRequisitos(ArrayList requisitos) {
		this.requisitos = requisitos;
	}

	public void addRequisito(Requisito requisito){
		this.requisitos.add(requisito);
	}

	public void removeRequisito(Requisito requsito){
		Iterator it = this.requisitos.iterator();
		Requisito r = null;
		while (it.hasNext()){
			r = (Requisito) it.next();
			if(requsito.getNome().equals(r.getNome())){
				it.remove();
				return;
			}
		}
	}


	/* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		//No precisa fazer nenhuma verificao, pois a atividade
		//Lista de Requisitos no depende de nenhuma outra atividade
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.ListaDeRequisitos");
       }

}
