/*
 * Created on 23/08/2005
 *
 */
package br.ufsc.fcama.logica.pratica;

import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.Constantes;

/**
 * @author Thiago Leo Machado
 */
public class PraticaOrganizacaoDaDocumentacao extends Pratica {



	public PraticaOrganizacaoDaDocumentacao(){
		super();
		//A atividade organizao da documentao tem dependncias mas no tem essa critrio ento
		//ser colocado no obrigatrias a class da ativida	de com Boolean true
		//assim quando for selecionada no ter problema este critrio estar ok
		super.obrigatorias.put(PraticaOrganizacaoDaDocumentacao.class, new Boolean(true));
	}


    /* (non-Javadoc)
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		// entra no if se operacao = EXCLUSAO
	    if (Constantes.EXCLUSAO.equalsIgnoreCase(operacao)){
		    //faz as verificaes para as dependncias  no caso da excluso
	        this.confereDependenciaExclusao(classAtividade);
		}else{//entra no else se operacao = INCLUSAO
		    //faz a verificao para as dependncias no caso da incluso
		    this.confereDependenciaInclusao(classAtividade);
		}
	}

	private void confereDependenciaExclusao(Class classAtividade)throws ExceptionExclusaoPraticaNaoPermitida{
	    //Confere se  uma das atividades que tem  dependncia
	    if (classAtividade == PraticaUserStories.class || classAtividade == PraticaListaDeRequisitos.class
	            || classAtividade == PraticaDocumentacaoDetalhada.class ){
	        //caso seja dependente e o hash outras esteja com tamanho 1 e a atividade est selecionada
	        //lana uma exception
	        if (super.isSelecionada() && super.outras.size() == 1){
	            throw new ExceptionExclusaoPraticaNaoPermitida(PraticaOrganizacaoDaDocumentacao.class);
	        }else{
	         //caso contrario apenas remove a atividade da lista das liberaes
	            super.outras.remove(classAtividade);
	        }
	    }
	}

	private void confereDependenciaInclusao(Class classAtividade)throws ExceptionInclusaoPraticaNaoPermitida{
	    if (classAtividade == PraticaUserStories.class || classAtividade == PraticaListaDeRequisitos.class
	            || classAtividade == PraticaDocumentacaoDetalhada.class ){
	        super.outras.put(classAtividade, classAtividade);
	    }
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.OrganizacaoDaDocumentacao");
       }



}
