/*
 * Created on 23/08/2005
 */
package br.ufsc.fcama.logica.pratica;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.PropertyResourceBundle;

import br.ufsc.fcama.exception.ExceptionExclusaoPraticaNaoPermitida;
import br.ufsc.fcama.exception.ExceptionInclusaoPraticaNaoPermitida;
import br.ufsc.fcama.logica.objAux.UserStory;

/**
 * @author Thiago Leo Machado
 */
public class PraticaUserStories extends Pratica {

	//lista de UserStory
	private ArrayList userStories;

	public PraticaUserStories(){
		super();
		//Como a atividade User Stories no tem dependncias
		//ser colocado no outras a class da atividade
		//assim quando for selecionada no ter problema este criterio estar ok
		super.outras.put(PraticaUserStories.class,PraticaUserStories.class);
		//Como a atividade user Stories no tem dependncias
		//ser colocado no obrigatrias a class da atividade com Boolean true
		//assim quando for selecionada no ter problema este critrio estar ok
		super.obrigatorias.put(PraticaUserStories.class, new Boolean(true));

		this.userStories = new ArrayList();
	}

	public ArrayList getUserStories() {
		return userStories;
	}

	public void setUserStories(ArrayList userStories) {
		this.userStories = userStories;
	}

	public void addUserStory(UserStory userStory){
		this.userStories.add(userStory);
	}

	public void removeUserStory(UserStory userStory){
		Iterator it = this.userStories.iterator();
		UserStory us = null;
		while(it.hasNext()){
			us = (UserStory)it.next();
			if (userStory.getNome().equals(us.getNome())){
				it.remove();
				return;
			}
		}
	}

	/*
	 * @see br.ufsc.fcama.atividade.Atividade#confereDependencia(java.lang.Class, java.lang.String)
	 */
	public void confereDependencia(Class classAtividade, String operacao) throws ExceptionInclusaoPraticaNaoPermitida, ExceptionExclusaoPraticaNaoPermitida {
		//No precisa fazer nenhuma verificao, pois a atividade
		//User Stories no depende de nenhuma outra atividade
	}

        public String toString(){
        	return PropertyResourceBundle
    		.getBundle("br.ufsc.fcama.internacionalizacao.ProgramProperties")
    			.getString("br.ufsc.fcama.logica.pratica.UserStories");
       }



}
